
// Tss tiedostossa on toteutettu luokka Kohdetiedosto.

package datanhallinta;

import java.io.*;


/**Kohdetiedosto perii luokan Tiedosto. Kohdetiedosto voi olla	
*konstruointitavasta riippuen joko "standard output" tai nimetty tiedosto.
*Luokka tarjoaa palvelut perustyyppej olevien muuttujien kirjoittamiseen
*tiedostoon.
*/
public class  Kohdetiedosto extends Tiedosto
{
/*--- KONSTRUKTORIT ---*/	
	
/**Konstruktori luo olion, joka kirjoittaa standard output -vuohon.
*/
	public Kohdetiedosto() throws IOException
	{	
		tulostetiedosto = 
			new PWF(System.out);
	}
	
/**Konstruktori luo olion, joka kirjoittaa tiedostoon. Parametrina 
*annetaan tiedoston nimi.
*/
	public Kohdetiedosto(String nimi) throws IOException
	{
		super(nimi);
		
		//System.out.println("Luodaan kohdetiedosto "+nimi);
		
		tulostetiedosto= 
			new PrintWriter(new FileOutputStream(nimi));
	
		//System.out.println("Kohdetiedosto luotu");
		
	}
	
/*--- PUBLIC-METODIT ---*/	
	
	
/**Metodi sulkee tiedoston.
*/
	public void sulje() throws IOException
	{ tulostetiedosto.close();}
	
/*Seuraavat metodit kirjoittavat char, int, double tai String 
*-tyyppisen muuttujan tiedostoon.
*/
	public void kirjoitaMerkki(char merkki) throws IOException
	{ tulostetiedosto.print(""+merkki);}
	public void kirjoitaArvo(int luku) throws IOException
	{ tulostetiedosto.print(""+luku);}
	public void kirjoitaArvo(float luku) throws IOException
	{ tulostetiedosto.print(""+luku);}
	public void kirjoitaArvo(double luku) throws IOException
	{ tulostetiedosto.print(""+luku);}
	public void kirjoitaMerkkijono(String mjono) throws IOException
	{ tulostetiedosto.print(mjono);}
	
/**Seuraavat metodit kuormittavat rajapinnan kirjoita().Parametri
*kirjoitetaan tiedostoon, ei tehd rivinvaihtoa.
*/
	public void kirjoita(char merkki) throws IOException
	{ tulostetiedosto.print(""+merkki);}
	public void kirjoita(int luku) throws IOException
	{ tulostetiedosto.print(""+luku);}
	public void kirjoita(float luku) throws IOException
	{ tulostetiedosto.print(""+luku);}
	public void kirjoita(double luku) throws IOException
	{ tulostetiedosto.print(""+luku);}
	public void kirjoita(String mjono) throws IOException
	{ tulostetiedosto.print(mjono);}
	
/**Seuraavat metodit kuormittavat rajapinnan kirjoitaRivi(). Parametri
*kirjoitetaan tiedostoon ja listn rivinvaihto.
*/
	public void kirjoitaRivi(char merkki) throws IOException
	{ tulostetiedosto.println(""+merkki);}
	public void kirjoitaRivi(int luku) throws IOException
	{ tulostetiedosto.println(""+luku);}
	public void kirjoitaRivi(float luku) throws IOException
	{ tulostetiedosto.println(""+luku);}
	public void kirjoitaRivi(double luku) throws IOException
	{ tulostetiedosto.println(""+luku);}
	public void kirjoitaRivi(String mjono) throws IOException
	{ tulostetiedosto.println(mjono);}
	
	
/*--- PROTECTED-METODIT ---*/
/* Metodi sulkee tiedoston.
*/
	protected void finalize() throws IOException, Throwable
	{ 
		sulje(); 
		super.finalize();
	}
	
	
/*--- PRIVATE-TIETORAKENTEET ---*/
	
/*PWF on peritty luokasta PrintWriter. Metodit print ja println on
*kirjoitettu uudelleen niin, ett suoritetaan aina flush -operaatio.
*Tt tarvitaan, jotta standard out:iin kirjoitettaessa ei
*puskuroitaisi.
*/
	class PWF extends PrintWriter
	{
		public PWF(OutputStream s){super(s);}
		public void print(String s){super.print(s);flush();}	
		public void println(String s){super.println(s);flush();}
	}
	
	private PrintWriter tulostetiedosto;
	
/*--- MAIN-METODI ---*/
/*Main-metodissa testataan luokan palveluja.
*/
	public static void main(String args[]) throws IOException
	{
		System.out.println("Kokeillaan luoda tiedosto 'testi' ja kirjoitetaan"
		+ " sinne ");
		
		Kohdetiedosto tied= new Kohdetiedosto("testi");
		tied.kirjoitaRivi("Tm on tiedostossa.");
		tied.kirjoitaMerkki('a');
		tied.kirjoitaMerkki('\n');
		tied.kirjoitaArvo(123);
		tied.kirjoitaArvo(12.34);
		tied.kirjoitaRivi("loppu.");
		
		
		tied.sulje();
		
		System.out.println("Yritetn sitten kirjoittaa standard outtiin.");
		Kohdetiedosto naytto= new Kohdetiedosto();
		naytto.kirjoitaRivi("Tm nkyy nytll.");
		naytto.kirjoitaRivi('a');
		naytto.kirjoitaRivi("\n");
		naytto.kirjoitaRivi('\n');
		naytto.kirjoitaRivi(123);
		naytto.kirjoitaRivi(12.34);
		naytto.kirjoitaRivi("loppu.");
		naytto.kirjoitaRivi("loppu2.");
		
		
		Lahdetiedosto nappis=new Lahdetiedosto();
		naytto.kirjoitaRivi("naytto.kirjoita: "+nappis.lueRivi());
		
		naytto.sulje();
		
		nappis.sulje();
		
	}//main

}


