
// Tm tiedosto sislt luokan Lahdetiedosto toteutuksen.

package datanhallinta;

import java.io.*;

/**Lahdetiedosto perii luokan Tiedosto. Luokka tarjoaa metodit tiedostosta
*lukemiseen merkki, sana tai rivi kerrallaan.
*/
public class Lahdetiedosto extends Tiedosto
{
	
/*---KONSTRUKTORIT ---*/	

/**Konstruktori luo luokan Lahdetiedosto ilmentymn, joka voi lukea
*standard input:sta.
*/
	public Lahdetiedosto() throws IOException
	{				
		syotetiedosto = 
			new BufferedReader(new InputStreamReader(System.in));	
	}
	
/**Konstruktori luo luokan Lahdetiedosto ilmentymn, joka voi lukea
*parametrina annettavasta tiedostosta.
*/
	public Lahdetiedosto(String nimi) throws IOException
	{
		super(nimi);
		syotetiedosto= 
			new BufferedReader(new InputStreamReader(new FileInputStream(nimi)));
	}
	
/*--- PUBLIC-METODIT ---*/	
		
/**Sulkee  tiedoston.
*/
	public void sulje() throws IOException
	{ 
		System.out.println("Lahdetiedosto.sulje: begin");
		syotetiedosto.close();
		System.out.println("Lahdetiedosto.sulje: end");
	}
	
/**Palauttaa tiedoston seuraavan merkin.
*/
	public int lueMerkki() throws IOException
	{	
		//tarkista();
		return syotetiedosto.read();
	}
	
/** Palauttaa tiedoston seuraavan sanan. Sanat oletetaan erotetuiksi jollain
*javan 'whitespace'-merkill.
*/
	public String lueSana() throws IOException
	{
		//tarkista();
		StringBuffer s=new StringBuffer();
		int i;
		
		while(((i=syotetiedosto.read())>=0)
		&&(Character.isWhitespace((char)i)));
		if (i<0) return null;
		while(((i=syotetiedosto.read())>=0)
		&&(!Character.isWhitespace((char)i)))
			s.append((char)i);
		
		
		return s.toString();	
	}
	
/**Palauttaa merkkijonon, joka on juuri ennen rivinvaihtoa. Palauttaa
*null:n, jos tiedostosta ei voida lukea.
*/
	public String lueRivi() //throws IOException
	{	
		tarkista();	
		try
		{
			return syotetiedosto.readLine();	
		}
		catch (IOException e)
		{
			return null;
		}
	}
	
	
/**Palauttaa tiedoston seuraavan merkkijonon, joka pttyy parametrina
*annettavaan merkkiin. Palauttaa null:n, jos tiedostosta ei voida lukea.
*/
	public String lueRivi(char rivinLopetusmerkki) //throws IOException
	{		
		if (rivinLopetusmerkki=='\n') return lueRivi();
		tarkista();
		StringBuffer s=new StringBuffer();
		int i;
		try
		{
			while(((i=syotetiedosto.read())>=0)
			&&((char)i!=rivinLopetusmerkki))
				s.append((char)i);	
			if (i<0) return null;
		}
		catch (IOException e)
		{
			return null;
		}
		
		return s.toString();	
	}
	
	
/*--- PROTECTED-METODIT ---*/

/*Kutsuu yliluokan finalize-metodia.
*/
	protected void finalize() throws IOException, Throwable
	{ super.finalize();}
	
	
/*--- PRIVATE-METODIT ---*/

/*Huolehtii odottamisesta, jos luettavaa ei ole.
*/
	private void tarkista()
	{
	  if (standardivuo)
		try
		{
			while (!syotetiedosto.ready())
				Thread.currentThread().sleep(100);
		}
		catch (InterruptedException e)
		{ System.out.println("Lahdetiedosto.tarkista 1: VIRHE");}
		catch (IOException e)
		{ System.out.println("Lahdetiedosto.tarkista 2: VIRHE"); }
		
	}
	
/*--- PRIVATE-TIETORAKENTEET ---*/
	
	private BufferedReader syotetiedosto;

/*--- MAIN-METODI ---*/
/*
*/
	public static void main(String args[]) throws IOException
	{
		Lahdetiedosto nappis=new Lahdetiedosto();
		
		String s;
		boolean onnistui=false;
		Kohdetiedosto naytto=new Kohdetiedosto();

		
		while (!onnistui)
		{
			naytto.kirjoitaRivi("Anna tiedoston nimi:");
			s=nappis.lueRivi();
			try 
			{
				Lahdetiedosto tied=new Lahdetiedosto(s);
				
				String t=tied.lueRivi();
				System.out.println(t);
				tied.sulje();
				onnistui=true;	
			}
			catch (IOException e)
			{
				System.out.println("Tiedostoa '"+s+"' ei lytynyt.");
				
			}
		}	
	}
}
