
// Tss tiedostossa on luokan OtsikonHallinta toteutus.

package datanhallinta;

import java.io.*;

/**Otsikonhallinta tarjoaa palvelut otsikkotietojen lukemiseen 
*lhdetiedostosta, kirjoittamiseen kohdetiedostoon sek huolehtii
*otsikkotietojen silytyksest. 
*/
class OtsikonHallinta
{
/*--- KONSTRUKTORIT ---*/

/**Luo Otsikonhallinta-olion. Saa parametrina Lahdetiedoston.
*/
	public OtsikonHallinta(Lahdetiedosto datalahde)
	{ this.datalahde=datalahde;}	


/*--- PUBLIC-METODIT ---*/
	
/*Seuraavat metodit palauttavat sytedataan liittyv otsaketietoa.
*/
	public int annaKenttienLkm()
	{ return otsikot.length; }
	
	public String annaKentanNimi(int kentanNro)
	{ return otsikot[kentanNro].nimi; }
	
	public boolean onFunktio(int kentanNro)
	{ return otsikot[kentanNro].onFunktio; }
	
	public String annaXnimi(int kentanNro)
	{ return otsikot[kentanNro].Xnimi; }
	
	public float annaAlaraja(int kentanNro)
	{ return otsikot[kentanNro].alaraja; }
	
	public float annaYlaraja(int kentanNro)
	{ return otsikot[kentanNro].ylaraja; }
	
	public char annaTietueidenErotin()
	{ return tietueidenErotin; }
	
	public char annaKenttienErotin()
	{ return kenttienErotin; }
	
	
/**Metodi lukee otsikkotiedot lahdetiedostosta ja tallettaa tiedot 
*tietorakenteisiinsa.
*/
	public void lueOtsikot() throws Exception 
	{
		//System.out.println("OtsikonHallinta.lueOtsikot: Begin");
		String r;
		int tila=1; 
		StringBuffer sb=new StringBuffer();
		while ((tila>0)&&((r=datalahde.lueRivi())!=null))
		{
			//System.out.println("OtsikonHallinta.lueOtsikot: rivi='"+r+"'");
			for (int i=0;(tila>0)&&(i<r.length());i++)
			{
				char c=r.charAt(i);
				//System.out.println("lueOtsikot: c='"+c+"'");
				if (c=='>')
					tila=valitseTila(tila,sb);
				else if (c=='<')
					tila=kasitteleLohko(tila,sb);
				else if (c!='#')
					sb.append(c);
			}
		}
		if (tila!=0)
			throw new Exception();	
		//System.out.println("OtsikonHallinta.lueOtsikot: End");
	}// lueOtsikot
	
	
/**Metodin kirjoittaa otsikkotiedot parametrina annettavaan kohdetiedostoon.
*Toisen ja kolmantena parametrina annetaan karsintatiedot suhteessa
*alkuperiseen dataan. 
*/
	public void kirjoitaOtsikko(Kohdetiedosto kohde, int absKarsittuAlusta, int
		absKarsintaAskel, int[] kenttienNro)
	throws IOException
	{
		kohde.kirjoitaRivi("# <"+lohkot[0]+">");
		
		kohde.kirjoita("# <"+lohkot[2]+"> ");
		boolean[] apu=new boolean[otsikot.length];
		for(int k=0;k<apu.length;k++)
			apu[k]=false;
		for(int k=0;k<kenttienNro.length;k++)
			apu[kenttienNro[k]]=true;
		for(int k=0;k<apu.length;k++)
			if (!apu[k])
				kohde.kirjoita(otsikot[k].kokoNimi+" ");
		kohde.kirjoitaRivi("<"+lohkot[3]+">");
		
		kohde.kirjoita("# <"+lohkot[4]+"> ");
		kohde.kirjoita("'"+erottimestaMjono(tietueidenErotin)+"'");
		kohde.kirjoitaRivi(" <"+lohkot[5]+">");
		
		kohde.kirjoita("# <"+lohkot[6]+"> ");
		kohde.kirjoita("'"+erottimestaMjono(kenttienErotin)+"'");
		kohde.kirjoitaRivi(" <"+lohkot[7]+">");
		
		kohde.kirjoita("# <"+lohkot[8]+"> ");
		kohde.kirjoita(absKarsittuAlusta);
		kohde.kirjoitaRivi(" <"+lohkot[9]+">");
		
		kohde.kirjoita("# <"+lohkot[10]+"> ");
		kohde.kirjoita(absKarsintaAskel);
		kohde.kirjoitaRivi(" <"+lohkot[11]+">");
		
		kohde.kirjoitaRivi("# <"+lohkot[1]+">");	
	}
	
/*--- PRIVATE-METODIT ---*/
	
/*Valitsee tilakoneen tilan.
*/
	private int valitseTila(int tila, StringBuffer sb)
	{
		String s=sb.toString();
		//					h/h a/a r/r f/f k/k K/K
		int[] tilasiirtyma={2,0,3,2,4,2,5,2,2,2,2,2};
		int[][] tilasiirtoOk=
		{{0,0,0,0,0,0},{0,1,1,0,0,0},{1,1,1,1,1,1},
		 {0,0,1,0,0,0},{0,0,1,0,0,0},{0,0,1,0,0,0}};
		 					
		int t=-1;
		for (int i=0;i<lohkot.length;i++)
			if (s.equals(lohkot[i]))
				t=tilasiirtyma[i];
		sb.setLength(0);
		//System.out.println("valitseTila: s='"+s+"' tila="+tila+" t="+t);
		if ((t>=0)&&(tilasiirtoOk[tila][t]==1));
		else t=-1;
		
		return t;
	}// valitseTila2
	
/*Ksittelee otsikon lohkon.
*/
	private int kasitteleLohko(int tila, StringBuffer sb)
	{
		String s=sb.toString();
		int t=0;
		switch (tila)
		{
		case 1: t=tila; break;
		case 2: t=tila; break;
		case 3: t=asetaKentat(tila,s);break;
		case 4: t=asetaTietueidenErotin(tila,s);break;
		case 5: t=asetaKenttienErotin(tila,s);break;
		}		
		sb.setLength(0);
		return t;
	}// kasitteleLohko2
	
/*Jsent parametrina annettavan merkkijonon, kun merkkijono 
*sislt kenttien tiedot.
*/
	private int asetaKentat(int tila, String s)
	{
		int MAX=16*1024;
		// Kertn kentt taulukkoon
		StringBuffer[] kentat=new StringBuffer[MAX];
		boolean[] onFunktio=new boolean[MAX];
		int kenttia=0;
		int sulkutila=1;
		int j=0;
		
		while (Character.isWhitespace(s.charAt(j))&&(j<s.length()))j++;
		s+=' ';
		char exc=' ';
		kentat[0]=new StringBuffer(); onFunktio[0]=false;
		for (int i=j;(sulkutila>0)&&(i<s.length());i++)
		{
			char c=s.charAt(i);
			switch (sulkutila)
			{
			case 1: // sulkujen ulkopuolella
				if (c=='(') 
				{ 
					sulkutila=2; 
					kentat[kenttia].append(c); 
				}
				else if (Character.isWhitespace(c)) 
				{	
					if (!Character.isWhitespace(exc)) 
					{	
						kentat[++kenttia]=new StringBuffer(); 
						onFunktio[kenttia]=false;
					}
				}
				else kentat[kenttia].append(c);
				break;
			case 2: // sulkujen sisll
				if (c==')') 
				{
					sulkutila=1; 
					onFunktio[kenttia]=true;
				}	
				kentat[kenttia].append(c);
				break;
			}
			exc=c;	
		}		
		// asetetaan kentat otsikko-taulukkoon
		otsikot=new Otsikko[kenttia];
		for (int i=0;i<kenttia;i++)
		{
			otsikot[i]=new Otsikko();
			try
			{ otsikot[i].aseta(kentat[i].toString(),onFunktio[i]);}
			catch (Exception e)
			{ tila=-1; }
		}
		return tila;
	}// asetaKentat2
	
/*
*/
	private int asetaTietueidenErotin(int tila, String s)
	{
		//System.out.println("OtsikonHallinta.asetaTietueidenErotin: s='"+
		//	s+"'");
		int e=etsiErotin(s);
		if (e<0) return -1;
		tietueidenErotin=(char)e;
		return tila; 
	}
/*
*/
	private int asetaKenttienErotin(int tila, String s)
	{
		//System.out.println("OtsikonHallinta.asetaKenttienErotin: s='"
		//	+s+"'");
		int e=etsiErotin(s);
		if (e<0) return -1;
		kenttienErotin=(char)e;
		return tila; 
	}
	
	
/*Metodi etsii erotinmerkin parametrin merkkijonon.
*/
	private int etsiErotin(String s)
	{
		StringBuffer e=new StringBuffer();
		int erotin;
		int i=0,n=s.length();
		while ((i<n)&&(s.charAt(i)!='\'')) i++;
		while ((++i<n)&&(s.charAt(i)!='\'')) e.append(s.charAt(i));
		if (i>=n) return -1;
		//System.out.println("etsiErotin2: e='"+e+"'");
		switch (e.length())
		{
		case 1:
			erotin=e.charAt(0);
			break;
		case 2:
			if (e.charAt(0)=='\\')
				if (e.charAt(1)=='n') 
				{
					erotin='\n';
					break;
				}
		default:
			erotin=-1;
		}
		return erotin;	
	}// etsiErotin2
	
/*Muuttaa erotinmerkin merkkijonoksi.
*/
	private String erottimestaMjono(char erotin)
	{
		if (erotin=='\n')
			return "\\n";
		else
			return ""+erotin;
	}
	
/*--- PRIVATE-TIETORAKENTEET ---*/
	
	private static final String[] lohkot=
		{"header","/header","attributes","/attributes",
		"record separator","/record separator", 
		"field separator","/field separator",
		"skipped","/skipped",
		"included","/included"}; 
	
	private class Otsikko
	{
		protected Otsikko()
		{ nimi=Xnimi=null; onFunktio=false; alaraja=ylaraja=Float.NaN; }
		protected void aseta(String mjono, boolean onFunktio) throws Exception
		{
			this.onFunktio=onFunktio;
			this.kokoNimi=mjono;
			if (onFunktio)
				asetaFunktioTiedot(mjono);			
			else
				nimi=mjono;
		}
		private void asetaFunktioTiedot(String mjono) throws Exception
		{
			//System.out.println("asetaFunktioTiedot: mjono='"+mjono+"'");
			int i=0,n=mjono.length();
			while ((i<n)&&(mjono.charAt(i)!='(')) i++;
			if (i>=n) throw new Exception();
			nimi=mjono.substring(0,i);
		
			int tila=1;
			StringBuffer sb=new StringBuffer();
			while ((++i<n)&&(tila>0))
			{
				char c=mjono.charAt(i);
				switch (tila)
				{
				case 1:
					if (c==')')
					{
						if (sb.length()>0) Xnimi=sb.toString();
						tila=0;
					}
					else if (c=='[')
					{
						if (sb.length()>0) Xnimi=sb.toString();
						sb.setLength(0);
						tila=2;
					}
					else if (!Character.isWhitespace(c))
						sb.append(c);
					break;
				case 2:
					if (c==']')
						tila=-1;
					else if ((Character.isWhitespace(c))||(c==','))
					{
						alaraja=Float.valueOf(sb.toString()).floatValue();
						sb.setLength(0);
						tila=3;
					}
					else 
						sb.append(c);
					break;
				case 3:
					if (c==']')
					{
						ylaraja=Float.valueOf(sb.toString()).floatValue();
						sb.setLength(0);
						tila=1;
					}
					else if (!Character.isWhitespace(c))
						sb.append(c);
				}
			
			}
			if (tila!=0) throw new Exception();	 	
		}// asetaFunktioTiedot
		
		protected String nimi, Xnimi, kokoNimi;
		protected boolean onFunktio;
		protected float alaraja, ylaraja;
	}
	
	private Otsikko[] otsikot={};
	private char tietueidenErotin='\n';
	private char kenttienErotin=' ';
	private Lahdetiedosto datalahde=null;
}

