
// Tm tiedosto sislt luokan Tiedosto toteutuksen.

package datanhallinta;

import java.io.*;

/**Tiedosto on abstrakti luokka, joka tarjoaa tll hetkell ainoastaan
*konstruktorit ja sulje-metodin sek tiedostonnimen silyttmisen ja 
*palauttamisen, mutta mahdollistaa tiedostoille yhteisten toimintojen
*toteuttamisen yhdess paikassa.
*/
abstract class Tiedosto 
{
/**Konstruktori. Asettaa nimeksi "(standarad)" mikli tiedoston nime
*ei ole annettu parametrina.
*/
	public Tiedosto() throws IOException
	{
		standardivuo=true;
		tiedostonNimi="(Standard)";
	}
	
/**Konstruktori. Tiedoston nimi annetaan parametrina.
*/
	public Tiedosto(String nimi) throws IOException
	{
		standardivuo=false;
		tiedostonNimi=nimi;
	}
	
/**Sulkee tiedoston.
*/
	public abstract void sulje() throws IOException;

/**Palauttaa tiedoston nimen.
*/		
	public String annaNimi()
	{ return tiedostonNimi; }
	
	
	protected String tiedostonNimi="";
	protected boolean standardivuo;
}
