
// Tss tiedostossa on luokan Tiedostosuodatin toteutus.

package datanhallinta;

import java.io.*;

/**Tiedostosuodatin perii luokan Suodatin. Tiedostosuodatin tarjoaa 
*metodit kohdetiedoston sulkemiseen ja rivin lismiseen tiedostoon
*/
class Tiedostosuodatin extends Suodatin
{
	
/*--- KONSTRUKTORIT ---*/
	
/** Alustaa tietorakenteet. Parametrina annetaan sen tiedostonNimi, johon
*kirjoitetaan sek viite Otsikonhallinta-luokan olioon. Otsikonhallinta-olio
*tiet kenttien lukumrn erotinmerkit jne.
*/
	public Tiedostosuodatin(String tiedostonNimi,OtsikonHallinta ots) 
	throws IOException
	{		
		super(ots);
		int kenttienLkm=ots.annaKenttienLkm();
		kohdetiedosto=new Kohdetiedosto(tiedostonNimi);
		
		if (kenttienLkm!=kenttaKarsittu.length)
		{ System.out.println("VIRHE"); }
	}// Tiedostosuodatin
	
	
	
/*--- PUBLIC-METODIT ---*/
	
/**Sulkee tiedoston johon ollaan kirjoittamassa.
*/
	public void sulje() throws IOException
	{
		if (kohdetiedosto!=null)
			kohdetiedosto.sulje();	
	}
	
/**Palauttaa true joss parametrina annettu kentt on talletettu tiedostoon
*eli sit ei ole karsittu.
*/
	public boolean onTiedostossa(int kentanNro)
	{ return !kenttaKarsittu[kentanNro]; }
	
/**Palauttaa tiedoston, johon ollaan kirjoittamassa.
*/
	public Kohdetiedosto annaKohdetiedosto()
	{ return kohdetiedosto; }
	
	
/*--- PROTECTED-METODIT ---*/
	
/*Finalize-metodi
*/
	protected void finalize() throws Throwable
	{ super.finalize();}
	
/**Lis parametrina annettavat kentt tiedostoon.
*/
	protected void lisaaKentat(String[] kentat) 
	throws IOException
	{	
		for (int i=0;i<kentat.length;i++)
			if (!kenttaKarsittu[i])
			{
				//System.out.println(kentat[i]);
				kohdetiedosto.kirjoita(
					kentat[i]+kenttienErotin);
		
			}
		kohdetiedosto.kirjoita(tietueidenErotin);
		rivienLkm++;	
	}
	
/*Metodi kenttien poistamiseen. Metodi ei tee mitn.
*/
	protected void poistaKentat(int[] kenttienNro){}
	
/*Metodi rivien poistamiseen. Metodi ei tee mitn.
*/
	protected void tiivistaRivit(int alustaPoisSuht, int riviaskelSuht){}
	
	
	
/*--- PRIVATE-TIETORAKENTEET ---*/
	
	
	private Kohdetiedosto kohdetiedosto=null;
	
	
/*--- MAIN-METODI ---*/
	
	public static void main(String[] args)
	{
		System.out.println("Tiedostosuodatin.main: Begin");
		
		System.out.println("Tiedostosuodatin.main: End");
	}
	
	
}// class Tiedostosuodatin
