/** 	Kaaviopakkaus
	versio 1.0
	23.3.1998
    	
    	

*/

package kaavio;
import java.awt.*;
import laskenta.*;

/** AutokorrelaationPiirto sislt yhden muuttujan autokorrelaation seurannan 
kuvaamiseen tarvittavat metodit. Se on Piirto-luokan aliluokka.
*/

public class AutokorrelaationPiirto extends Piirto 
{
	/** Konstruktori ottaa parametrina graphics olion, joka osoittaa valmiiksi
		kanvaasille */
	public AutokorrelaationPiirto(Graphics graphics, Autokorrelaatiolaskenta
		laskenta, int alusta1, int askel1) 
	{
		this.g=graphics;
		leveys=544;
		korkeus=266;
		alarajaX=0;
		alarajaY=0;
		ylarajaX=1;
		ylarajaY=1;
		syvyys=50;
		alustaKontrolli=alusta1;
		askelKontrolli=askel1;
		this.laskenta= laskenta;
	}	
	/** Katso Piirto -luokasta */
	public void piirraUudelleen(int riveja, boolean lasketaan) 
	{
		float skaalausX, skaalausY;
		int uusiY, uusiX;
		
		dhRiveja=riveja;
		syvyys=laskenta.annaSyvyys();
		piirretaan=true;
		if (lasketaan) laskenta.laskeUudelleen(riveja);
		if (automX&&lasketaan)
		{
			alarajaX=0;
			ylarajaX=syvyys*askel+1;
		}
		if (automY&&lasketaan) 
		{
	/* autokorrelaatio aina [-1,1] */
			alarajaY=-1;
			ylarajaY=1;
		}			

		piirraAkselit();
		skaalausX=skaalaa(alarajaX, ylarajaX,askel);
		skaalausY=skaalaa(alarajaY, ylarajaY,
			laskenta.annaAutokorrelaatio(1));
		x=vasenTila+(int)(skaalausX*(leveys-(vasenTila+oikeaTila)));
		y=korkeus-alaTila-(int)(skaalausY*(korkeus-(alaTila+ylaTila)));

		for (int i=2; i<=syvyys; i++)
		{
			skaalausX=skaalaa(alarajaX, ylarajaX,i*askel);
			skaalausY=skaalaa(alarajaY, ylarajaY,
			laskenta.annaAutokorrelaatio(i));
			uusiX=vasenTila+(int)(skaalausX*(leveys-(vasenTila+oikeaTila)));
			uusiY=korkeus-alaTila-(int)(skaalausY*(korkeus-(alaTila+ylaTila)));
			if (!new Float(laskenta.annaAutokorrelaatio(i)).isNaN())
			{
				if (piirretaan) piirraViiva(x,y,uusiX,uusiY,Color.black);
			}
			else 	/* jos ei ole arvoa, niin poistutaan silmukasta */
			{
				i=syvyys;
			}
			 /* jos x arvot ulkona ruudulta, niin ei en piirret */
			if (skaalausX>100) piirretaan=false; 
			x=uusiX;
			y=uusiY;
		}

	}

	/** Katso Piirto -luokasta */
	public void piirraLisaykset(int lkm) 
	{
		float skaalausX, skaalausY;
		int uusiY, uusiX; 

		dhRiveja+=lkm;
		piirretaan=true;
		laskenta.laskeLisays(lkm);
		tyhjennaPiirtoalue();

		skaalausX=skaalaa(alarajaX, ylarajaX,askel);
		skaalausY=skaalaa(alarajaY, ylarajaY,
			laskenta.annaAutokorrelaatio(1));
		x=vasenTila+(int)(skaalausX*(leveys-(vasenTila+oikeaTila)));
		y=korkeus-alaTila-(int)(skaalausY*(korkeus-(alaTila+ylaTila)));

		for (int i=2; i<=syvyys; i++)
		{
			skaalausX=skaalaa(alarajaX, ylarajaX,i*askel);
			skaalausY=skaalaa(alarajaY, ylarajaY,
			laskenta.annaAutokorrelaatio(i));
			uusiX=vasenTila+(int)(skaalausX*(leveys-(vasenTila+oikeaTila)));
			uusiY=korkeus-alaTila-(int)(skaalausY*(korkeus-(alaTila+ylaTila)));
			if (!new Float(laskenta.annaAutokorrelaatio(i)).isNaN())
			{
				if (piirretaan) piirraViiva(x,y,uusiX,uusiY,Color.black);
			}
			else 	/* jos ei ole arvoa, niin poistutaan silmukasta */
			{
				i=syvyys;
			}
			 /* jos x arvot ulkona ruudulta, niin ei en piirret */
			if (skaalausX>100) piirretaan=false; 
			x=uusiX;
			y=uusiY;
		}

	}
	/** Metodilla asetetaan kontrollissa tehty datan karsinta */
	public void asetaDatanKarsinta(int alusta1, int askel1)
	{
		alustaKontrolli=alusta1;
		askelKontrolli=askel1;
		laskeKarsinnat();
	}	
	/** Metodilla asetetaan kaaviossa tehty datan karsinta */
	public void asetaKaavionKarsinta(int alusta1, int askel1)
	{
		alustaKaavio=alusta1;
		askelKaavio=askel1;
		laskeKarsinnat();
	}
	/** metodi laskee kokonaiskarsinnat kontrollin ja kaavion karsinnoista */
	private void laskeKarsinnat()
	{
		alusta=alustaKontrolli+askelKontrolli*alustaKaavio;
		askel=askelKontrolli*askelKaavio;
	}
	/** Katso Piirto -luokasta, ei tee tss mitn, sill autokorrelaatio kyrn
	 keskiarvoa ei lasketa*/
	protected void piirraKa() {}

	private int alustaKaavio=0, askelKaavio=1;	// Kaavion karsinnat
	private int alustaKontrolli=0, askelKontrolli=1;	// Kontrollin karsinnat
	private int alusta=0, askel=1;	 	/* lasketut kokonaissiirtymt, jotta 
							voidaan merkit syvyys alkuperisten rivien mukaan */
	private Autokorrelaatiolaskenta laskenta;
	private int syvyys;
	private int x,y; /* Silyttvt edellisen piirretyn pisteen */
}
