/** 	Kaaviopakkaus    		
*/

package kaavio;
import java.awt.*;
import laskenta.*;


/** HistogrammiPiirto sislt histogrammin kuvaamiseen
tarvittavat metodit. Se on Piirto-luokan aliluokka.
*/

public class HistogrammiPiirto extends Piirto 
{
	/** Konstruktori ottaa parametrina graphics olion, joka osoittaa valmiiksi
		kanvaasille */
	public HistogrammiPiirto(Graphics graphics, Jakaumalaskenta laskenta) 
	{
		this.g=graphics;
		leveys=580;
		korkeus=266;
		alarajaX=0;
		alarajaY=0;
		ylarajaX=1;
		ylarajaY=10;
		pylvaidenLkm=100;
		this.laskenta= laskenta;
	}	

	private void piirraPylvas(int x, int y, int lev, int kork, Color vari) 
	{
		g.setColor(vari);
		g.fillRect(x,y,lev,kork);
	}
	
	/** Katso Piirto -luokasta */
	public void piirraUudelleen(int riveja, boolean lasketaan) 
	{
		int alakvantiili=0, ylakvantiili=0, mediaani=0;
		float skaalausX, skaalausY;
		int x,y,uusiX;
		Color vari;
		
		dhRiveja=riveja;
		if (automX&&lasketaan)
		{
			float ero;
		/* Turha laskenta, jotta saadaan minimi ja maximi */
			laskenta.asetaPylvaat(1,0,1);
			laskenta.laskeUudelleen(riveja);

			alarajaX=laskenta.annaMin();
			ylarajaX=laskenta.annaMax();
			ero=ylarajaX-alarajaX;
			alarajaX=laskenta.annaMin()-(0.02f*ero);
			ylarajaX=laskenta.annaMax()+(0.02f*ero);
			alarajaX=pyoristaFloat(alarajaX,5);
			ylarajaX=pyoristaFloat(ylarajaX,5);

			if (alarajaX==ylarajaX)
			{
				alarajaX-=1;
				ylarajaX+=1;
			}
			laskePylvaidenLkm();
			/* lasketaan uudelleen oikeilla arvoilla */
			laskenta.asetaPylvaat(pylvaidenLkm,alarajaX,ylarajaX);
			laskenta.laskeUudelleen(riveja);
		}
		if (!automX&&lasketaan)
		{
			laskePylvaidenLkm();
			laskenta.asetaPylvaat(pylvaidenLkm,alarajaX,ylarajaX);
			laskenta.laskeUudelleen(riveja);
		}			
		pylvaidenLkm=laskenta.annaLkm();
		if (automY&&lasketaan)
		{
			alarajaY=0;
			ylarajaY=laskenta.annaMaxKertyma()*1.05f;
			if (ylarajaY==0) ylarajaY=10;
		}
		piirraAkselit();
		skaalausX=skaalaa(alarajaX,ylarajaX,laskenta.annaX(0));
		x=vasenTila+(int)(skaalausX*(leveys-(vasenTila+oikeaTila)))+1;
		if (kvantiilit)
		{
			alakvantiili=laskenta.annaAlakvantiili();
			ylakvantiili=laskenta.annaYlakvantiili();
		}
		mediaani=laskenta.annaMediaani();

		for (int i=1; i<=pylvaidenLkm; i++)
		{
			vari=Color.black;  // oletus musta
			skaalausX=skaalaa(alarajaX,ylarajaX,laskenta.annaX(i));
			skaalausY=skaalaa(alarajaY,ylarajaY,laskenta.annaKertyma(i));
			uusiX=vasenTila+(int)(skaalausX*(leveys-(vasenTila+oikeaTila)));
			y=korkeus-alaTila-(int)(skaalausY*(korkeus-(alaTila+ylaTila)));
		/** jos kertym on mutta skaalauksen jlkeen ei mitn silti nkyisi,
		niin piirretn pikselin korkuinen pylvs (asiakkaiden toivomus) */	
			if (y==korkeus-alaTila&&skaalausY>0) y=korkeus-alaTila-1;
			if (kvantiilit)
			{
				if (i==ylakvantiili) vari=Color.lightGray;
				if (i==alakvantiili) vari=Color.lightGray;
			}
			if (i==mediaani) vari=Color.yellow;
				
			piirraPylvas(x,y,uusiX-x,korkeus-(alaTila+y)+2,vari);
			x=uusiX+1; /* Pylvisiin pikselin vlit */
		}		
		if (laskenta.rivejaKaytetty()>0) piirraKa();
	}

	/** Katso Piirto -luokasta */
	public void piirraLisaykset(int lkm) 
	{
		int alakvantiili=0, ylakvantiili=0, mediaani=0;
		float skaalausX, skaalausY;
		int x,y,uusiX;
		Color vari;
		
		laskenta.laskeLisays(lkm);
		dhRiveja+=lkm;
		if ((automY&&laskenta.annaMaxKertyma()>ylarajaY)||(automX&
			((laskenta.annaKertyma(0)>0)
			||(laskenta.annaKertyma(pylvaidenLkm+1)>0))))
		{
			float ero=ylarajaX-alarajaX;
			boolean xMuutettu=false;
			if (automY&&laskenta.annaMaxKertyma()>ylarajaY) 
				ylarajaY=laskenta.annaMaxKertyma()*2;
			if (automX&&laskenta.annaKertyma(0)>0)
			{
				alarajaX=laskenta.annaMin()-0.05f*ero;
				alarajaX=pyoristaFloat(alarajaX,5);
				xMuutettu=true;
			}
			if (automX&&laskenta.annaKertyma(pylvaidenLkm+1)>0)
			{
				ylarajaX=laskenta.annaMax()+0.05f*ero;
				ylarajaX=pyoristaFloat(ylarajaX,5);
				xMuutettu=true;			
			}
	
			if (xMuutettu)
			{
			/* joudutaan asettamaan pylvt uudelleen */
				if (alarajaX==ylarajaX)
				{
					alarajaX-=1;
					ylarajaX+=1;
				}
				laskePylvaidenLkm();
				laskenta.asetaPylvaat(pylvaidenLkm,alarajaX,ylarajaX);
				laskenta.laskeUudelleen(dhRiveja);					
			}
			piirraUudelleen(dhRiveja,false);
		}		

		skaalausX=skaalaa(alarajaX,ylarajaX,laskenta.annaX(0));
		x=vasenTila+(int)(skaalausX*(leveys-(vasenTila+oikeaTila)))+1;
		if (kvantiilit)
		{
			alakvantiili=laskenta.annaAlakvantiili();
			ylakvantiili=laskenta.annaYlakvantiili();
		}
		mediaani=laskenta.annaMediaani();
		
		for (int i=1; i<=pylvaidenLkm; i++)
		{
			vari=Color.black;  // oletus musta
			skaalausX=skaalaa(alarajaX,ylarajaX,laskenta.annaX(i));
			skaalausY=skaalaa(alarajaY,ylarajaY,laskenta.annaKertyma(i));
			uusiX=vasenTila+(int)(skaalausX*(leveys-(vasenTila+oikeaTila)));
			y=korkeus-alaTila-(int)(skaalausY*(korkeus-(alaTila+ylaTila)));
		/** jos kertym on mutta skaalauksen jlkeen ei mitn silti nkyisi,
		niin piirretn pikselin korkuinen pylvs (asiakkaiden toivomus) */	
			if (y==korkeus-alaTila&&skaalausY>0) y=korkeus-alaTila-1;
			if (kvantiilit)
			{
				if (i==ylakvantiili) vari=Color.lightGray;
				if (i==alakvantiili) vari=Color.lightGray;
			}
			if (i==mediaani) vari=Color.yellow;
				

			piirraPylvas(x,y,uusiX-x,korkeus-(alaTila+y)+2,vari);
			x=uusiX+1;
		}
		if (laskenta.rivejaKaytetty()>0) piirraKa();		
	}
	/** Asetetaan kvantiilit piirrettvksi tai ei */
	public void piirraKvantiilit(boolean piirretaan,float alaKvantiili, float
	ylaKvantiili)
	{
		kvantiilit=piirretaan;
		this.alaKvantiili=alaKvantiili;
		this.ylaKvantiili=ylaKvantiili;

	}
	/** laskee pylviden lukumrn leveydest, jos tarpeen */
	private void laskePylvaidenLkm()
	{
		if (pylvaanLeveys!=0)
		{
			pylvaidenLkm=(int)((ylarajaX-alarajaX)/pylvaanLeveys);
		}
	}
	/** asetaa pylviden lukumrn vakioksi */
	public void asetaPylvaidenLkm(int lkm)
	{
		pylvaidenLkm=lkm;
		pylvaanLeveys=0;
	}
	/** asetaa pylviden leveyden vakioksi */
	public void asetaPylvaidenLeveys(float pylvaanLeveys)
	{
		this.pylvaanLeveys=pylvaanLeveys;
	}
	/** asetetaan tarkkojen kvantiilien piirto */
	public void piirraTarkatKvantiilit(boolean piirra)
	{
		tarkat=piirra;
	}
	
	/** Katso Piirto -luokasta */
	protected void piirraKa() 
	{
		float skaalaus;
		int pikseli;
		
		if (kaPiirretty)
		{
			skaalaus=skaalaa(alarajaX,ylarajaX,keskiarvo);
			pikseli=vasenTila+(int)(skaalaus*(leveys-(vasenTila+oikeaTila)));
			piirraViiva(pikseli-5,ylaTila-2,pikseli+5,ylaTila-2,Color.black);
			piirraViiva(pikseli-5,ylaTila-1,pikseli+5,ylaTila-1,Color.black);
			piirraViiva(pikseli-5,korkeus-alaTila,
				pikseli+5,korkeus-alaTila,Color.black);
			piirraViiva(pikseli-5,korkeus-alaTila+1,
				pikseli+5,korkeus-alaTila+1,Color.black);
				
		}

		keskiarvo=laskenta.annaKeskiarvo();
		skaalaus=skaalaa(alarajaX,ylarajaX,keskiarvo);
		pikseli=vasenTila+(int)(skaalaus*(leveys-(vasenTila+oikeaTila)));
		piirraViiva(pikseli-5,ylaTila-2,pikseli+5,ylaTila-2,Color.yellow);
		piirraViiva(pikseli-5,ylaTila-1,pikseli+5,ylaTila-1,Color.yellow);
		piirraViiva(pikseli-1,ylaTila-2,pikseli+1,ylaTila-2,Color.black);
		piirraViiva(pikseli-1,ylaTila-1,pikseli+1,ylaTila-1,Color.black);
		piirraViiva(pikseli-5,korkeus-alaTila,
			pikseli+5,korkeus-alaTila,Color.yellow);
		piirraViiva(pikseli-5,korkeus-alaTila+1,
			pikseli+5,korkeus-alaTila+1,Color.yellow);
		piirraViiva(pikseli-1,korkeus-alaTila,
			pikseli+1,korkeus-alaTila,Color.black);
		piirraViiva(pikseli-1,korkeus-alaTila+1,
			pikseli+1,korkeus-alaTila+1,Color.black);
		kaPiirretty=true;
	}

	private Jakaumalaskenta laskenta;
	private int pylvaidenLkm;	
	private boolean kvantiilit=false;
	private float alaKvantiili, ylaKvantiili; /* kvantiilien kohdat 
		esim. 0.025 ja 0.975 */
	
	private float keskiarvo;
	private boolean kaPiirretty=false;
	private float pylvaanLeveys=0;	/* Yhden pylvn leveys; ei tarvitse 
												asetaa, jos asetetaan pylviden lukumr */
	private boolean tarkat=false;
}

