/** 	Kaaviopakkaus
	versio 1.0
	23.3.1998
    	
    	

*/

package kaavio;
import datanhallinta.*;
import laskenta.*;

/** Aliluokka HistogrammiTulostus hoitaa histogrammin tulostuksen. 
*/

public class HistogrammiTulostus
{
	/**kt:ta kytetn tulostuksen tallettamiseen*/
	public Kohdetiedosto kt;
	
	
	
	public HistogrammiTulostus(String tdstoNimi, boolean kaavio,
			Jakaumalaskenta laskenta, String muuttujannimi,
			int pylvaidenLkm, float alaK, float ylaK) 
	{
		try
		{
			String otsake;
			kt = new Kohdetiedosto(tdstoNimi);
			otsake = teeOtsake(kaavio, muuttujannimi, alaK, ylaK);
			kt.kirjoitaRivi(otsake);
			laskenta.laskeKvantiilit(alaK, ylaK);
			if (kaavio)
			{		
				for(int i=0;i<pylvaidenLkm;i++)
				{
					kt.kirjoitaArvo(laskenta.annaX(i));
					kt.kirjoitaMerkki(' ');
					kt.kirjoitaArvo(laskenta.annaKertyma(i+1));
					kt.kirjoitaRivi("");
				}
			}
			else
			{
				kt.kirjoitaArvo(laskenta.annaKeskiarvo());
				kt.kirjoitaMerkki(' ');
				kt.kirjoitaArvo(laskenta.annaMin());
				kt.kirjoitaMerkki(' ');
				kt.kirjoitaArvo(laskenta.annaMax());
				kt.kirjoitaMerkki(' ');
				kt.kirjoitaArvo(laskenta.annaVarianssi());
				kt.kirjoitaMerkki(' ');
				kt.kirjoitaArvo(laskenta.annaKeskihajonta());
				kt.kirjoitaMerkki(' ');
				if (!Float.isNaN(alaK) && !Float.isNaN(ylaK))
					{
					kt.kirjoitaArvo(laskenta.annaTarkkaAlakvantiili());
					kt.kirjoitaMerkki(' ');
					kt.kirjoitaArvo(laskenta.annaTarkkaYlakvantiili());
					kt.kirjoitaMerkki(' ');
					kt.kirjoitaArvo(laskenta.annaTarkkaMediaani());
					kt.kirjoitaMerkki(' ');
					}
				kt.kirjoitaRivi(""); 
			
			}
			kt.sulje();
		}catch(Exception e){
				System.out.println("Virhe HistogrammiTulostus.javassa!");
				}
	}
	
/**teeOtsake palauttaa otsakkeen tulostiedostoa varten*/
		
	private String teeOtsake(boolean kaavio, String muuttuja, float alaK, 
							float ylaK)
	{
		String apu = "";
		if (kaavio)
		{
		return "#<header>\n#<attributes>"+muuttuja+" "+muuttuja+"_frequency"+
			"</attributes>\n#</header>";
		}
		else
		{
		if (!Float.isNaN(alaK) && !Float.isNaN(ylaK))
			apu=" "+muuttuja+"_quantile"+alaK+" "+muuttuja+"_quantile"+ylaK+
				" "+muuttuja+"_median";
			
		return "#<header>\n#<attributes>"+muuttuja+"_mean "+muuttuja+"_min "+
			muuttuja+"_max "+muuttuja+"_var "+muuttuja+"_stddev"+apu+
				"</attributes>\n#</header>";
		
		//eli ka,min, max, varianssi, hajonta
		}
	}
}
