/** 	Kaaviopakkaus
	versio 1.0
	23.3.1998
    	
    	

*/

package kaavio;
import java.awt.*;
import laskenta.*;

/** KaksimuuttujaaPiirto sislt kahden parametrin seurannan kuvaamiseen
tarvittavat metodit. Se on Piirto-luokan aliluokka.
*/

public class KaksimuuttujaaPiirto extends Piirto 
{

	/** Konstruktori ottaa parametrina graphics olion, joka osoittaa valmiiksi
		kanvaasille */
	public KaksimuuttujaaPiirto(Graphics graphics, Yhteisjakaumalaskenta
		laskenta) 
	{
		this.g=graphics;
		leveys=611;
		korkeus=266;
		alarajaX=0;
		alarajaY=0;
		ylarajaX=1;
		ylarajaY=1;
		this.laskenta= laskenta;
	}
	
	/** Kuormittaa Piirto -yliluokan metodin ja piirt pisteen tilalle pienen
		salmiakin */	
	protected void piirraPiste(int x, int y, Color vari) 
	{
		g.setColor(vari);
		g.drawLine(x-2,y,x,y-2);
		g.drawLine(x,y-2,x+2,y);
		g.drawLine(x+2,y,x,y+2);
		g.drawLine(x,y+2,x-2,y);
	}
	
	/** Katso Piirto -luokasta */
	public void piirraUudelleen(int riveja, boolean lasketaan) 
	{
		float skaalausX, skaalausY;
		int uusiX, uusiY;
		
		
		this.dhRiveja=riveja;
		if (lasketaan) 
		{
			laskenta.laskeUudelleen(riveja);
		}
		riveja=laskenta.rivejaKaytetty();
		if (automX&&lasketaan)
		{
			alarajaX=laskenta.annaXMin()- 0.05f*(laskenta.annaXMax()-
				laskenta.annaXMin());
			ylarajaX=laskenta.annaXMax()+ 0.05f*(laskenta.annaXMax()-
				laskenta.annaXMin());
			alarajaX=pyoristaFloat(alarajaX,5);
			ylarajaX=pyoristaFloat(ylarajaX,5);
			if (alarajaX==ylarajaX)
			{
				alarajaX-=1;
				ylarajaX+=1;
			}			

		}	
		if (automY&&lasketaan) 
		{
			alarajaY=laskenta.annaYMin()- 0.05f*(laskenta.annaYMax()-
				laskenta.annaYMin());
			ylarajaY=laskenta.annaYMax()+ 0.05f*(laskenta.annaYMax()-
				laskenta.annaYMin());
			alarajaY=pyoristaFloat(alarajaY,5);
			ylarajaY=pyoristaFloat(ylarajaY,5);
			if (alarajaY==ylarajaY)
			{
				alarajaY-=1;
				ylarajaY+=1;
			}			

			
		}			
	
		piirraAkselit();
		alku=true;
		laskenta.asetaRiviosoitin(-1);
		for (int i=0; i<riveja; i++) 
	   {
			laskenta.siirraRiviosoitinta();		 
			skaalausX=skaalaa(alarajaX,ylarajaX,laskenta.annaX());
			skaalausY=skaalaa(alarajaY,ylarajaY,laskenta.annaY());
			uusiX=vasenTila+(int)(skaalausX*(leveys-(vasenTila+oikeaTila)));
			uusiY=korkeus-alaTila-(int)(skaalausY*(korkeus-(alaTila+ylaTila)));
			if (!viiva) 
			{
				piirraPiste(uusiX,uusiY,Color.black);
			} 
			else
			{
				if (!alku)
				{
					piirraViiva(x,y,uusiX,uusiY,Color.black);
				}
				else
				{
		/* jos piirretn viivaa, niin ensimmist pistett ei piirret */		
					alku=false;
				}
			}	
			x=uusiX;
			y=uusiY;
	   }
		piirraKa();
	}

	/** Katso Piirto -luokasta */
	public void piirraLisaykset(int lkm) 
	{
		float skaalausX, skaalausY;
		int uusiX, uusiY;
		int laskuri=laskenta.rivejaKaytetty();
		int riveja;
		
		this.dhRiveja+=lkm;
		laskenta.laskeLisays(lkm);
		riveja=laskenta.rivejaKaytetty();

		if ((automY&&(laskenta.annaYMax()>ylarajaY || 
				laskenta.annaYMin()<alarajaY)) ||
			(automX&&(laskenta.annaXMax()>ylarajaX ||
			 laskenta.annaXMin()<alarajaX)))
		{
			if (automX)
			{
				alarajaX=laskenta.annaXMin()- 0.05f*(laskenta.annaXMax()-
					laskenta.annaXMin());
				ylarajaX=laskenta.annaXMax()+ 0.05f*(laskenta.annaXMax()-
					laskenta.annaXMin());
				alarajaX=pyoristaFloat(alarajaX,5);
				ylarajaX=pyoristaFloat(ylarajaX,5);
				if (alarajaX==ylarajaX)
				{
					alarajaX-=1;
					ylarajaX+=1;
				}			

			}
			if (automY)
			{
				alarajaY=laskenta.annaYMin()- 0.05f*(laskenta.annaYMax()-
					laskenta.annaYMin());
				ylarajaY=laskenta.annaYMax()+ 0.05f*(laskenta.annaYMax()-
					laskenta.annaYMin());
				alarajaY=pyoristaFloat(alarajaY,5);
				ylarajaY=pyoristaFloat(ylarajaY,5);
				if (alarajaY==ylarajaY)
				{
					alarajaY-=1;
					ylarajaY+=1;
				}			
			}
			piirraUudelleen(dhRiveja, false);
		} else	//	muuten piirretn lismll

		for (; laskuri<riveja; laskuri++) 
	   {
			laskenta.siirraRiviosoitinta();		 
			skaalausX=skaalaa(alarajaX,ylarajaX,laskenta.annaX());
			skaalausY=skaalaa(alarajaY,ylarajaY,laskenta.annaY());
			uusiX=vasenTila+(int)(skaalausX*(leveys-(vasenTila+oikeaTila)));
			uusiY=korkeus-alaTila-(int)(skaalausY*(korkeus-(alaTila+ylaTila)));
			if (!viiva) 
			{
				piirraPiste(uusiX,uusiY,Color.black);
			} 
			else
			{
				if (!alku)
				{
					piirraViiva(x,y,uusiX,uusiY,Color.black);
				}
				else
				{
		/* jos piirretn viivaa, niin ensimmist pistett ei piirret */		
					alku=false;
				}
			}	

			x=uusiX;
			y=uusiY;
	    }
		piirraKa();
	}

	/** Katso Piirto -luokasta */
	protected void piirraKa() 
	{
		float skaalaus;
		int pikseli;
		
		if (kaPiirretty)
		{
			skaalaus=skaalaa(alarajaY,ylarajaY,keskiarvoY);
			pikseli=korkeus-alaTila-(int)(skaalaus*(korkeus-(alaTila+ylaTila)));
			piirraViiva(vasenTila-2,pikseli-5,vasenTila-2,pikseli+5,Color.black);
			piirraViiva(vasenTila-1,pikseli-5,vasenTila-1,pikseli+5,Color.black);
			piirraViiva(leveys-oikeaTila,pikseli-5,leveys-oikeaTila,
				pikseli+5,Color.black);
			piirraViiva(leveys-oikeaTila+1,pikseli-5,leveys-oikeaTila+1,
				pikseli+5,Color.black);
			skaalaus=skaalaa(alarajaX,ylarajaX,keskiarvoX);
			pikseli=vasenTila+(int)(skaalaus*(leveys-(vasenTila+oikeaTila)));
			piirraViiva(pikseli-5,ylaTila-2,pikseli+5,ylaTila-2,Color.black);
			piirraViiva(pikseli-5,ylaTila-1,pikseli+5,ylaTila-1,Color.black);
			piirraViiva(pikseli-5,korkeus-alaTila,
				pikseli+5,korkeus-alaTila,Color.black);
			piirraViiva(pikseli-5,korkeus-alaTila+1,
				pikseli+5,korkeus-alaTila+1,Color.black);
		}
		keskiarvoY=laskenta.annaYKeskiarvo();
		skaalaus=skaalaa(alarajaY,ylarajaY,keskiarvoY);
		pikseli=korkeus-alaTila-(int)(skaalaus*(korkeus-(alaTila+ylaTila)));
		piirraViiva(vasenTila-2,pikseli-5,vasenTila-2,pikseli+5,Color.yellow);
		piirraViiva(vasenTila-1,pikseli-5,vasenTila-1,pikseli+5,Color.yellow);
		piirraViiva(vasenTila-2,pikseli-1,vasenTila-2,pikseli+1,Color.black);
		piirraViiva(vasenTila-1,pikseli-1,vasenTila-1,pikseli+1,Color.black);
		piirraViiva(leveys-oikeaTila,pikseli-5,leveys-oikeaTila,
			pikseli+5,Color.yellow);
		piirraViiva(leveys-oikeaTila+1,pikseli-5,leveys-oikeaTila+1,
			pikseli+5,Color.yellow);
		piirraViiva(leveys-oikeaTila,pikseli-1,leveys-oikeaTila,
			pikseli+1,Color.black);
		piirraViiva(leveys-oikeaTila+1,pikseli-1,leveys-oikeaTila+1,
			pikseli+1,Color.black);

		keskiarvoX=laskenta.annaXKeskiarvo();
		skaalaus=skaalaa(alarajaX,ylarajaX,keskiarvoX);
		pikseli=vasenTila+(int)(skaalaus*(leveys-(vasenTila+oikeaTila)));
		piirraViiva(pikseli-5,ylaTila-2,pikseli+5,ylaTila-2,Color.yellow);
		piirraViiva(pikseli-5,ylaTila-1,pikseli+5,ylaTila-1,Color.yellow);
		piirraViiva(pikseli-1,ylaTila-2,pikseli+1,ylaTila-2,Color.black);
		piirraViiva(pikseli-1,ylaTila-1,pikseli+1,ylaTila-1,Color.black);
		piirraViiva(pikseli-5,korkeus-alaTila,
			pikseli+5,korkeus-alaTila,Color.yellow);
		piirraViiva(pikseli-5,korkeus-alaTila+1,
			pikseli+5,korkeus-alaTila+1,Color.yellow);
		piirraViiva(pikseli-1,korkeus-alaTila,
			pikseli+1,korkeus-alaTila,Color.black);
		piirraViiva(pikseli-1,korkeus-alaTila+1,
			pikseli+1,korkeus-alaTila+1,Color.black);
		kaPiirretty=true;
	}
	/** Asettaa piirtotavan pisteiksi tai viivoiksi */
	public void piirraViiva(boolean viiva)
	{
		this.viiva=viiva;
	}

	private Yhteisjakaumalaskenta laskenta;
	private int x, y;  /* Silyttvt edellisen piirretyn pisteen */
	private boolean viiva; /* true, jos yhdistetn pisteet viivalla */
	private boolean alku=true; /* true, jos ei ole viel saatu ensimmisi arvoja */
	private float keskiarvoX, keskiarvoY;
	private boolean kaPiirretty=false;
}
