/** 	Kaaviopakkaus
	versio 1.0
	23.3.1998
    	
    	

*/

package kaavio;
import datanhallinta.*;
import laskenta.*;

/** Luokka PaloittainvakionTulostus hoitaa paloittain vakioiden funktioiden tulostuksen.
*/

public class PaloittainvakionTulostus
{
	/**kt:ta kytetn tulostuksen tallettamiseen*/
	public Kohdetiedosto kt;
	
	/**Konstruktori tilanteelle, jossa tulostetaan vain funktion arvot, 
	ei kvantiileja.*/
	
	public PaloittainvakionTulostus(String tdstoNimi, boolean kaavio,
		Funktiolaskenta laskenta, String muuttujannimi) 
	{
		try
		{
			String otsake;
			kt = new Kohdetiedosto(tdstoNimi);		
			otsake = teeOtsake(kaavio, muuttujannimi);
			kt.kirjoitaRivi(otsake);
			int apu=laskenta.annaLkm();
			if (kaavio)
			{		
				for(int i=0;i<apu;i++)
				{
					kt.kirjoitaArvo(laskenta.annaX(i));
					kt.kirjoitaMerkki(' ');
					kt.kirjoitaArvo(laskenta.annaKeskiarvo(i));					
					kt.kirjoitaRivi("");
				}
			}
			else
			{
				//kommentoitu, koska paloittain vakioista ei tulosteta tunnuslukuja
				/*kt.kirjoitaArvo(laskenta.annaMin());
				kt.kirjoitaMerkki(' ');
				kt.kirjoitaArvo(laskenta.annaMax());
				kt.kirjoitaMerkki(' ');
				kt.kirjoitaRivi("");
				*/
			}
			kt.sulje();
		}
		catch(Exception e)
		{/*Virhe IOssa!!!*/
			System.err.println("PaloittainvakionTulostus: virhe "+e);
			System.exit(1);
		};	
	}

	
	/**Konstruktori tilanteelle, jossa tulostetaan funktion arvojen lisksi 
	mys kvantiilien arvot.*/
	
	public PaloittainvakionTulostus(String tdstoNimi, boolean kaavio,
		Funktiolaskenta laskenta, String muuttujannimi, 
		float alaK, float ylaK) 
	{
		try
		{
			String otsake;
			kt = new Kohdetiedosto(tdstoNimi);		
			otsake = teeOtsake(kaavio, muuttujannimi, alaK, ylaK);
			kt.kirjoitaRivi(otsake);
			int apu=laskenta.annaLkm();
			if (kaavio)
			{		
				for(int i=0;i<apu;i++)
				{
					kt.kirjoitaArvo(laskenta.annaX(i));
					kt.kirjoitaMerkki(' ');
					kt.kirjoitaArvo(laskenta.annaKeskiarvo(i));
					kt.kirjoitaMerkki(' ');
					kt.kirjoitaArvo(laskenta.annaAlakvantiili(i));
					kt.kirjoitaMerkki(' ');
					kt.kirjoitaArvo(laskenta.annaYlakvantiili(i));						
					kt.kirjoitaRivi("");
				}
			}
			else
			{	//kommentoitu, koska paloittain vakioista ei tulosteta tunnuslukuja
				/*
				kt.kirjoitaArvo(laskenta.annaMin());
				kt.kirjoitaMerkki(' ');
				kt.kirjoitaArvo(laskenta.annaMax());
				kt.kirjoitaMerkki(' ');
				kt.kirjoitaArvo(laskenta.annaPieninKvantiili());
				kt.kirjoitaMerkki(' ');
				kt.kirjoitaArvo(laskenta.annaSuurinKvantiili());
				kt.kirjoitaMerkki(' ');
				kt.kirjoitaArvo(laskenta.annaPieninKa());
				kt.kirjoitaMerkki(' ');
				kt.kirjoitaArvo(laskenta.annaSuurinKa());
				kt.kirjoitaRivi("");
				*/
			}
			kt.sulje();
		}catch(Exception e)
		{/*Virhe IOssa!!!*/
			System.err.println("PaloittainvakionTulostus: virhe "+e);
			System.exit(1);
		};	
	}
	
	/**teeOtsake(boolean, String) tekee otsakkeen tulostiedostoa varten, kun
	kvantiileja ei tulosteta*/
	private String teeOtsake(boolean kaavio, String muuttuja)
	{
		if (kaavio)
		{
		return "#<header>\n#<attributes>"+"time "+muuttuja+"_mean"+"</attributes>\n#</header>";
		}
		else
		{
		//kommentoitu, koska paloittain vakioista ei tulosteta tunnuslukuja
		return /*"#<header>\n#<attributes>"+muuttuja+"_min "+ muuttuja+"_max"
			+"</attributes>\n#</header>"*/"";
		
		//eli min ja max
		}
	}
	
	/**teeOtsake(boolean, String, float, float) tekee otsakkeen 
	tulostiedostoa varten, kun kvantiilitkin tulostetaan*/

	private String teeOtsake(boolean kaavio, String muuttuja, float alaK, 
				float ylaK)
	{
		if (kaavio)
		{
		return "#<header>\n#<attributes>"+"time "+muuttuja+"_mean "+
			muuttuja+"_quantile"+alaK+" "+muuttuja+
			"_quantile"+ylaK+"</attributes>\n#</header>";
		}
		else
		{
		//kommentoitu, koska paloittain vakioista ei tulosteta tunnuslukuja
		return /*"#<header>\n#<attributes>"+muuttuja+"_min "+muuttuja+"_max "
			+muuttuja+"_quantile_min "+muuttuja+
			"_quantile_max "+muuttuja+"_quantile"+alaK+"_mean "+
			muuttuja+"_quantile"+ylaK+"_mean"+"</attributes>\n#</header>"*/"";
		
		//eli min ja max, kvantiilien min ja max, sek kvantiilien kat
		}
	}	
}
