/** 	Kaaviopakkaus
*/

// package kaavio;
import java.awt.*;
import laskenta.*;


/** Abstrakti Piirto-yliluokka sislt piirtoaliluokkien yhteiset metodit, joista osa
abstrakteja.
*/

abstract class Piirto
{
	protected Piirto() 
	{
	}
	
/** Kskee laskennan laskea aineisto uudelleen ja piirt sen kanvaasille */
	abstract public void piirraUudelleen(int riveja, boolean lasketaan);
	
/** Kskee laskennan laskemaan lkm lisyst ja piirt ne kanvaasille */	
	abstract public void piirraLisaykset(int lkm);
	
	/** Piirt kavaasissa akselien plle pienen viivan, joka osoittaa
		keskiarvon kohdan */
	abstract protected void piirraKa();

	/** metodi skaalaa palauttaa prosentteina muuttujan arvo sijainnin suhteessa
	muuttujiin ylaraja ja alaraja */
	protected float skaalaa(float alaraja, float ylaraja, float arvo)
	{
		return (arvo-alaraja)/Math.abs(ylaraja-alaraja);
	}
	
	/** Hakee arvojen vlilt mahdollisimman "sievn" (vhn merkitsevi
	numeroita) luvun ja palauttaa sen. Oletus eka < toka */
	protected double haeArvo(double eka, double toka)
	{
		double arvo;	/* Thn menness paras arvo */
		double pituus, apuPituus;	/* sen merkitsevien numeroiden mr 
		(vhennettyn vakiolla<1, jos viimeinen numero on 5 tai 2) */
		long siirtyma=1; 	/* Vli, jonka vlein lukuja testataan */
		double apu=eka;
		long laskuri, apulong;
		boolean lopeta=false;
		String s;
		char[] ca;
		int nollia=0;	// Ilmaisee sen montako nollaa luvun lopussa on
		int maxNollat=0;	/* Esiintyneiden nollien maksimimr, siirtym
					voidaan kasvattaa suhteessa nollien mrn */
		if (eka*toka<=0) 	/* Jos arvot erimerkkiset tai toinen on nolla, niin 
								sievin arvo niiden vlill	on 0 */
		{
			arvo=0;
		} 
		else
		{
			/* tarkistukset tehdn kokonaisluvuille, koska doubleille tuli
			pyristysvirheit */
			while((long)(apu)!=apu) // While silmukat skaalaavat apu muuttujan  
			{				// pienimpn mahdolliseen kokonaislukuun.	
				apu*=10;
			}
			apu/=10;	// Jos tm on kok.luku, niin pienennetn	
			while((long)(apu)==eka) 
			{
				apu/=10;
			}
			apu*=10; 	
	
			laskuri=(long)apu;
			arvo=(long)apu;
			pituus=(new Long((long)apu).toString()).length();
			while (laskuri<=toka*apu/eka&&!lopeta)  
			{
				/* Arvioi luvun kytettvyyden sen pituuden ja viimeisen numeron
					perusteella */
				nollia=0;
				s=new Long(laskuri).toString();
				apuPituus=s.length();
				ca=s.toCharArray();
				
				while (ca[(int)apuPituus-1]=='0') 
				{
					apuPituus--;
					nollia++;
				}
				
				if (ca[(int)apuPituus-1]=='5') 
				{
					apuPituus-=0.02;
				}
				else if (ca[(int)apuPituus-1]=='2'||ca[(int)apuPituus-1]=='4'||
				ca[(int)apuPituus-1]=='6'||ca[(int)apuPituus-1]=='8')
				apuPituus-=0.01;
				
				if (nollia>17) 		// ettei pituus vhene yhdell
				{
					apuPituus=apuPituus-0.9; 
				}
				else for (int i=0; i<nollia; i++) 
				{
					apuPituus-=0.05;	
				}
	
				if (apuPituus<pituus)
				{
					arvo=laskuri;
					pituus=apuPituus;
				}
				while (nollia>maxNollat) /* Jos nollia enemmn kuin ennen, niin 
				voidaan siirty suuremmilla harppauksilla */
				{
					siirtyma*=10;
					maxNollat++;
				}
				//apulong=laskuri+siirtyma;
				if (laskuri+siirtyma<laskuri) lopeta=true; // vuotaa yli
				laskuri=laskuri+siirtyma;
			}
			arvo=arvo*eka/apu;	
		}
		return arvo;
	}
		 
	/** Piirt kanvaasille x- ja y-akselit ja muutaman arvon paikalleen */
	protected void piirraAkselit() 
	{
	/* Arvot erikseen x:lle ja y:lle, jotta kaikki voidaan laskea valmiiksi
		ennen piirtmist */
		Font apu=g.getFont();  /* jotta lopuksi voidaan palauttaa vanha fontti */
		String[] arvotX; /* Taulukot, johon laitetaan piirrettvt
									arvot stringein */
		String[] arvotY;
											
		int maxPituus=0; 	// X akselilla pisimmn luvun merkkien mr 
		int lkmX;				/* Piirrettvien arvojen lukumrt */
		int lkmY;
		double siirtyma=1;  /* Vierekkisten arvojen vlinen siirtym */
		int ii=0;
		
		float eroY=ylarajaY-alarajaY;
		float eroX=ylarajaX-alarajaX;
		
		double arvo;	
		float skaalaus;	/* Kytetn piirrettess merkit */
		int pikseli;		/* Kytetn piirrettess merkit */

		if (eroY<0)		// jos ero<0, niin alaraja ja ylaraja ovat vrinpin
		{
			eroY=alarajaY;
			alarajaY=ylarajaY;
			ylarajaY=eroY;
			eroY=ylarajaY-alarajaY;
		}
		if (eroX<0)		// jos ero<0, niin alaraja ja ylaraja ovat vrinpin
		{
			eroX=alarajaX;
			alarajaX=ylarajaX;
			ylarajaX=eroX;
			eroX=ylarajaX-alarajaX;
		}
		/* Haetaan ero vlille 5-10 , josta tulee arvojen merkkauskohtien luku- 
		mr, samalla siirtyma tulee osoittamaan kahden arvon vlisen eron */
		while(eroY>=50)
		{
			eroY/=10;
			siirtyma*=10;
		}
		while (eroY>=25) 
		{
			eroY/=5;
			siirtyma*=5;
		}
		while(eroY>=10)
		{
			eroY/=2;
			siirtyma*=2;
		}
	
		while(eroY<1)  /* Seuraavia while-lauseita suoritetaan vain jos ero<5 */ 
		{
			eroY*=10;
			siirtyma/=10;
		}
		while (eroY<=2) 
		{
			eroY*=5;
			siirtyma/=5;	
		}
		while(eroY<5)
		{
			eroY*=2;
			siirtyma/=2;
		}
   	/* Jos eron desimaaliosa on 0.4 tai alle, niin haetaan eka arvo vlilt 
   	alaraja - alaraja + 0.5 *siirtyma ja arvoja asetetaan ero kappaletta, jos 
   	desimaaliosa yli 0.4, niin eka arvo haetaan vlilt alaraja - alaraja +
   	(0.5*(ero-(int)ero)) * siirtyma ja arvoja asetetaan (int)ero+1 kappaletta 
   	puolikkaiden tarkoitus on est viimeist arvoa menemst liian reunaan */
   	 
		lkmY=(int)eroY;
		if (eroY-(int)eroY>0.4) 
		{
			lkmY++;
			arvo=haeArvo(alarajaY,alarajaY+(0.5*(eroY-(int)eroY))*siirtyma);
		}
		else arvo=haeArvo(alarajaY,alarajaY+(0.5*siirtyma));
		arvotY=new String[lkmY];
		for (int i=0; i<lkmY; i++)
		{
		/* Jos arvo riittvn lhell nolla, niin asetetaan se nollaksi */
			if (Math.abs(arvo)<siirtyma/10) arvo=0; 
			/* Jos arvolla ei ole desimaaleja, niin otetaan sielt ".0" pois */
			if (arvo==(long)arvo) arvotY[i]=new Long((long)arvo).toString();
			else arvotY[i]=new Float(arvo).toString();
			arvo+=siirtyma;
			if (arvotY[i].length()>maxPituus) maxPituus=arvotY[i].length();

		}


		siirtyma=1; /* Sama x arvoille */
		/* Haetaan ero vlille 5-10 eli arvojen merkkauskohdat, samalla siirtyma
		tulee osoittamaan kahden arvon vlisen eron */
		while(eroX>=50)
		{
			eroX/=10;
			siirtyma*=10;
		}
		while (eroX>=25) 
		{
			eroX/=5;
			siirtyma*=5;
		}
		while(eroX>=10)
		{
			eroX/=2;
			siirtyma*=2;
		}
	
		while(eroX<1)  /* Seuraavia while-lauseita suoritetaan vain jos ero<5 */ 
		{
			eroX*=10;
			siirtyma/=10;
		}
		while (eroX<=2) 
		{
			eroX*=5;
			siirtyma/=5;	
		}
		while(eroX<5)
		{
			eroX*=2;
			siirtyma/=2;
		}

   	/* Jos eron desimaaliosa on 0.4 tai alle, niin haetaan eka arvo vlilt 
   	alaraja - alaraja + 0.5 *siirtyma ja arvoja asetetaan ero kappaletta, jos 
   	desimaaliosa yli 0.4, niin eka arvo haetaan vlilt alaraja - alaraja +
   	(0.5*(ero-(int)ero)) * siirtyma ja arvoja asetetaan (int)ero+1 kappaletta 
   	puolikkaiden tarkoitus on est viimeist arvoa menemst liian reunaan */
   	 
		lkmX=(int)eroX;
		if (eroX-(int)eroX>0.4) 
		{
			lkmX++;
			arvo=haeArvo(alarajaX,alarajaX+(0.5*(eroX-(int)eroX))*siirtyma);
		}
		else arvo=haeArvo(alarajaX,alarajaX+0.5*siirtyma);
	
		arvotX=new String[lkmX];
		for (int i=0; i<lkmX; i++)
		{
		/* Jos arvo riittvn lhell nolla, niin asetetaan se nollaksi */
			if (Math.abs(arvo)<siirtyma/10) arvo=0; 
			/* Jos arvolla ei ole desimaaleja, niin otetaan sielt ".0" pois */
			if (arvo==(long)arvo) arvotX[i]=new Long((long)arvo).toString();
			else arvotX[i]=new Float(arvo).toString();
			arvo+=siirtyma;
		}

		vasenTila=maxPituus*6+6; /* Jokaiselle merkille tilaa */
		oikeaTila=4;		
		alaTila=2*6+6; 	/* Teksti kahdelle riville */ 
		ylaTila=4;			
		tyhjennaIkkuna();
		g.setFont(new Font("Courier",0,9)); /* Uusi pieni fontti */
		g.setColor(Color.black);
		
	/* Piirretn akselit */	
		g.fillRect(vasenTila-2, ylaTila-2, 2, korkeus-alaTila-ylaTila+2);
		g.fillRect(vasenTila-2, korkeus-alaTila, leveys-vasenTila, 2);
		g.fillRect(leveys-oikeaTila, ylaTila-2, 2, korkeus-alaTila-ylaTila+2);
		g.fillRect(vasenTila-2, ylaTila-2, leveys-vasenTila, 2);

		for (int i=0; i<lkmX; i++)
		{
			skaalaus=skaalaa(alarajaX, ylarajaX, new
				Float(arvotX[i]).floatValue());
			pikseli=vasenTila+(int)((leveys-(vasenTila+oikeaTila))*skaalaus);
			g.drawLine(pikseli,korkeus-alaTila+2,pikseli,korkeus-alaTila+4);
			g.drawLine(pikseli,0,pikseli,ylaTila-2);
		 	g.drawString(arvotX[i],pikseli-6,korkeus-(6*(i%2)));

		}

		for (int i=0; i<lkmY; i++)
		{
			skaalaus=skaalaa(alarajaY, ylarajaY, new
				Float(arvotY[i]).floatValue());
			pikseli=korkeus-alaTila-(int)((korkeus-(ylaTila+alaTila))*skaalaus);
			g.drawLine(vasenTila-4,pikseli,vasenTila-2,pikseli);
			g.drawLine(leveys-2,pikseli,leveys,pikseli);
		 	g.drawString(arvotY[i],0,pikseli+6);

		}

	/* Piirtoalueeksi akseleiden sispuolinen alue akseleineen */
		g.setClip(vasenTila-2,ylaTila-2,leveys-(vasenTila+oikeaTila)+4,
			korkeus-(ylaTila+alaTila)+4);
		
		g.setFont(apu); /* Palauttaa vanhan fontin */
	}
	
	/** Piirt kanvaasille pisteen haluttuun kohtaan halutulla vrill */
	protected void piirraPiste(int x, int y, Color vari) 
	{
		g.setColor(vari);
		g.drawLine(x,y,x,y);
	}
	
	/** Piirt kanvaasille viivan halutulla vrill haluttuun kohtaan */
	protected void piirraViiva(int x1, int y1, int x2, int y2, Color vari) 
	{
		g.setColor(vari);
		g.drawLine(x1,y1,x2,y2);
	}
	
	/** Tyhjent kanvaasin */
	protected void tyhjennaIkkuna() 
	{
		g.setClip(0,0,leveys,korkeus);
		g.clearRect(0,0,leveys,korkeus);
	}

	/** Tyhjent akseleiden sispuolisen alueen */
	protected void tyhjennaPiirtoalue() 
	{
		g.clearRect(vasenTila,ylaTila,leveys-(vasenTila+oikeaTila),
			korkeus-(ylaTila+alaTila));
	}
	
	/** Asettaa x:n alarajan. Klin kyttn. */
	public void asetaAlarajaX(float alarajaX)
	{
		this.alarajaX=alarajaX;
	}
	
	/** Asettaa x:n ylrajan. Klin kyttn. */
	public void asetaYlarajaX(float ylarajaX)
	{
		this.ylarajaX=ylarajaX;
	}
	
	/** Asettaa y:n alarajan. Klin kyttn. */
	public void asetaAlarajaY(float alarajaY)
	{
		this.alarajaY=alarajaY;
	}
	
	/** Asettaa y:n ylrajan. Klin kyttn. */
	public void asetaYlarajaY(float ylarajaY)
	{
		this.ylarajaY=ylarajaY;
	}
	
	/** Palauttaa X:n alarajan. Klin kyttn */
	public float annaAlarajaX() { return alarajaX; }
	
	/** Palauttaa X:n ylrajan. Klin kyttn */
	public float annaYlarajaX() { return ylarajaX; }
	
	/** Palauttaa Y:n alarajan. Klin kyttn */
	public float annaAlarajaY() { return alarajaY; }
	
	/** Palauttaa Y:n ylrajan. Klin kyttn */
	public float annaYlarajaY() { return ylarajaY; }
	
	/** Asettaa X -rajojen automaattisdn plle tai pois */
	public void asetaAutomX(boolean automX)
	{
		this.automX=automX;
	}

	/** Asettaa Y -rajojen automaattisdn plle tai pois */
	public void asetaAutomY(boolean automY)
	{
		this.automY=automY;
	}
	/** Pyrist floatin haluttuun tarkkuuteen */
	protected float pyoristaFloat(float luku, int tarkkuus)
	{
		int apu=0;	// Laskee skaalauksessa tehdyt laskut palautusta varten 
		float apuf=luku;
		double apud;
		boolean plus=true;	// Etumerkki plus?
		
		
		if (apuf<0)
		{
			apuf*=-1;
			plus=false;
		}
		
		if (tarkkuus>0&&tarkkuus<8&&apuf!=0) 
		/* jos parametrit ovat jrkevt */ 
		{
			while(apuf<1) // While silmukat skaalaavat apuf muuttujan 
			{		// pienimpn mahdolliseen kokonaislukuun.	
				apuf*=10;
				apu--;			
			}
			
			while(apuf>10) 
			{
				apuf/=10;
				apu++;
			}

			apuf*=Math.pow(10,tarkkuus-1);
			
			apuf=Math.round(apuf);	// suoritetaan pyristys
			
			// skaalataan takaisin, jos tarvetta
			if (apuf!=0&&(apu-tarkkuus+1)!=0)
			{
	/* kierrtys doublen kautta, jotta eptarkkuudet saadaan katkaistua pois */ 
				apud=apuf*Math.pow(10,apu-tarkkuus+1);
				apuf=(float)apud;
			}
 		}
		luku=apuf;
		if (!plus) luku*=-1;
		return luku;
	}
			
			
	protected Graphics g;
	protected float alarajaX, alarajaY, ylarajaX, ylarajaY;
	protected int leveys,korkeus;
	protected int vasenTila, oikeaTila, ylaTila, alaTila; /* Akselien viemt 
	tilat joka puolelta */
	protected boolean automX, automY;
	protected boolean piirretaan=true;
	protected int dhRiveja;
}
