/** 	Kaaviopakkaus
*/

// package kaavio;
import java.io.*;
import java.awt.*;
import laskenta.*;

/** YksimuuttujaPiirto sislt yhden parametrin seurannan kuvaamiseen
tarvittavat metodit. Se on Piirto-luokan aliluokka.
*/

public class YksimuuttujaPiirto extends Piirto 
{
	private YksimuuttujaPiirto() {}
	/** Konstruktori ottaa parametrina graphics olion, joka osoittaa valmiiksi
		kanvaasille */
	public YksimuuttujaPiirto(Graphics graphics) 
	{
		this.g=graphics;
		g.drawString("luotiin piirto",20,40);
		leveys=426;
		korkeus=258;
		alarajaX=1f;
		alarajaY=-2f;
		ylarajaX=500f;
		ylarajaY=2.5f;
		alkuperainenRivi=10;
		alustaKaavio=10;
		askelKaavio=3;
		
		alustaKontrolli=5;
		askelKontrolli=2;
		laskeKarsinnat();
		kuvanLeveys=500;
		automX=true;
		automY=true;
		laskenta= new Jaljityslaskenta(false);
		laskenta.karsiRivit(alustaKaavio,askelKaavio);
		laskenta.valitseKentta(1);
		//laskenta.asetaRiviosoitin(alkuperainenRivi);
		laskenta.laskeUudelleen(0);
		piirraAkselit();
		x=vasenTila+(int)(skaalaa(alarajaX,ylarajaX,alkuperainenRivi)*
			(leveys-(vasenTila+oikeaTila)));
		y=korkeus-alaTila-(int)(skaalaa(alarajaY,ylarajaY,laskenta.annaY())*
			(korkeus-(alaTila+ylaTila)));
	}	

	/** Katso Piirto -luokasta */
	public void piirraUudelleen(int dhRiveja, boolean lasketaan) 
	{
		
		double skaalausX, skaalausY;
		int uusiX,uusiY;
		int kokRivit=dhRiveja*askelKontrolli+alustaKontrolli;
		int riveja;
		
		this.dhRiveja=dhRiveja;
		piirretaan=true;
		if (lasketaan) laskenta.laskeUudelleen(dhRiveja); 
		riveja=laskenta.rivejaKaytetty();
		if (automX&&lasketaan) 
		{
			if (kokRivit>=(int)(kuvanLeveys*0.98f)+alusta)
			{
				alarajaX=kokRivit-(int)(kuvanLeveys*0.98f);
				ylarajaX=kokRivit;
			} else
			{
				alarajaX=alusta;
				ylarajaX=alusta+kuvanLeveys;
			}
		}
		if (automY&&lasketaan) 
		{
			alarajaY=laskenta.annaMin()- 0.05f*(laskenta.annaMax()-
				laskenta.annaMin());
			ylarajaY=laskenta.annaMax()+ 0.05f*(laskenta.annaMax()-
				laskenta.annaMin());
			alarajaY=pyoristaFloat(alarajaY,5);
			ylarajaY=pyoristaFloat(ylarajaY,5);
			if (alarajaY==ylarajaY)
			{
				alarajaY-=1;
				ylarajaY+=1;
			}			
		}
			
		piirraAkselit();
		laskennanRivi=(int)((alarajaX-alusta)/askel);
		if (laskennanRivi<0)
		{
			laskennanRivi=0;
		}
		alkuperainenRivi=alusta+(laskennanRivi*askel);
		if (laskennanRivi<riveja)
		{
			laskenta.asetaRiviosoitin(laskennanRivi++);
			skaalausX=skaalaa(alarajaX,ylarajaX,alkuperainenRivi);
			skaalausY=skaalaa(alarajaY,ylarajaY,laskenta.annaY());
			x=vasenTila+(int)(skaalausX*(leveys-(vasenTila+oikeaTila)));
			y=korkeus-alaTila-(int)(skaalausY*(korkeus-(alaTila+ylaTila)));
		
			for (; laskennanRivi<riveja; laskennanRivi++)
			{
				laskenta.siirraRiviosoitinta();
				skaalausX=skaalaa(alarajaX,ylarajaX,alkuperainenRivi+askel);
				skaalausY=skaalaa(alarajaY,ylarajaY,laskenta.annaY());
				uusiX=vasenTila+(int)(skaalausX*(leveys-(vasenTila+oikeaTila)));
				uusiY=korkeus-alaTila-(int)(skaalausY*(korkeus-(alaTila+ylaTila)));
				if (piirretaan) piirraViiva(x,y,uusiX,uusiY,Color.black);
				 /* jos x arvot ulkona ruudulta, niin ei en piirret */
				if (skaalausX>100) piirretaan=false; 
				x=uusiX;
				y=uusiY;
				alkuperainenRivi+=askel;
	   	}	
			piirraKa();
		}	
	}

	/** Katso Piirto -luokasta */
	public void piirraLisaykset(int lkm)
	{
		float skaalausX, skaalausY;
		int uusiX,uusiY;
		int laskuri=laskenta.rivejaKaytetty();
		int riveja;
		
		laskenta.laskeLisays(lkm);
		dhRiveja+=lkm;
		riveja=laskenta.rivejaKaytetty();
		if (automY&&(laskenta.annaMax()>ylarajaY||laskenta.annaMin()<alarajaY)) 
		/* Jos tarkistetaan automaattisesti ja kuva ulkona ruudulta */ 
		{
			alarajaY=laskenta.annaMin()- 0.05f*(laskenta.annaMax()-
				laskenta.annaMin());
			ylarajaY=laskenta.annaMax()+ 0.05f*(laskenta.annaMax()-
				laskenta.annaMin());
			alarajaY=pyoristaFloat(alarajaY,5);
			ylarajaY=pyoristaFloat(ylarajaY,5);
			if (alarajaY==ylarajaY)
			{
				alarajaY-=1;
				ylarajaY+=1;
			}			

			piirraUudelleen(dhRiveja, false);
		}			
		else // piirretn silmukassa
		for (; laskuri<riveja; laskuri++) 
	   {
			laskenta.siirraRiviosoitinta();
			skaalausX=skaalaa(alarajaX,ylarajaX,alkuperainenRivi+askel);
			skaalausY=skaalaa(alarajaY,ylarajaY,laskenta.annaY());
			uusiX=vasenTila+(int)(skaalausX*(leveys-(vasenTila+oikeaTila)));
			uusiY=korkeus-alaTila-(int)(skaalausY*(korkeus-(alaTila+ylaTila)));
			if (piirretaan) piirraViiva(x,y,uusiX,uusiY,Color.black);
			x=uusiX;
			y=uusiY;
			alkuperainenRivi=alkuperainenRivi+askel;
			laskennanRivi++;
		/* Jos piirto menossa ruudusta ulos, niin siirretn katsomisaluetta
		puoli ruutua eteenpin */
			if (automX&&alkuperainenRivi+askel>ylarajaX) 
			{
				int kokRivit=dhRiveja*askelKontrolli+alustaKontrolli;
				ylarajaX=kokRivit+(int)(kuvanLeveys/4);
				alarajaX=ylarajaX-kuvanLeveys;
				piirraUudelleen(dhRiveja, false);
				laskuri=riveja;	// lopetetaan; piirrUudelleen piirsi kaiken
			}
			 /* jos x arvot ulkona ruudulta, niin ei en piirret */
			if (skaalausX>100) piirretaan=false; 
	   }
		piirraKa();	
	}

	/** Katso Piirto -luokasta */
	protected void piirraKa() 
	{
		float skaalaus;
		int pikseli;
		
		if (kaPiirretty)
		{
			skaalaus=skaalaa(alarajaY,ylarajaY,keskiarvo);
			pikseli=korkeus-alaTila-(int)(skaalaus*(korkeus-(alaTila+ylaTila)));
			piirraViiva(vasenTila-2,pikseli-5,vasenTila-2,pikseli+5,Color.black);
			piirraViiva(vasenTila-1,pikseli-5,vasenTila-1,pikseli+5,Color.black);
			piirraViiva(leveys-oikeaTila,pikseli-5,leveys-oikeaTila,
				pikseli+5,Color.black);
			piirraViiva(leveys-oikeaTila+1,pikseli-5,leveys-oikeaTila+1,
				pikseli+5,Color.black);
		}
		keskiarvo=laskenta.annaKeskiarvo();
		skaalaus=skaalaa(alarajaY,ylarajaY,keskiarvo);
		pikseli=korkeus-alaTila-(int)(skaalaus*(korkeus-(alaTila+ylaTila)));
		piirraViiva(vasenTila-2,pikseli-5,vasenTila-2,pikseli+5,Color.yellow);
		piirraViiva(vasenTila-1,pikseli-5,vasenTila-1,pikseli+5,Color.yellow);
		piirraViiva(vasenTila-2,pikseli-1,vasenTila-2,pikseli+1,Color.black);
		piirraViiva(vasenTila-1,pikseli-1,vasenTila-1,pikseli+1,Color.black);
		piirraViiva(leveys-oikeaTila,pikseli-5,leveys-oikeaTila,
			pikseli+5,Color.yellow);
		piirraViiva(leveys-oikeaTila+1,pikseli-5,leveys-oikeaTila+1,
			pikseli+5,Color.yellow);
		piirraViiva(leveys-oikeaTila,pikseli-1,leveys-oikeaTila,
			pikseli+1,Color.black);
		piirraViiva(leveys-oikeaTila+1,pikseli-1,leveys-oikeaTila+1,
			pikseli+1,Color.black);
		kaPiirretty=true;
	}
	/** Metodilla asetetaan kontrollissa tehty datan karsinta */
	public void asetaDatanKarsinta(int alusta1, int askel1)
	{
		alustaKontrolli=alusta1;
		askelKontrolli=askel1;
		laskeKarsinnat();
	}	
	/** Metodilla asetetaan kaaviossa tehty datan karsinta */
	public void asetaKaavionKarsinta(int alusta1, int askel1)
	{
		alustaKaavio=alusta1;
		askelKaavio=askel1;
		laskeKarsinnat();
	}
	/** Metodilla asetetaan kuvan leveys datan rivein vakioksi */
	public void asetaLeveys(int kuvanLeveys)
	{
		this.kuvanLeveys=kuvanLeveys;
	}	
	/** metodi laskee kokonaiskarsinnat kontrollin ja kaavion karsinnoista */
	private void laskeKarsinnat()
	{
		alusta=alustaKontrolli+askelKontrolli*alustaKaavio;
		askel=askelKontrolli*askelKaavio;
	}
	
	/** Testataan haeArvo ja pyoristaFloat metodeita */
	public static void main(String[] args) // Testaa haeArvo -metodia
	{
		float d1,d2;
		YksimuuttujaPiirto olio=new YksimuuttujaPiirto();
		
		d1=0.7f; d2=12f;
		System.out.println("haeArvo("+d1+","+d2+") = "+(float)olio.haeArvo(d1,d2));
		d1=0.0001f; d2=0.1234f;
		System.out.println("haeArvo("+d1+","+d2+") = "+(float)olio.haeArvo(d1,d2));
		d1=-0.0001f; d2=0.1f;
		System.out.println("haeArvo("+d1+","+d2+") = "+(float)olio.haeArvo(d1,d2));
		d1=1f; d2=10001f;
		System.out.println("haeArvo("+d1+","+d2+") = "+(float)olio.haeArvo(d1,d2));

		d1=0.1f; d2=5f;
		System.out.println("pyoristaFloat("+d1+","+(int)d2+") = "+olio.pyoristaFloat(d1,(int)d2));
		d1=0f; d2=5f;
		System.out.println("pyoristaFloat("+d1+","+(int)d2+") = "+olio.pyoristaFloat(d1,(int)d2));
		d1=0.123f; d2=1f;
		System.out.println("pyoristaFloat("+d1+","+(int)d2+") = "+olio.pyoristaFloat(d1,(int)d2));
		d1=0.12345678f; d2=5f;
		System.out.println("pyoristaFloat("+d1+","+(int)d2+") = "+olio.pyoristaFloat(d1,(int)d2));
		d1=0.123f; d2=9f;
		System.out.println("pyoristaFloat("+d1+","+(int)d2+") = "+olio.pyoristaFloat(d1,(int)d2));
		d1=0.123f; d2=0f;
		System.out.println("pyoristaFloat("+d1+","+(int)d2+") = "+olio.pyoristaFloat(d1,(int)d2));
	}

	private Jaljityslaskenta laskenta;
	private int x, y;  /* Silyttvt edellisen piirretyn pisteen */
	private int alkuperainenRivi;  /* Datan alkuperinen rivinumero */	
	private int laskennanRivi;
	private float keskiarvo;
	private boolean kaPiirretty=false;
	private int alustaKaavio=0, askelKaavio=1;	// Kaavion karsinnat
	private int alustaKontrolli=0, askelKontrolli=1;		// Kokonaiskarsinnat
	private int alusta=0, askel=1;	 	/* lasketut kokonaissiirtymt, jotta 
												voidaan merkit alkuperiset rivinumerot */
	private int kuvanLeveys;	/* kuvan leveys alkuperisen datan rivein */
}
