import sunsoft.jws.visual.rt.base.*;
import sunsoft.jws.visual.rt.shadow.java.awt.*;
import java.awt.*;
import laskenta.*;
import kaavio.*;
import sunsoft.jws.visual.rt.shadow.VJCanvasShadow;
import sunsoft.jws.visual.rt.awt.*;

/** Hoitaa Kaavioikkunan tapahtumanksittelyn ja piirtosikeen
	synkronoinnin
*/
public class AutoCorrelation extends Group implements Runnable {
  
	public AutoCorrelationRoot gui; // kyttliittym (jws:n generoima) 	
 	private Graphics g; // graph olio joka vlitetn piirrolle 	
 	private Autokorrelaatiolaskenta laskenta; // tmn kaaviotyypin lakenta olio 	
	private AutokorrelaationPiirto piirto; // tmn kaaviotyypin piirto olio 		
	
	private Thread t; //sie joka hoitaa piirtmisen 		
	private JavistPaaikkuna kontrolli;// viittaus pikkunaan 		
	private boolean pysaytetty=true; // kertoo onko piirto pysytetty 	
  	private boolean pysayta=false; // kertoo, ett piirto olisi syyt pysaytt 		
  	private int valittuIndeksi; // kertoo piirrettvn parametrin indeksin 		
  	private int[] indeksit; /* tll silytetn listboksissa olevien 
  								parametrien todelliset (datanhallinnan) indeksit */
  	private String valittuString; //valitun kentn nimi 
  	private int valittuna=0; // valittuna olevien kenttien lkm
	private int riveja=0; // tiedossa olevien rivien lkm
  	private int askel=1; // kaavion sisisen karsinnan askel
  	private int poistettu=0; //kaavion sisisen karsinnan rivimr
  	private int uusiaRiveja=0; // uusien rivien lkm
  	private boolean pysahtynyt = false; // onko pyshtynyt
	private boolean odottamassa = false; // onko odottamassa
	private int pysaytettava = 1; // pysaytettavien lkm
	private boolean asetuksetOk = false;
	private boolean laskettavaUudelleen = true; 
	private boolean piirrettavaUudelleen = true;
	private boolean laskeUudelleen; 
	private boolean piirraUudelleen;
	private boolean varattu=true;
  
	/** Saa viittauksen pikkunaan ja thn menness luettujen rivien mrn */
	public AutoCorrelation(JavistPaaikkuna kontrolli,int riveja)
	{
    
		this.kontrolli=kontrolli;
    	laskenta=new Autokorrelaatiolaskenta(true);   
    	
    	this.riveja=riveja;
    	addForwardedAttributes();
    	// sie luodaan ja kynnistetn vlittmsti.
		// pysytettava alustetaan arvolla 1, jolloin run-metodi
		// j odottamaan.
		t = new Thread(this);
		t.start();
  	}
  
	/**	Sikeen t metodi. Hoitaa piirtmisen omana sikeenn */  
  	public void run()
	{
  		int r = 0;
  		while(true)
  		{
			r = rivejaKertynyt();  		
  			riveja += r;
  			if (piirraUudelleen && laskeUudelleen) piirto.piirraUudelleen(riveja, true);
			else
			{
				if (piirraUudelleen) piirto.piirraUudelleen(riveja, false);
				if (r > 0) piirto.piirraLisaykset(r);
			}
  			haeTunnusluvut();
		}
	}

	// ++++++ Synkronisoidut metodit +++++++++++

	/** Palauttaa kontrollista tulleiden rivien mrn. 
		Jos rivej ei ole tullut ja piirrettavaUudelleen ja laskettavaUudelleen == false
		tai pysayttettava>0 j odottamaan.
	*/
	private synchronized int rivejaKertynyt()
	{
		int r = uusiaRiveja;
		boolean toimeton = !(piirrettavaUudelleen || laskettavaUudelleen || (r > 0));
		if (toimeton  || (pysaytettava > 0))
		{
			pysahtynyt = true;
			if (odottamassa)
			{
				notifyAll();				// vapauttaa kaikki odota() - metodissa olevat sikeet
				odottamassa = false;
			}
			try { wait(); } catch (Exception e)
			{ System.out.println("rivejaKertynyt: wait exception"); System.exit(1); }
			r = uusiaRiveja;
		}
		piirraUudelleen = piirrettavaUudelleen; piirrettavaUudelleen = false;
		laskeUudelleen = laskettavaUudelleen; laskettavaUudelleen = false;
		uusiaRiveja = 0;
		return r;
	}
  
	/** Lisaa uusien rivien mrn.*/
	public synchronized  void tullutUusiaRiveja(int r)
	{
		uusiaRiveja += r;
		if ((pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; } 
	}
  
	/** ilmoittaa, ett ei saa aloittaa uutta laskentaa */ 
	public synchronized void pysayta()
	{	
  		pysaytettava++;
	}

	/** palauttaa kontrollin vasta kun piirto on pysaytetty */
	public synchronized void odota()
	{
		if (!pysahtynyt)
		{
			odottamassa = true;
			try { wait(); } catch (Exception e)
			{ System.out.println("odota: wait exception"); System.exit(1); }
		}
	}

	/** Jatkaa pysayta metodilla pysaytettya toimintoa*/
	public synchronized void jatka()
	{
		if ((--pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; }
	}

	/** Tilaa uudelleen piirron */
	private synchronized void tilaaUudelleenpiirto()
	{
		piirrettavaUudelleen = true;
		if ((pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; }
	}

	/** Pst piirto sikeen jatkamaan kun valinnat on tehty */
	private synchronized void valinnatTehty()
	{
		piirrettavaUudelleen = laskettavaUudelleen = true;
		if ((--pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; }
		varattu=false;
	}

  	/** muuttaa rivien mr ja kertoo piirrolle karsinnasta
  		kertoo mys, ett on syyt piirt ja laskea uudelleen 
  	 */
  	public synchronized void rivitMuuttuneet(int r, int alusta, int askel)
  	{
 		haeKentat();
 		if (piirto!=null)
 			piirto.asetaDatanKarsinta(alusta,askel);
 		
 		riveja = r;
 		uusiaRiveja = 0;
 		piirrettavaUudelleen = laskettavaUudelleen = true;

 	}
  


  	/** Hakee ja kirjoittaa kaavion tunnusluvut graphview ikkunaan*/ 
  	public void haeTunnusluvut()
  	{
  		
  		gui.lblAutoCorrelationKeskiarvo.set("text",""+laskenta.annaKeskiarvo());
		gui.lblAutoCorrelationHajonta.set("text",""+laskenta.annaKeskihajonta());  
   		gui.lblAutoCorrelationMaksimi.set("text",""+laskenta.annaMax());
   		gui.lblAutoCorrelationMinimi.set("text",""+laskenta.annaMin());
   		gui.lblAutoCorrelationRowsProsessed.set("text",""+laskenta.rivejaKaytetty());
   		gui.lblAutoCorrelationNumberOfSweeps.set("text",""+riveja);
   		gui.lblAutoCorrelationVarianssi.set("text",""+laskenta.annaVarianssi());
	}
  
  	/** Tarkistaa onko kaaviossa valittuna oleva kentt viel datanhallinnassa.
  		Jos ei ole, niin tehdn "itsemurha" */
  	public void tarkistaKentat()
  	{
  			
		if(kontrolli.dh.onMuistissa(valittuIndeksi))
			haeKentat();
		else	
			kontrolli.tapaMut(this);
	}
  
 	
  	/** Suoritetaan, kun Print-nappulaa painetaan. Kysyy kyttjlt tieedostot, joihin 
  		tulostetaan
  	*/  
  	public void buttAutoCorrelationPrintClick(Message msg, Event evt)
	{
  		if(varattu)return;
  		else
  			varattu=true;
  		String dir="";
	  	String file="";
	  	List list1 = (List)kontrolli.gui.list1.getBody();
  	  
		pysayta(); odota();
  	  	// kuvan tulostus
     	kontrolli.gui.filedialog1.set("title","Print picture");
     	kontrolli.gui.filedialog1.show();
  	  	FileDialog apu=(FileDialog)kontrolli.gui.filedialog1.getBody();
  	  	apu.setMode(FileDialog.SAVE);
  	  	
     	dir = (String)kontrolli.gui.filedialog1.get("directory");
     	file = (String)kontrolli.gui.filedialog1.get("file");   
	 
	  	if(file!=null)
	  	{
  	  		new AutokorrelaationTulostus(""+dir+file,true,laskenta,valittuString);
  	  	}
  	  
  	  	
  		dir=null;file=null;
  			
  		// tunnuslukujen tulostus
  		kontrolli.gui.filedialog1.set("title","Print statistics");
     	kontrolli.gui.filedialog1.show();
  	  	apu=(FileDialog)kontrolli.gui.filedialog1.getBody();
  	  	apu.setMode(FileDialog.SAVE);
  	  	
     	dir = (String)kontrolli.gui.filedialog1.get("directory");
     	file = (String)kontrolli.gui.filedialog1.get("file");   
	 
	  	if(file!=null)
	  	{
	 		new AutokorrelaationTulostus(""+dir+file,false,laskenta,valittuString);
  	  	}
  	  
  	  	dir=null;file=null;
  	  	tilaaUudelleenpiirto();
  	  	jatka();
		varattu=false;
	}
    
	/** Suoritetaan, kun Settings-nappulaa painetaan.*/ 
	public void buttAutoCorrelationSettingsClick(Message msg, Event evt)
   	{
		if(varattu)return;
		else
			varattu=true;
		valittuString=""+kontrolli.dh.annaKentanNimi(valittuIndeksi);
 	 	if (asetuksetOk) pysayta();
		gui.dialAutoCorrelationSettings.show();
 	}   
	    
    /** Suoritetaan, kun Close-nappulaa painetaan. */
    public void buttAutoCorrelationCloseClick(Message msg, Event evt)
    {
  		kontrolli.tapaMut(this);
  	}
    
    /** Kutsutaan vastaavaa "nappula-painettu" metodia */
    public void menuitemAutoCorrelationFilePrintClick(Message msg, Event evt)
    {
    	buttAutoCorrelationPrintClick(msg,evt);
    }
    
    /** Kutsutaan vastaavaa "nappula-painettu" metodia */
    public void menuitemAutoCorrelationFileCloseClick(Message msg, Event evt)
    {
    	buttAutoCorrelationCloseClick(msg,evt);
    }
    
    /** Kutsutaan vastaavaa "nappula-painettu" metodia */
    public void menuitemAutoCorrelationGraphSettingsClick(Message msg, Event evt)
    {
    	buttAutoCorrelationSettingsClick(msg,evt);
    
    }
    
    /** Haetaan kyttjn valitseman list-indeksin todellinen indeksi */   
    public void listAutoCorrelationSettingsClick(Message msg, Event evt)
    {
  
  		Label valittu=(Label)gui.lblAutoCorrelationSettingsChosenAttribute.getBody();
 		List list=(List)gui.listAutoCorrelationSettings.getBody();
	  
  		valittuIndeksi=indeksit[list.getSelectedIndex()];
  		valittuString=list.getSelectedItem();
  		valittu.setText(valittuString);		
  		valittuna=1;		
  
  	}
   	 
    
    /** Suoritetaan, kun Settings ikkunan Ok-nappulaa painetaan.
    	Jos piirtoa ei ole viel luotu luodaan piirto ja sie t. 
    	Lisksi haetaan kyttjn antamat tiedot. Jos tiedot ovat oikeelliset ja 
    	valittu ei ole funktio kutsutaan valinnatTehty metodia. Jos tiedot ovat 
    	oikeelliset ja valittu on funktio jtetn valinnatTehty metodin kutsu 
    	haeFunktionTiedot metodin suoritettavaksi.   
    
    */
    public void buttAutoCorrelationSettingsOkClick(Message msg, Event evt)
    {	 
  		int poistettu=0;
   		int askel=1;
   		odota();
   		if(valittuna==1)
  	 	{
  	 		Dialog dialogi=(Dialog)gui.dialAutoCorrelationSettings.getBody();// settings dialogi
 	 		Dialog dialogi1=(Dialog)gui.dialAutoCorrelationSelections.getBody();// funktio dialogi
 			boolean onFunktio=false;
			// asetetaan akselien nimet
  	 		Label yAkseli=(Label)gui.lblAutoCorrelationAkseliHigh.getBody();
  	 		yAkseli.setText(valittuString);
	 		Label xAkseli=(Label)gui.lblAutoCorrelationAkseliLow.getBody();
	 		xAkseli.setText("depth");
 			// asetetaan graph-ikkunaan parametrin nimi
 			gui.lblAutoCorrelationParameter.set("text",valittuString);
 			if(piirto==null)
  	 		{
   				VJCanvas vjcanvas = (VJCanvas)gui.canvAutoCorrelation.getBody();
				g = vjcanvas.getGraphics();
				laskenta.valitseKentta(valittuIndeksi);
    			poistettu=kontrolli.dh.absKarsittuAlusta();
  	 			askel=kontrolli.dh.absKarsintaAskel();
  	 			piirto= new AutokorrelaationPiirto(g,laskenta,poistettu,askel);
  	 			t=new Thread(this);
  	 	 		if(haeTiedot())//hakee ja tarkistaa kyttjn antamat tiedot
 	 			{
 	 				// kysytn onko valittu funktio
 		 		
 		 			if(kontrolli.dh.onFunktio(valittuIndeksi))
 		 				onFunktio=true;
 		 			if(onFunktio)
 	 				{			
 	 		 	 		
 	 					gui.dialAutoCorrelationSelections.show();
 	 					// valitun kentn nimi
 	 		 			gui.gbpanel6.set("layoutName",valittuString);
 	 		
 	 				}
					if(!onFunktio) 	
		 			// jos valittu on funktio, ei kynnistet piirtoa
		 			//ennen kuin funktion tiedot on mritetty
		 			{
		 				gui.dialAutoCorrelationSettings.hide();
						asetuksetOk = true;
						valinnatTehty();	 			
					}
  				}
  			}//if(piirto==null)
	 		else
			{
	 			laskenta.valitseKentta(valittuIndeksi);
    			piirraUudelleen=true;
	 		
	 			if(haeTiedot())//hakee ja tarkistaa kyttjn antamat tiedot
 	 	 		{
					if(kontrolli.dh.onFunktio(valittuIndeksi))
						onFunktio=true; 	 	
 		 			// kysytn onko valittu funktio
 					if(onFunktio)
 	 				{			
 	 		 	 		gui.dialAutoCorrelationSelections.show();
 	 					// valitun kentn nimi
 	 					gui.gbpanel6.set("layoutName",valittuString);
 	 					// gbpanel6 on funktio dialogin kentt mihin tulee 
						// valittu parametri
					}
 
 	 				if(!onFunktio)
 	 				// jos valittu on funktio, ei kynnistet piirtoa
		 			//ennen kuin funktion tiedot on mritetty
 	 				{
 	 					gui.dialAutoCorrelationSettings.hide();
						asetuksetOk = true;
  						valinnatTehty();		
  					}
  				}
			}
 	 
		}//if(valittuna==1)
	
		else
			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.VALITSEYKSI,JavistPaaikkuna.FOO);
	}
  
  	/** Hakee ja tarkistaa kyttjn antamat tiedot. */
  	public boolean haeTiedot()
  	{
  		
		float xYla=0;
  		float xAla=0;
  		float yYla=0;
  		float yAla=0;
  		int syvyys=1;
  		boolean syoteOk=false;
  		String poisString;
  	   	String askelString;
  	   	String syvyysString;
  		TextField txtAskel=(TextField)gui.txtAutoCorrelationIncludeRows.getBody();
  		TextField txtPois=(TextField)gui.txtAutoCorrelationRemoveRows.getBody();
  		TextField txtSyvyys=(TextField)gui.txtAutoCorrelationSettingsDepth.getBody();
  		try
  		{
  			askelString=txtAskel.getText();
  			poisString=txtPois.getText();
  			askel=Integer.parseInt(askelString);
  			poistettu=Integer.parseInt(poisString);
  			if(askel<=0||poistettu<0)
  			{
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				return false;	
  			}
  			
  		}	
  		catch(NumberFormatException e)
  		{ 
  			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  			return false;
  			
  		}
  		
  		try
  		{
  			syvyysString=txtSyvyys.getText();
  			syvyys=Integer.parseInt(syvyysString);
  			if(syvyys>0)
  				syoteOk=true;
  			else
  			{	
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				return false;
  			}
  		
  		}
  		catch(NumberFormatException e)
  		{ 
  			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  			return false;
  			
  		}		
  		if(syoteOk)
  		{
  			gui.lblAutoCorrelationRowsIncluded.set("text","");
  			gui.lblAutoCorrelationRowsRemoved.set("text","");
  			gui.lblAutoCorrelationRowsIncluded.set("text",""+(kontrolli.dh.absKarsintaAskel()*askel));
			gui.lblAutoCorrelationRowsRemoved.set("text",""+(kontrolli.dh.absKarsittuAlusta()+poistettu*kontrolli.dh.absKarsintaAskel()));	
  			piirto.asetaKaavionKarsinta(poistettu,askel);
  			laskenta.asetaSyvyys(syvyys);
  			laskenta.karsiRivit(poistettu,askel);
  			syoteOk=false;
  			piirto.asetaAutomX(true);
 			piirto.asetaAutomY(true);
 			return true;
 		}
  		else
  			return false;	
  	}
  
  
  	/** Siin tapauksessa, ett kyttjn valitsema kentt on funktio,
  		 haetaan kyttn funktiosta antamat tiedot ja sytteiden ollessa oikeelliset 
  		 kutsutaan valinnatTehty metodia 
  	*/  
  	public void haeFunktionTiedot()
  	{	
  		String paloja;
  		String palaa;
  		String kohtaa;
 		int palojaInt=0; 
 		int palaaInt=0;
 		int kohtaaInt=0;
 		boolean syoteOk =false;		
  		Checkbox seurataanLkm=(Checkbox)gui.radioAutoCorrelationParam1TraceNumber.getBody();
  		Checkbox seurataanPalaa=(Checkbox)gui.radioAutoCorrelationP1TraceFunctionsTracePiece.getBody();
		TextField txtPaloja=(TextField)gui.txtAutoCorrelationParam1TraceFunctionsPcs.getBody();
  		TextField txtKohtaa=(TextField)gui.txtAutoCorrelationP1TraceFunctionsTracePlace.getBody();
  		TextField txtPalaa=(TextField)gui.txtAutoCorrelationP1TraceFunctionsTracePiece.getBody();
   	
   		try{
   			if(!seurataanLkm.getState())
  			// kiinnitetn palalukumr
  			{	
  				paloja=txtPaloja.getText();
				palojaInt=Integer.parseInt(paloja);
			  			
  				if(seurataanPalaa.getState())
  				{	
  					palaa=txtPalaa.getText();	
  					palaaInt=Integer.parseInt(palaa);
  					if(palojaInt!=0&&palaaInt<=palojaInt&&palaaInt!=0)
  					{	
  						syoteOk=true;	
  						valittuString+="_level"+palaaInt;
  					}	
  				  			
  					else
  						JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				}
  				else	
				{
					// seurataan hyppykohtaa
					kohtaa=txtKohtaa.getText();
					kohtaaInt=Integer.parseInt(kohtaa);
  					if(palojaInt!=0&&kohtaaInt<palojaInt&&kohtaaInt!=0)
					{	
						syoteOk=true;
						valittuString+="_jump"+kohtaaInt;
					}
					else
						JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
				}
			}	  
  			else
			{	
				syoteOk=true;		
  				valittuString+="_pieces";
  			}		
  		}//try
  		catch(NumberFormatException e)
  		{ 
  			syoteOk=false;
  			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  		}		
  		if(syoteOk)
 		{ 
 			//Sytteet hyvksyttvi	
		  	syoteOk=false;
			if(seurataanLkm.getState())
				laskenta.valitseKentta(valittuIndeksi,0);
			else
			{
				laskenta.kiinnitaPalaLkm(valittuIndeksi,palojaInt);
				if(seurataanPalaa.getState())
					laskenta.valitseKentta(valittuIndeksi,2*palaaInt-1);
				else
					laskenta.valitseKentta(valittuIndeksi,2*kohtaaInt);
			}
				
			gui.dialAutoCorrelationSelections.hide();
	  		gui.dialAutoCorrelationSettings.hide();
			asetuksetOk = true;
	  		valinnatTehty();
		}
  	}
  
    /** Suoritetaan, kun Settings ikkunan cancel-nappulaa painetaan. */
    public void buttAutoCorrelationSettingsCancelClick(Message msg, Event evt)
    {
    	varattu=false;
    	gui.dialAutoCorrelationSettings.hide();
		if (asetuksetOk) jatka();
    }
    
    // Kyttmttmia action tapahtumia kalin objekteille
    public void radioAutoCorrelationParam1TraceNumberClick(Message msg, Event evt){}
    public void radioAutoCorrelationParam1TraceFunctionsClick(Message msg, Event evt){}
    public void txtAutoCorrelationParam1TraceFunctionsPcsEnter(Message msg, Event evt){}
    public void radioAutoCorrelationP1TraceFunctionsTracePieceClick(Message msg, Event evt){}
    public void txtAutoCorrelationP1TraceFunctionsTracePieceEnter(Message msg, Event evt){}
    public void radioAutoCorrelationP1TraceFunctionsTracePlaceClick(Message msg, Event evt){}
    public void txtAutoCorrelationP1TraceFunctionsTracePlaceEnter(Message msg, Event evt){}
    public void txtAutoCorrelationSettingsDepthEnter(Message msg, Event evt){}
    public void txtAutoCorrelationRemoveRowsEnter(Message msg, Event evt){}
    public void txtAutoCorrelationIncludeRowsEnter(Message msg, Event evt){}
  
    /** Suoritetaan, kun Selections ikkunan Ok-nappulaa painetaan.*/
    public void buttAutoCorrelationSelectionsOkClick(Message msg, Event evt)
    {
    
    	haeFunktionTiedot();
    }
 
	protected Root initRoot() 
	{	
    	gui = new AutoCorrelationRoot(this);	
    
    	addAttributeForward(gui.getMainChild());	

    	return gui;
  	}
  	
  	protected void initGroup() { }	
  	protected void showGroup() { }	
  	protected void hideGroup() { }	
  	
  	/** Hakee datanhallinnalta muistissa olevat kentt */
  	public void haeKentat()
	{

		List list=(List)gui.listAutoCorrelationSettings.getBody();
 		int apu=kontrolli.dh.annaKenttienLkm();		   
		Dialog dialog =(Dialog)gui.dialAutoCorrelationSettings.getBody();
		dialog.setModal(false);	   
		list.removeAll();
		indeksit=new int[apu];// taulukkoon merkataan listboksissa olevien parametrien indeksit 
		int j=0;//listboksin indeksi
		for (int i=0;i<apu;i++)
		{			
					
			if(list!=null&&kontrolli.dh.onMuistissa(i))
			{
				list.addItem(kontrolli.dh.annaKentanNimi(i));
				indeksit[j]=i;
				j++;
			}				    

		 }

  			
  		// pivitetn settings-ikkunan labelit ja textfieldit
  		gui.txtAutoCorrelationIncludeRows.set("text",""+askel);
  		gui.txtAutoCorrelationRemoveRows.set("text",""+poistettu);
  		gui.lblAutoCorrelationRowsIncluded.set("text","");
  		gui.lblAutoCorrelationRowsRemoved.set("text","");
  		gui.lblAutoCorrelationRowsIncluded.set("text",""+(kontrolli.dh.absKarsintaAskel()*askel));
		gui.lblAutoCorrelationRowsRemoved.set("text",""+(kontrolli.dh.absKarsittuAlusta()+poistettu*kontrolli.dh.absKarsintaAskel()));	
  
  	}
  
  	/** Suoritetaan vhn ennenkuin kyttliittym tulee nkyviin. 
  		Suorittaa alustuksia.
  	*/
  	protected void createGroup() 
  	{
  		haeKentat();
  		// alustetaan labelit
  		gui.lblAutoCorrelationAkseliHigh.set("text","                                        ");
		gui.lblAutoCorrelationAkseliLow.set("text","                                        ");
	 	gui.lblAutoCorrelationRowsIncluded.set("text","   "+(kontrolli.dh.absKarsintaAskel()*askel)+"   ");
  		gui.lblAutoCorrelationRowsRemoved.set("text","   "+(kontrolli.dh.absKarsittuAlusta()+poistettu*kontrolli.dh.absKarsintaAskel())+"   ");
  		gui.txtAutoCorrelationSettingsDepth.set("text",""+50);
  		gui.lblAutoCorrelationKeskiarvo.set("text","              ");
		gui.lblAutoCorrelationHajonta.set("text","              ");  
   		gui.lblAutoCorrelationMaksimi.set("text","              ");
   		gui.lblAutoCorrelationMinimi.set("text","              ");
   		gui.lblAutoCorrelationRowsProsessed.set("text","              ");
   		gui.lblAutoCorrelationNumberOfSweeps.set("text","              ");
   		gui.lblAutoCorrelationVarianssi.set("text","              ");
  	}
  
  	protected void destroyGroup() { }	
  	protected void startGroup() { }	
  	protected void stopGroup() { }	

  	protected Object getOnGroup(String key)
	{	
    	return super.getOnGroup(key);	
  	}
  	
  	protected void setOnGroup(String key, Object value) 
  	{	
    	super.setOnGroup(key, value);	
  	}
  
  	public boolean handleMessage(Message msg) {	
    	return super.handleMessage(msg);	
 	}
  	
  	/** Yleinen tapahtumanksittely metodi. */
  	public boolean handleEvent(Message msg, Event evt) 
  	{
		switch (evt.id) 
      	{
      		case 2567:	// PAINT_EVENT
			{
         		if (msg.target == gui.canvAutoCorrelation) 
            		tilaaUudelleenpiirto();
            	break;
            }
			case 701: //listaa npytetty
		  	{
				if(msg.target==gui.listAutoCorrelationSettings)
				{
					listAutoCorrelationSettingsClick(msg,evt);			
  				}
			break;
		 	}
		
		}
    	if(evt.id!=java.awt.event.WindowEvent.WINDOW_CLOSING)
    		return super.handleEvent(msg, evt);
  		else
  			return true;
	}
}
