import sunsoft.jws.visual.rt.base.*;
import sunsoft.jws.visual.rt.shadow.java.awt.*;
import java.awt.*;
import laskenta.*;
import kaavio.*;
import sunsoft.jws.visual.rt.shadow.VJCanvasShadow;
import sunsoft.jws.visual.rt.awt.*;

/** Hoitaa Kaavioikkunan tapahtumanksittelyn ja piirtosikeen
	synkronoinnin
*/
public class ParameterDistribution extends Group implements Runnable {
	
	public ParameterDistributionRoot gui;// kyttliittym (jws:n generoima) 
	private Graphics g;// graph olio joka vlitetn piirrolle
	private Jakaumalaskenta laskenta;// tmn kaaviotyypin lakenta olio
  	private HistogrammiPiirto piirto;// tmn kaaviotyypin piirto olio 
  
  	private Thread t; //sie joka hoitaa piirtmisen 		
	private JavistPaaikkuna kontrolli;// viittaus pikkunaan 		

  	private int valittuIndeksi; // kertoo piirrettvn parametrin indeksin 		
  	private int[] indeksit; /* tll silytetn listboksissa olevien 
  								parametrien todelliset (datanhallinnan) indeksit */
  	private String valittuString; //valitun kentn nimi 
  	private int valittuna=0; // valittuna olevien kenttien lkm
	private int riveja=0; // tiedossa olevien rivien lkm
  	private int askel=1; // kaavion sisisen karsinnan askel
  	private int poistettu=0; //kaavion sisisen karsinnan rivimr
  	private int uusiaRiveja=0; // uusien rivien lkm
  	private boolean pysahtynyt = false; // onko pyshtynyt
	private boolean odottamassa = false; // onko odottamassa
	private int pysaytettava = 1; // pysaytettavien lkm
	private boolean asetuksetOk = false;
	private boolean laskettavaUudelleen = true; 
	private boolean piirrettavaUudelleen = true;
  	private boolean tarkatKvantiilit = false;
	private boolean laskeUudelleen; 
	private boolean piirraUudelleen;
  	private boolean kvantiilit=false;
	private boolean varattu=true;//saako settings / print ikkunan avata
	private float	qYla=0;
  	private	float	qAla=0;
  	
	/** Saa viittauksen pikkunaan ja thn menness luettujen rivien mrn */
	public ParameterDistribution(JavistPaaikkuna k, int r) 
	{
		kontrolli = k;
  		laskenta=new Jakaumalaskenta(true);   
		riveja = r;   
		addForwardedAttributes();
		// sie luodaan ja kynnistetn vlittmsti.
		// pysytettava alustetaan arvolla 1, jolloin run-metodi
		// j odottamaan.
		t = new Thread(this);
		t.start();
	}
 
	/**	Sikeen t metodi. Hoitaa piirtmisen omana sikeenn */  
  	public void run()
	{
  		int r = 0;
  		while(true)
  		{
			r = rivejaKertynyt();  		
  			riveja += r;
  			if (piirraUudelleen && laskeUudelleen) piirto.piirraUudelleen(riveja, true);
			else
			{
				if (r > 0) piirto.piirraLisaykset(r);
				if (piirraUudelleen) piirto.piirraUudelleen(riveja, false);
			}
  			haeTunnusluvut();
		}
	}

	// ++++++ Synkronisoidut metodit +++++++++++

	/** Palauttaa kontrollista tulleiden rivien mrn. 
		Jos rivej ei ole tullut ja piirrettavaUudelleen ja laskettavaUudelleen == false
		tai pysayttettava>0 j odottamaan.
	*/
	private synchronized int rivejaKertynyt()
	{
		int r = uusiaRiveja;
		boolean toimeton = !(piirrettavaUudelleen || laskettavaUudelleen || (r > 0));
		if (toimeton  || (pysaytettava > 0))
		{
			pysahtynyt = true;
			if (odottamassa)
			{
				notifyAll();				// vapauttaa kaikki odota() - metodissa olevat sikeet
				odottamassa = false;
			}
			try { wait(); } catch (Exception e)
			{ System.out.println("rivejaKertynyt: wait exception"); System.exit(1); }
			r = uusiaRiveja;
		}
		piirraUudelleen = piirrettavaUudelleen; piirrettavaUudelleen = false;
		laskeUudelleen = laskettavaUudelleen; laskettavaUudelleen = false;
		uusiaRiveja = 0;
		return r;
	}
  
	/** Lisaa uusien rivien mrn.*/
	public synchronized  void tullutUusiaRiveja(int r)
	{
		uusiaRiveja += r;
		if ((pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; } 
	}
  
	/** ilmoittaa, ett ei saa aloittaa uutta laskentaa */ 
	public synchronized void pysayta()
	{	
  		pysaytettava++;
	}

	/** palauttaa kontrollin vasta kun piirto on pysaytetty */
	public synchronized void odota()
	{
		if (!pysahtynyt)
		{
			odottamassa = true;
			try { wait(); } catch (Exception e)
			{ System.out.println("odota: wait exception"); System.exit(1); }
		}
	}

	/** Jatkaa pysayta metodilla pysaytettya toimintoa*/
	public synchronized void jatka()
	{
		if ((--pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; }
	}

	/** Tilaa uudelleen piirron */
	private synchronized void tilaaUudelleenpiirto()
	{
		piirrettavaUudelleen = true;
		if ((pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; }
	}

	/** Pst piirto sikeen jatkamaan kun valinnat on tehty */
	private synchronized void valinnatTehty()
	{
		varattu=false;
		piirrettavaUudelleen = laskettavaUudelleen = true;
		if ((--pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; }
	}
  	
	/** muuttaa rivien mr ja kertoo piirrolle karsinnasta
  		kertoo mys, ett on syyt piirt ja laskea uudelleen 
  	*/
  	public synchronized void rivitMuuttuneet(int r, int alusta, int askel)
	{
 		haeKentat(); 
 		riveja = r;
		uusiaRiveja = 0;
 		piirrettavaUudelleen = laskettavaUudelleen = true;
 	}
  
  
 	/** Hakee ja kirjoittaa kaavion tunnusluvut graphview ikkunaan*/ 
	public void haeTunnusluvut()
 	{
  		gui.lblParameterDistributionAboveRange.set("text",""+(laskenta.annaKertyma(laskenta.annaLkm()+1)));
  		gui.lblParameterDistributionBelowRange.set("text",""+(laskenta.annaKertyma(0)));
  		gui.lblParameterDistributionHajonta.set("text",""+laskenta.annaKeskihajonta());;
  	 	gui.lblParameterDistributionKeskiarvo.set("text",""+laskenta.annaKeskiarvo());
   		gui.lblParameterDistributionMaksimi.set("text",""+laskenta.annaMax());
   		gui.lblParameterDistributionMinimi.set("text",""+laskenta.annaMin());
   		gui.lblParameterDistributionRowsProsessed.set("text",""+laskenta.rivejaKaytetty());
   		gui.lblParameterDistributionNumberOfSweeps.set("text",""+riveja);
   		gui.lblParameterDistributionVarianssi.set("text",""+laskenta.annaVarianssi());
   		
   		if(kvantiilit)//piirretaan kvantiilit ruudulle
   		{
   			if(tarkatKvantiilit)
   			{
   				gui.lblParameterDistributionQuantileHighValue.set("text",""+laskenta.annaTarkkaYlakvantiili());
   				gui.lblParameterDistributionQuantileLowValue.set("text",""+laskenta.annaTarkkaAlakvantiili());
				gui.lblParameterDistributionMediaani.set("text",""+laskenta.annaTarkkaMediaani()); 
  			}		
   			else
   			{
   				gui.lblParameterDistributionQuantileHighValue.set("text",""+laskenta.annaKeskiX(laskenta.annaYlakvantiili()));
   				gui.lblParameterDistributionQuantileLowValue.set("text",""+laskenta.annaKeskiX(laskenta.annaAlakvantiili()));
				gui.lblParameterDistributionMediaani.set("text",""+laskenta.annaKeskiX(laskenta.annaMediaani())); 
   			}
   		}
   	}
	
	/** Tarkistaa onko kaaviossa valittuna oleva kentt viel datanhallinnassa.
  		Jos ei ole, niin tehdn "itsemurha" */
  	public void tarkistaKentat()
  	{
		if(kontrolli.dh.onMuistissa(valittuIndeksi))
			haeKentat();
		else
			kontrolli.tapaMut(this);
  	}
  
  
  	/** Suoritetaan, kun Print-nappulaa painetaan. Kysyy kyttjlt tiedostot, joihin 
  		tulostetaan
  	*/  
  	public void buttParameterDistributionPrintClick(Message msg, Event evt)
	{	
 	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  	//MUISTA KERTOA PYLVIDEN LUKUMR
	// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	//true == kaavio
  	//false== tunnusluvut
  		
  		if(varattu) return;
  		else
  			varattu=true;
  		String dir="";
	  	String file="";
	  	List list1 = (List)kontrolli.gui.list1.getBody();
  	  
     	pysayta();odota();	
     	// kuvan tulostus
		kontrolli.gui.filedialog1.set("title","Print picture");
		kontrolli.gui.filedialog1.show();
  	  	FileDialog apu=(FileDialog)kontrolli.gui.filedialog1.getBody();
  	  	apu.setMode(FileDialog.SAVE);
  	  	dir = (String)kontrolli.gui.filedialog1.get("directory");
		file = (String)kontrolli.gui.filedialog1.get("file");   
	 
	  	if(file!=null)
	  	{
  	  		new
  	  		HistogrammiTulostus(""+dir+file,true,laskenta,valittuString,laskenta.annaLkm(),
  	  						qAla, qYla);
  	  	}
  	  
  		dir=null;file=null;
  		
  		// tunnuslukujen tulostus
  		kontrolli.gui.filedialog1.set("title","Print statistics");
		kontrolli.gui.filedialog1.show();
  	  	apu=(FileDialog)kontrolli.gui.filedialog1.getBody();
  	  	apu.setMode(FileDialog.SAVE);
  	  	dir = (String)kontrolli.gui.filedialog1.get("directory");
		file = (String)kontrolli.gui.filedialog1.get("file");   
		if(file!=null)
	  	{
	 		new
	 		HistogrammiTulostus(""+dir+file,false,laskenta,valittuString,laskenta.annaLkm(),
	 						qAla, qYla);
  	  	}
  	  
  		dir=null;file=null;	

		tilaaUudelleenpiirto();
		jatka();
		varattu=false;
	}
    
	/** Suoritetaan, kun Settings-nappulaa painetaan.*/  
	public void buttParameterDistributionSettingsClick(Message msg, Event evt)
	{
		if(varattu)return;
		else
			varattu=true;
		if (asetuksetOk) pysayta();
		valittuString=kontrolli.dh.annaKentanNimi(valittuIndeksi);
		gui.dialParameterDistributionSettings.show();
	}
	
	/** Suoritetaan, kun Close-nappulaa painetaan. */ 
	public void buttParameterDistributionCloseClick(Message msg, Event evt)
	{
		kontrolli.tapaMut(this);
	}
     
	 /** Kutsutaan vastaavaa "nappula-painettu" metodia */
	public void menuitemParameterDistributionFilePrintClick(Message msg, Event evt)
	{
    		buttParameterDistributionPrintClick(msg,evt);
 	}
     
	/** Kutsutaan vastaavaa "nappula-painettu" metodia */
	public void menuitemParameterDistributionFileCloseClick(Message msg, Event evt)
	{
 		buttParameterDistributionCloseClick(msg,evt);
	}
     
	/** Kutsutaan vastaavaa "nappula-painettu" metodia */
	public void menuitemParameterDistributionGraphSettingsClick(Message msg, Event evt)
	{
 		buttParameterDistributionSettingsClick( msg,evt);
	}
     
	/** Haetaan kyttjn valitseman list-indeksin todellinen indeksi */
	public void listParameterDistributionSettingsClick(Message msg, Event evt)
	{
		Label valittu=(Label)gui.lblParameterDistributionSettingsChosenAttribute.getBody();
 		List list=(List)gui.listParameterDistributionSettings.getBody();
	  	valittuIndeksi=indeksit[list.getSelectedIndex()];
  		valittuString=list.getSelectedItem();
  		valittu.setText(valittuString);	
  	  	valittuna=1;
  	}
    
 	 /** Suoritetaan, kun Settings ikkunan Ok-nappulaa painetaan.
    	 Jos piirtoa ei ole viel luotu luodaan piirto ja sie t. 
    	 Lisksi haetaan kyttjn antamat tiedot. Jos tiedot ovat oikeelliset ja 
    	 valittu ei ole funktio kutsutaan valinnatTehty metodia. Jos tiedot ovat 
    	 oikeelliset ja valittu on funktio jtetn valinnatTehty metodin kutsu 
    	 haeFunktion tiedot metodin suoritettavaksi.   
 	*/
	public void buttParameterDistributionSettingsOkClick(Message msg, Event evt)
	{
		int poistettu=0;
  	 	int askel=1;
  
		odota();	 	
  	 	if(valittuna==1)
  		{
  			Dialog dialogi=(Dialog)gui.dialParameterDistributionSettings.getBody();// settings dialogi
 	 		Dialog dialogi1=(Dialog)gui.dialParameterDistributionSelections.getBody();// funktio dialogi
 	 		boolean onFunktio=false;
 	 
 	 		// asetetaan akselien nimet
  	 		Label yAkseli=(Label)gui.lblParameterDistributionAkseliHigh.getBody();
  	 		yAkseli.setText("");
	 
	 		Label xAkseli=(Label)gui.lblParameterDistributionAkseliLow.getBody();
	 		xAkseli.setText(valittuString);
 	
  	 		// asetetaan graph-ikkunaan parametrin nimi
  	 		gui.lblParameterDistribution.set("text",valittuString);
  	 		
  	 		if(piirto==null)
  	 		{
  	 			VJCanvas vjcanvas = (VJCanvas)gui.canvParameterDistribution.getBody();
    			g = vjcanvas.getGraphics();
    			laskenta.valitseKentta(valittuIndeksi);
    			piirto= new HistogrammiPiirto(g,laskenta);
  	 	 		if(haeTiedot())//hakee ja tarkistaa kyttjn antamat tiedot
 	 			{
 	 				// kysytn onko valittu funktio
 		 			if(kontrolli.dh.onFunktio(valittuIndeksi))
 		 				onFunktio=true;
 		 			if(onFunktio)
 	 				{			
 	 		 	 		// valitun kentn nimi
 	 					gui.dialParameterDistributionSelections.show();
 	 		 			gui.gbpanel42.set("layoutName",valittuString);
 	 					// gbpanel42 on funktio dialogin kentt mihin tulee 
						// valittu parametri
 	 			 	}
					if(!onFunktio) 	
		 			// jos valittu on funktio, ei kynnistet piirtoa
		 			//ennen kuin funktion tiedot on mritetty
		 			{
	 					gui.dialParameterDistributionSettings.hide();
						asetuksetOk = true;
						valinnatTehty();
					}
  				 } // if (haeTiedot())
  			}//if(piirto==null)
			else
			{
				laskenta.valitseKentta(valittuIndeksi);
	 			if(haeTiedot())//hakee ja tarkistaa kyttjn antamat tiedot
 	 	 		{
					if(kontrolli.dh.onFunktio(valittuIndeksi))
						onFunktio=true; 	 	
 		 			// kysytn onko valittu funktio
 					if(onFunktio)
 	 				{			
 	 		 	 		// valitun kentn nimi
 	 					gui.dialParameterDistributionSelections.show();
 	 					gui.gbpanel42.set("layoutName",valittuString);
 	 					// gbpanel42 on funktio dialogin kentt mihin tulee 
						// valittu parametri
					}
 					if(!onFunktio)
 	 				// jos valittu on funktio, ei kynnistet piirtoa
		 			//ennen kuin funktion tiedot on mritetty
 	 				{
 	 					gui.dialParameterDistributionSettings.hide();
						asetuksetOk = true;
						valinnatTehty();
  					}
  				}
			}
		}//if(valittuna==1)	
    		else
    			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.VALITSEYKSI,JavistPaaikkuna.FOO);
	}
    
	/** Hakee ja tarkistaa kyttjn antamat tiedot. */
	public boolean haeTiedot()
  	{
  		float xYla=0;
  		float xAla=0;
  		float yYla=0;
  		float yAla=0;  		
		float	qProsentti=0;
  		float leveys=0;
  		int kappaletta=0;
  		boolean syoteOk=false;
  		String xYlaString;
  		String xAlaString;
  		String yYlaString;
  		String yAlaString;
  	   	String poisString;
  	   	String askelString;
  	   	String QuantilesYlaString;
  	   	String QuantilesAlaString;
  	   	String QuantilesProsenttiString;
  		String leveysString;
  		String kappalettaString;
  		//karsinta
  		TextField txtAskel=(TextField)gui.txtParameterDistributionIncludeRows.getBody();
  		TextField txtPois=(TextField)gui.txtParameterDistributionRemoveRows.getBody();
  		// nkyv alue
  		TextField txtXYla=(TextField)gui.txtParameterDistributionSettingsVisibleAreaXHigh.getBody(); 
  		TextField txtXAla=(TextField)gui.txtParameterDistributionSettingsVisibleAreaXLow.getBody();
  		//kvantiilit
  		TextField txtQuantilesYla=(TextField)gui.txtParameterDistributionQuantilesRangeHigh.getBody();
  		TextField txtQuantilesAla=(TextField)gui.txtParameterDistributionQuantilesRangeLow.getBody();
  		TextField txtQuantilesProsentti=(TextField)gui.txtParameterDistributionQuantilesPercent.getBody();
  		//pilarit
  		TextField txtKappaletta=(TextField)gui.txtParameterDistributionSettingsPilarsPieces.getBody();
  		TextField txtLeveys=(TextField)gui.txtParameterDistributionSettingsPilarsWidth.getBody();
  		Checkbox autom=(Checkbox)gui.chboxParameterDistributionVisibleAreaAutomatic.getBody();
  		Checkbox prosentti=(Checkbox)gui.radioParameterDistributionQuantilesPercent.getBody();
  		Checkbox piirretaanKvantiilit=(Checkbox)gui.chboxParameterDistributionQuantilesDraw.getBody();;
  		Checkbox pilarinLeveys=(Checkbox)gui.radioParameterDistributionSettingsPilarsWidth.getBody();
  		Checkbox tarkat=(Checkbox)gui.chboxParameterDistributionQuantilesExactValues.getBody();
  		
  		// luokkamuuttujia
  		qYla=0;
		qAla=0;
  		// luokkamuuttujia printtausta varten
  		kvantiilit=false;
  		tarkatKvantiilit=false;
  		try
  		{
  			askelString=txtAskel.getText();
  			poisString=txtPois.getText();
  			askel=Integer.parseInt(askelString);
  			poistettu=Integer.parseInt(poisString);
  			if(askel<=0||poistettu<0)
  			{
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				return false;
  			}
  		
  		}
  		catch(NumberFormatException e)
  		{ 
  			
  			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  			return false;
  		}
  		try
  		{
  			xYlaString=txtXYla.getText();
  			xAlaString=txtXAla.getText();
  			//askel ja poistettu luokkamuuttujia
  			if(!autom.getState())
  			{
  				xYla=new Float(xYlaString).floatValue();
  				xAla=new Float(xAlaString).floatValue();
  				if(xAla<xYla)
  					syoteOk=true;
  				else
  				{
  					JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);			
  					return false;
  				}
  			}
  			
  		}
  		catch(NumberFormatException e)
  		{ 
  			if(autom.getState())
  				syoteOk=true;
  			else	
  			{
  				
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				return false;
  			}
  		}	
  		try
		{	
  			if(pilarinLeveys.getState())
  			{
	 			leveysString=txtLeveys.getText(); 			
  				leveys=new Float(leveysString).floatValue();				 			
				if(leveys>0)
					syoteOk=true;  			
  				else
  				{
  					
  					JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  					return false;
  				}
  			}
  			else
  			{
  				kappalettaString=txtKappaletta.getText();
  				kappaletta=Integer.parseInt(kappalettaString);
  				if(kappaletta>0)
  					syoteOk=true;  			
  				else
  				{
  					
  					JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  					return false;
  				}
  			}
  		}
  		catch(NumberFormatException e)
  		{ 	
  				
  			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  			return false;
  		}		
  		
  		if(syoteOk&&piirretaanKvantiilit.getState())
  		{
  			kvantiilit=true;
  			try
  			{	
  				syoteOk=false;
  				if(prosentti.getState())
  				{	
  					QuantilesProsenttiString=txtQuantilesProsentti.getText();
					qProsentti=new Float(QuantilesProsenttiString).floatValue();  			
  					if((qProsentti<=100)&&(qProsentti>=0))			
  					{
  						qYla=50+0.5f*qProsentti;
  						qAla=50-0.5f*qProsentti;
  						syoteOk=true;
  				
  					}
  					else
  					{
  						JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  						return false;
  					}
  				}
  				else
  				{
  					QuantilesYlaString=txtQuantilesYla.getText();
  	   				QuantilesAlaString=txtQuantilesAla.getText();;
  		   			qYla=new Float(QuantilesYlaString).floatValue();
  	      				qAla= new Float(QuantilesAlaString).floatValue();
  	      				if( (qYla>=qAla)&&(qYla>=0)&&(qYla<=100)&&(qAla>=0)&&(qAla<=100))
  	      					syoteOk=true;	
  	      				else
  	      				{	
  	      					JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  	      					return false;
  	      				}
  	      		}	
  			}
  			catch(NumberFormatException e)
  			{ 
  					
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				return false;
  			}
 		}
  		if(syoteOk)
  		{
  			gui.lblParameterDistributionRowsIncluded.set("text","");
  			gui.lblParameterDistributionRowsRemoved.set("text","");
  			gui.lblParameterDistributionRowsIncluded.set("text",""+kontrolli.dh.absKarsintaAskel()*askel);
			gui.lblParameterDistributionRowsRemoved.set("text",""+kontrolli.dh.absKarsittuAlusta()+poistettu*kontrolli.dh.absKarsintaAskel());	
  			if(piirretaanKvantiilit.getState())
  			{
  				laskenta.asetaKvantiilit(0.01f*qAla,0.01f*qYla);
  				piirto.piirraKvantiilit(true,0.01f*qAla,0.01f*qYla);
  				if(tarkat.getState())
  				{
  					tarkatKvantiilit=true;
  					laskenta.laskeTarkatKvantiilit();
  					piirto.piirraTarkatKvantiilit(true);
  				
  				}
  				else
  					piirto.piirraTarkatKvantiilit(false);
  			}	
  			else
  			{	
  				piirto.piirraKvantiilit(false,0,0);
  				laskenta.asetaKvantiilit(Float.NaN,Float.NaN);
  			}	
  			laskenta.karsiRivit(poistettu,askel);
  			syoteOk=false;
  			if(pilarinLeveys.getState())
  				piirto.asetaPylvaidenLeveys(leveys);
  			else
  				piirto.asetaPylvaidenLkm(kappaletta);
  			if(!autom.getState())
  			//ei automaattinen
  			{
  				piirto.asetaAutomX(false);
 				piirto.asetaAutomY(true);
 				piirto.asetaAlarajaX(xAla);
  				piirto.asetaYlarajaX(xYla);
  				return true;
  			}
 			else
 			{
 				piirto.asetaAutomX(true);
 				piirto.asetaAutomY(true);
 				return true;
 			} 		
  		}
  		else
  			return false;	
  	}
  
  	/** Siin tapauksessa, ett kyttjn valitsema kentt on funktio,
  		 haetaan kyttn funktiosta antamat tiedot ja sytteiden ollessa oikeelliset 
  		 kutsutaan valinnatTehty metodia 
  	*/
  	public void haeFunktionTiedot()
  	{	
		String paloja;
  		String palaa;
  		String kohtaa;
 		int palojaInt=0; 
 		int palaaInt=0;
 		int kohtaaInt=0;
 		boolean syoteOk =false;		
  		
  		Checkbox seurataanLkm=(Checkbox)gui.radioParameterDistributionParam1TraceNumber.getBody();
  		Checkbox
  		seurataanPalaa=(Checkbox)gui.radioParameterDistributionP1TraceFunctionsTracePiece.getBody();
														  
  		TextField txtPaloja=(TextField)gui.txtParameterDistributionParam1TraceFunctionsPcs.getBody();
  		TextField txtKohtaa=(TextField)gui.txtParameterDistributionP1TraceFunctionsTracePlace.getBody();
  		TextField txtPalaa=(TextField)gui.txtParameterDistributionP1TraceFunctionsTracePiece.getBody();
   		try{
   			if(!seurataanLkm.getState())
  			// kiinnitetn palalukumr
  			{	
  				paloja=txtPaloja.getText();
				palojaInt=Integer.parseInt(paloja);
			  			
  				if(seurataanPalaa.getState())
  				{	
  					palaa=txtPalaa.getText();	
  					palaaInt=Integer.parseInt(palaa);
  					if(palojaInt!=0&&palaaInt<=palojaInt&&palaaInt!=0)
  					{	
  						syoteOk=true;	
  				  		valittuString+="_level"+palaaInt;
  				  	}
  				  	else
  				  		JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);		
  				}
  				else	
				{
					// seurataan hyppykohtaa
					kohtaa=txtKohtaa.getText();
					kohtaaInt=Integer.parseInt(kohtaa);
  					if(palojaInt!=0&&kohtaaInt<palojaInt&&kohtaaInt!=0)
					{
						syoteOk=true;
						valittuString+="_level"+palaaInt;
					}
					else
						JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
				}
			}	  
  			else
			{	
				syoteOk=true;		
  				valittuString+="_pieces";
  			}
  		}//try
  		catch(NumberFormatException e)
  		{ 
  			syoteOk=false;
  			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  		}		
  		
  		if(syoteOk)
 		{ 		//Sytteet hyvksyttvi	
		  	syoteOk=false;
			if(seurataanLkm.getState())
				laskenta.valitseKentta(valittuIndeksi,0);
			else
			{
				laskenta.kiinnitaPalaLkm(valittuIndeksi,palojaInt);
				if(seurataanPalaa.getState())
					laskenta.valitseKentta(valittuIndeksi,2*palaaInt-1);
				else
					laskenta.valitseKentta(valittuIndeksi,2*kohtaaInt);
			}
				
			//funktionTiedotHaettu=true;
			gui.dialParameterDistributionSelections.hide();
	  		gui.dialParameterDistributionSettings.hide();
			asetuksetOk = true;
			valinnatTehty();
  		}
  	}
  
	/** Suoritetaan, kun Settings ikkunan cancel-nappulaa painetaan. */
	public void buttParameterDistributionSettingsCancelClick(Message msg, Event evt)
	{
  		varattu=false;
  		gui.dialParameterDistributionSettings.hide();
		if (asetuksetOk) jatka();
	}
	
	// Kyttmttmia action tapahtumia kalin objekteille
	public void txtParameterDistributionSettingsVisibleAreaXLowEnter(Message msg, Event evt){}
	public void txtParameterDistributionSettingsVisibleAreaXHighEnter(Message msg, Event evt){}
	public void chboxParameterDistributionVisibleAreaAutomaticClick(Message msg, Event evt){}
	public void radioParameterDistributionSettingsPilarsPiecesClick(Message msg, Event evt){}
	public void txtParameterDistributionSettingsPilarsPiecesEnter(Message msg, Event evt){}
	public void radioParameterDistributionSettingsPilarsWidth(Message msg, Event evt){}
	public void txtParameterDistributionSettingsPilarsWidthEnter(Message msg, Event evt){}
	public void txtParameterDistributionRemoveRowsEnter(Message msg, Event evt){}
	public void txtParameterDistributionIncludeRowsEnter(Message msg, Event evt){}
	public void chboxParameterDistributionQuantilesDrawClick(Message msg, Event evt){}
	public void radioParameterDistributionQuantilesRangeClick(Message msg, Event evt){}
	public void txtParameterDistributionQuantilesRangeLowEnter(Message msg, Event evt){}
	public void txtParameterDistributionQuantilesRangeHighEnter(Message msg, Event evt){}
	public void radioParameterDistributionQuantilesPercentClick(Message msg, Event evt){}
	public void txtParameterDistributionQuantilesPercentEnter(Message msg, Event evt){}
	public void radioParameterDistributionP1TraceFunctionsTracePieceClick(Message msg, Event evt){}  
	public void radioParameterDistributionSettingsPilarsWidthClick(Message msg, Event evt){}    
	public void chboxParameterDistributionQuantilesExactValuesClick(Message msg, Event evt){} 
	public void radioParameterDistributionParam1TraceNumberClick(Message msg, Event evt){}
	public void radioParameterDistributionParam1TraceFunctionsClick(Message msg, Event evt){}
	public void txtParameterDistributionParam1TraceFunctionsPcsEnter(Message msg, Event evt){}
	public void txtParameterDistributionP1TraceFunctionsTracePieceEnter(Message msg, Event evt){}
	public void radioParameterDistributionP1TraceFunctionsTracePlaceClick(Message msg, Event evt){}   	public void txtParameterDistributionP1TraceFunctionsTracePlaceEnter(Message msg, Event evt){}
     
	/** Suoritetaan, kun Selections ikkunan Ok-nappulaa painetaan.*/
	public void buttParameterDistributionSelectionsOkClick(Message msg, Event evt)
	{
    		haeFunktionTiedot();
	}
	  
	
  	protected Root initRoot() 
  	{
		gui = new ParameterDistributionRoot(this);
		addAttributeForward(gui.getMainChild());
		return gui;	
  	}	
	
  	protected void initGroup() { }	
  	protected void showGroup() { }	
 	protected void hideGroup() { }	
  	
  	/** Hakee datanhallinnalta muistissa olevat kentt */
  	public void haeKentat()
	{
		List list=(List)gui.listParameterDistributionSettings.getBody();
 		int apu=kontrolli.dh.annaKenttienLkm();		   
		list.removeAll();	   
		indeksit=new int[apu];// taulukkoon merkataan listboksissa 
		   							 // olevien parametrien indeksit
		int j=0;//listboksin indeksi
		for (int i=0;i<apu;i++)
		{			
			if(list!=null&&kontrolli.dh.onMuistissa(i))
			{
				list.addItem(kontrolli.dh.annaKentanNimi(i));
				indeksit[j]=i;
				j++;
			}				    
		 }
  		gui.txtParameterDistributionIncludeRows.set("text",""+askel);
  		gui.txtParameterDistributionRemoveRows.set("text",""+poistettu);
  		gui.lblParameterDistributionRowsIncluded.set("text","");
  		gui.lblParameterDistributionRowsRemoved.set("text","");
  		gui.lblParameterDistributionRowsIncluded.set("text",""+(kontrolli.dh.absKarsintaAskel()*askel));
		gui.lblParameterDistributionRowsRemoved.set("text",""+(kontrolli.dh.absKarsittuAlusta()+poistettu*kontrolli.dh.absKarsintaAskel()));	
  	}
  
  	/** Suoritetaan vhn ennenkuin kyttliittym tulee nkyviin. 
  		Suorittaa alustuksia.
  	*/
  	protected void createGroup()
  	{
  		haeKentat();
  		// alustetaan labelit
  		gui.lblParameterDistributionRowsIncluded.set("text","   "+(kontrolli.dh.absKarsintaAskel()*askel)+"   ");
  		gui.lblParameterDistributionRowsRemoved.set("text","   "+(kontrolli.dh.absKarsittuAlusta()+poistettu*kontrolli.dh.absKarsintaAskel())+"   ");
  		gui.txtParameterDistributionSettingsPilarsPieces.set("text",""+100);
  		gui.lblParameterDistributionAkseliHigh.set("text","                                        ");
  	 	gui.lblParameterDistributionAkseliLow.set("text","                                        ");
	 	gui.lblParameterDistributionAboveRange.set("text","              ");
  		gui.lblParameterDistributionBelowRange.set("text","              ");
  		gui.lblParameterDistributionHajonta.set("text","              ");;
  	 	gui.lblParameterDistributionKeskiarvo.set("text","              ");
   		gui.lblParameterDistributionMaksimi.set("text","              ");
   		gui.lblParameterDistributionMinimi.set("text","              ");
   		gui.lblParameterDistributionRowsProsessed.set("text","              ");
   		gui.lblParameterDistributionNumberOfSweeps.set("text","              ");
   		gui.lblParameterDistributionVarianssi.set("text","              ");
   		gui.lblParameterDistributionQuantileHighValue.set("text","              ");
   		gui.lblParameterDistributionQuantileLowValue.set("text","              ");
		gui.lblParameterDistributionMediaani.set("text","              "); 
  		
   	
  	}
  
  	protected void destroyGroup() { }	
  	protected void startGroup() { }	
	protected void stopGroup() { }	

  	protected Object getOnGroup(String key)
  	{	
    		return super.getOnGroup(key);	
  	}	

 	protected void setOnGroup(String key, Object value)
 	{	
	    	super.setOnGroup(key, value);	
  	}	

  	public boolean handleMessage(Message msg) 
  	{
	    	return super.handleMessage(msg);
  	}

  	/** Yleinen tapahtumanksittely metodi. */
	public boolean handleEvent(Message msg, Event evt) 	
  	{
  		switch (evt.id) 
		{
      			case 2567:	// PAINT_EVENT
			{
         			if (msg.target == gui.canvParameterDistribution) 
            				tilaaUudelleenpiirto();
				break;
			}
		  	case 701: //listaa npytetty
		  	{
				if(msg.target==gui.listParameterDistributionSettings)
				{
					listParameterDistributionSettingsClick( msg,evt);		
				}
				break;
		 	}
		}

		if(evt.id!=java.awt.event.WindowEvent.WINDOW_CLOSING)
			return super.handleEvent(msg, evt);
  		else
  			return true;
  	}
}

