import sunsoft.jws.visual.rt.base.*;
import sunsoft.jws.visual.rt.shadow.java.awt.*;
import java.awt.*;
import laskenta.*;
import kaavio.*;
import sunsoft.jws.visual.rt.shadow.VJCanvasShadow;
import sunsoft.jws.visual.rt.awt.*;

/** Hoitaa Kaavioikkunan tapahtumanksittelyn ja piirtosikeen
	synkronoinnin
*/
public class PieceWise extends Group implements Runnable
{
  	public PieceWiseRoot gui;
  	private Graphics g;
  	private Funktiolaskenta laskenta;
  	private PaloittainvakionPiirto piirto;
  	private Thread t; //sie joka hoitaa piirtmisen 		
	private JavistPaaikkuna kontrolli;// viittaus pikkunaan 		
  	private int valittuIndeksi; // kertoo piirrettvn parametrin indeksin 		
  	private int[] indeksit; /* tll silytetn listboksissa olevien 
  								parametrien todelliset (datanhallinnan) indeksit */
  	private String valittuString; //valitun kentn nimi 
  	private int valittuna=0; // valittuna olevien kenttien lkm
	private int riveja=0; // tiedossa olevien rivien lkm
  	private int askel=1; // kaavion sisisen karsinnan askel
  	private int poistettu=0; //kaavion sisisen karsinnan rivimr
  	private int uusiaRiveja=0; // uusien rivien lkm
  	private boolean pysahtynyt = false; // onko pyshtynyt
	private boolean odottamassa = false; // onko odottamassa
	private int pysaytettava = 1; // pysaytettavien lkm
	private boolean asetuksetOk = false;
	private boolean laskettavaUudelleen = true; 
	private boolean piirrettavaUudelleen = true;
	private boolean laskeUudelleen; 
	private boolean piirraUudelleen;
 	private int pisteet=200;	// laskentapisteet
	private boolean kvantiilit=false;	//piirretnk kvantiilit
   	private boolean tarkatKvantiilit=false;
   	private float	qYla=0;// kavantiilit
  	private	float	qAla=0;
  	private boolean varattu=true;// saako settings / print ikkunan avata	
  	/** Saa viittauksen pikkunaan ja thn menness luettujen rivien mrn */
  	public PieceWise(JavistPaaikkuna k, int r) 
  	{
  		kontrolli = k;
  		laskenta = new Funktiolaskenta(true);   
		riveja= r;   
		addForwardedAttributes();
		// sie luodaan ja kynnistetn vlittmsti.
		// pysaytettava alustetaan arvolla 1, jolloin run-metodi
		// j odottamaan.
		t = new Thread(this);
		t.start();
  	}

	/**	Sikeen t metodi. Hoitaa piirtmisen omana sikeenn */  
  	public void run()
	{
  		int r ;
  		while(true)
  		{
			r = rivejaKertynyt();  		
  			riveja += r;
  			if (piirraUudelleen && laskeUudelleen) piirto.piirraUudelleen(riveja, true);
			else
			{
				if (r > 0) piirto.piirraLisaykset(r);
				if (piirraUudelleen) piirto.piirraUudelleen(riveja, false);
			}
  			haeTunnusluvut();
		}
	}

	// ++++++ Synkronisoidut metodit +++++++++++

	/** Palauttaa kontrollista tulleiden rivien mrn. 
		Jos rivej ei ole tullut ja piirrettavaUudelleen ja laskettavaUudelleen == false
		tai pysayttettava>0 j odottamaan.
	*/
	private synchronized int rivejaKertynyt()
	{
		int r = uusiaRiveja;
		boolean toimeton = !(piirrettavaUudelleen || laskettavaUudelleen || (r > 0));
		if (toimeton  || (pysaytettava > 0))
		{
			pysahtynyt = true;
			if (odottamassa)
			{
				notifyAll();				// vapauttaa kaikki odota() - metodissa olevat sikeet
				odottamassa = false;
			}
			try { wait(); } catch (Exception e)
			{ System.out.println("rivejaKertynyt: wait exception"); System.exit(1); }
			r = uusiaRiveja;
		}
		piirraUudelleen = piirrettavaUudelleen; piirrettavaUudelleen = false;
		laskeUudelleen = laskettavaUudelleen; laskettavaUudelleen = false;
		uusiaRiveja = 0;
		return r;
	}
  
	/** Lisaa uusien rivien mrn.*/
	public synchronized  void tullutUusiaRiveja(int r)
	{
		uusiaRiveja += r;
		if ((pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; } 
	}
  
	/** ilmoittaa, ett ei saa aloittaa uutta laskentaa */ 
	public synchronized void pysayta()
	{	
  		pysaytettava++;
	}

	/** palauttaa kontrollin vasta kun piirto on pysaytetty */
	public synchronized void odota()
	{
		if (!pysahtynyt)
		{
			odottamassa = true;
			try { wait(); } catch (Exception e)
			{ System.out.println("odota: wait exception"); System.exit(1); }
		}
	}

	/** Jatkaa pysayta metodilla pysaytettya toimintoa*/
	public synchronized void jatka()
	{
		if ((--pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; }
	}

	/** Tilaa uudelleen piirron */
	private synchronized void tilaaUudelleenpiirto()
	{
		piirrettavaUudelleen = true;
		if ((pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; }
	}

	/** Pst piirtosikeen jatkamaan kun valinnat on tehty */
	private synchronized void valinnatTehty()
	{
		varattu=false;
		piirrettavaUudelleen = laskettavaUudelleen = true;
		if ((--pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; }
	}

	/** muuttaa rivien mr ja kertoo piirrolle karsinnasta
  		kertoo mys, ett on syyt piirt ja laskea uudelleen 
  	*/
  	public synchronized void rivitMuuttuneet(int r, int alusta, int askel)
	{
 		haeKentat(); 
 		
 		riveja = r;
		uusiaRiveja = 0;
 		piirrettavaUudelleen = laskettavaUudelleen = true;
 	}

	/** Hakee ja kirjoittaa kaavion tunnusluvut graphview ikkunaan*/ 
 	public void haeTunnusluvut()
  	{
  		gui.lblPieceWiseNumberOfSweeps.set("text",""+riveja);
  		gui.lblPieceWiseRowsProsessed.set("text",""+laskenta.rivejaKaytetty());
  	}

	public void tarkistaKentat()
	{
		if(kontrolli.dh.onMuistissa(valittuIndeksi))
			haeKentat();
		else
			kontrolli.tapaMut(this);
	}
  
    
	/** Suoritetaan, kun Print-nappulaa painetaan. Kysyy kyttjlt tieedostot, joihin 
  		tulostetaan
  	*/
	public void buttPieceWisePrintClick(Message msg, Event evt)
	{
		//true == kaavio
  		//false == luvut
  		
  		if(varattu)return;
		else
			varattu=true;
		
  		String dir="";
		String file="";
	  	List list1 = (List)kontrolli.gui.list1.getBody();
  	  	pysayta();odota();
  	  	// kuvan tulostus
		kontrolli.gui.filedialog1.set("title","Print picture");
		kontrolli.gui.filedialog1.show();
  	  	FileDialog apu=(FileDialog)kontrolli.gui.filedialog1.getBody();
  	  	apu.setMode(FileDialog.SAVE);
  	  	dir = (String)kontrolli.gui.filedialog1.get("directory");
		file = (String)kontrolli.gui.filedialog1.get("file");   
	 	if(file!=null)
	  	{
	 		if(kvantiilit)
	 			new PaloittainvakionTulostus(""+dir+file,true,laskenta,valittuString,qAla,qYla);
  	  		else
  	  			new PaloittainvakionTulostus(""+dir+file,true,laskenta,valittuString);
  	  	}
  		dir=null;file=null;
  		
  		
  		/*
  		// tunnuslukujen tulostus
  		kontrolli.gui.filedialog1.set("title","Print statistics");
		kontrolli.gui.filedialog1.show();
  	  	apu=(FileDialog)kontrolli.gui.filedialog1.getBody();
  	  	apu.setMode(FileDialog.SAVE);
  	  	dir = (String)kontrolli.gui.filedialog1.get("directory");
		file = (String)kontrolli.gui.filedialog1.get("file");   
	 	if(file!=null)
	  	{
	 		new PaloittainvakionTulostus(""+dir+file,true,laskenta,valittuString);
  	  	}
  		dir=null;file=null;	
 		*/
		tilaaUudelleenpiirto();
 		jatka();
 		varattu=false;
 	}
    
	/** Suoritetaan, kun Settings-nappulaa painetaan.*/
	public void buttPieceWiseSettingsClick(Message msg, Event evt)
	{
		if(varattu)return;
		else
			varattu=true;
		valittuString=""+kontrolli.dh.annaKentanNimi(valittuIndeksi);
 	 	if (asetuksetOk) pysayta();
 	 		gui.dialPieceWiseSettings.show();
	}
    
	/** Suoritetaan, kun Settings-nappulaa painetaan.*/
	public void buttPieceWiseCloseClick(Message msg, Event evt)
	{
		kontrolli.tapaMut(this);
	}
    
	/** Kutsutaan vastaavaa "nappula-painettu" metodia */
	public void menuitemPieceWiseFilePrintClick(Message msg, Event evt)
	{
		buttPieceWisePrintClick(msg,evt);
	}
    
	 /** Kutsutaan vastaavaa "nappula-painettu" metodia */
	public void menuitemPieceWiseFileCloseClick(Message msg, Event evt)
	{
		buttPieceWiseCloseClick(msg,evt);
	}
    
	/** Kutsutaan vastaavaa "nappula-painettu" metodia */
	public void menuitemPieceWiseGraphSettingsClick(Message msg, Event evt)
	{
		buttPieceWiseSettingsClick(msg,evt);
	}
    
	/** Haetaan kyttjn valitseman list-indeksin todellinen indeksi */
	public void listPieceWiseSettingsClick(Message msg, Event evt)
	{
		Label valittu=(Label)gui.lblPieceWiseSettingsChosenAttributeX.getBody();
 		List list=(List)gui.listPieceWiseSettings.getBody();
	  	valittuIndeksi=indeksit[list.getSelectedIndex()];
  		valittuString=list.getSelectedItem();
  		valittu.setText(valittuString);	
 		valittuna=1;
  		if(!Float.isNaN(kontrolli.dh.annaAlaraja(valittuIndeksi)))
  		{
  			float maarittelyAla=kontrolli.dh.annaAlaraja(valittuIndeksi);
  			float maarittelyYla=kontrolli.dh.annaYlaraja(valittuIndeksi);
			gui.txtPieceWiseSettingsRangeXLow.set("text",""+maarittelyAla);
    			gui.txtPieceWiseSettingsRangeXHigh.set("text",""+maarittelyYla);
		}
	}

   	/** Suoritetaan, kun Settings ikkunan Ok-nappulaa painetaan.
    	Jos piirtoa ei ole viel luotu luodaan piirto ja sie t. 
    	Lisksi haetaan kyttjn antamat tiedot. Jos tiedot ovat oikeelliset 
    	kutsutaan valinnatTehty metodia. 
	*/
	public void buttPieceWiseSettingsOkClick(Message msg, Event evt)
	{
		int poistettu=0;
  	 	int askel=1;
  	 	
		odota();	 
		if(valittuna==1)
  		{
  			Dialog dialogi=(Dialog)gui.dialPieceWiseSettings.getBody();// settings dialogi
 	 		boolean onFunktio=false;
 	 		String xnimi=null;
 	 	
 	 		// asetetaan akselien nimet
  	 		Label yAkseli=(Label)gui.lblPieceWiseAkseliHigh.getBody();
  	 		yAkseli.setText(valittuString);
	 
	 		Label xAkseli=(Label)gui.lblPieceWiseAkseliLow.getBody();
	 		xnimi=kontrolli.dh.annaXnimi(valittuIndeksi);
	 		if(xnimi!=null)
	 			xAkseli.setText(xnimi);
	 		else
	 			xAkseli.setText("x");	
 	
  	 		if(kontrolli.dh.onFunktio(valittuIndeksi))
 			{	
 				if(piirto==null)
  	 			{
  	 				VJCanvas vjcanvas = (VJCanvas)gui.canvPieceWise.getBody();
					g = vjcanvas.getGraphics();
					laskenta.valitseFunktio(valittuIndeksi);
    					poistettu=kontrolli.dh.absKarsittuAlusta();
  	 				askel=kontrolli.dh.absKarsintaAskel();
  	 				piirto= new PaloittainvakionPiirto(g,laskenta);

  	 	 			if(haeTiedot())//hakee ja tarkistaa kyttjn antamat tiedot
 	 				{
 	 					gui.dialPieceWiseSettings.hide();
						asetuksetOk = true;
						valinnatTehty();
					}//if(haeTiedot
  				}//if(piirto==null)
				else
				{
	 				laskenta.valitseFunktio(valittuIndeksi);
	 				if(haeTiedot())//hakee ja tarkistaa kyttjn antamat tiedot
 	 	 			{
						gui.dialPieceWiseSettings.hide();
						asetuksetOk = true;
						valinnatTehty();
  					}//if(haeTiedot)
  				}//else
			}//onFunktio
    
    		else
    			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.VALITSEFUNKTIO,JavistPaaikkuna.FOO);
    	}//if(valittuna=1)
    	else
    		JavistPaaikkuna.virheDialogi(JavistPaaikkuna.VALITSEYKSI,JavistPaaikkuna.FOO);
	}
     
	/** Hakee ja tarkistaa kyttjn antamat tiedot. */
	public boolean haeTiedot()
  	{
  		boolean syoteOk=false;
  		float xYla=0;
  		float xAla=0;
  		float yYla=0;
  		float yAla=0;
  		float maarittelyAla=0;
  		float maarittelyYla=0;
  		float	qProsentti=0;
  		float leveys=0;
  		int paloja=0;
  		String palojaString;
  		String xYlaString;
  		String xAlaString;
  		String yYlaString;
  		String yAlaString;
  	   	String poisString;
  	   	String askelString;
  	   	String pisteetString;
  	   	String maarittelyYlaString;
  	   	String maarittelyAlaString;
  	   	String QuantilesYlaString;
  	   	String QuantilesAlaString;
  	   	String QuantilesProsenttiString;
  		//laskenta pisteet
  		TextField txtPisteet=(TextField)gui.txtPieceWiseSettingsCountingPoints.getBody();
  		//karsinta
  		TextField txtAskel=(TextField)gui.txtPieceWiseIncludeRows.getBody();
  		TextField txtPois=(TextField)gui.txtPieceWiseRemoveRows.getBody();
  		// nkyv alue
  		TextField txtXYla=(TextField)gui.txtPieceWiseSettingsVisibleAreaXHigh.getBody(); 
  		TextField txtXAla=(TextField)gui.txtPieceWiseSettingsVisibleAreaXLow.getBody();
  		TextField txtYYla=(TextField)gui.txtPieceWiseSettingsVisibleAreaYHighEnter.getBody(); 
  		TextField txtYAla=(TextField)gui.txtPieceWiseSettingsVisibleAreaYLowEnter.getBody();
  		// mrittely alue
  		TextField txtMaarittelyAla=(TextField)gui.txtPieceWiseSettingsRangeXLow.getBody();
		TextField txtMaarittelyYla=(TextField)gui.txtPieceWiseSettingsRangeXHigh.getBody();
		//kvantiilit
  		TextField txtQuantilesYla=(TextField)gui.txtPieceWiseQuantilesRangeHigh.getBody();
  		TextField txtQuantilesAla=(TextField)gui.txtPieceWiseQuantilesRangeLow.getBody();
  		TextField txtQuantilesProsentti=(TextField)gui.txtPieceWiseQuantilesPercent.getBody();
  		TextField txtPaloja=(TextField)gui.txtPieceWiseParam1TraceFunctionsPcs.getBody();
  		Checkbox autom=(Checkbox)gui.chboxPieceWiseSettingsVisibleAreaAutomatic.getBody();
  		Checkbox automX=(Checkbox)gui.chboxPieceWiseSettingsVisibleAreaXAutomatic.getBody();
  		Checkbox kiinnitetaan=(Checkbox)gui.radioPieceWiseParam1TraceFunctions.getBody();
  		Checkbox prosentti=(Checkbox)gui.radioPieceWiseQuantilesPercent.getBody();
  		Checkbox piirretaanKvantiilit=(Checkbox)gui.chboxPieceWiseQuantilesDraw.getBody();;
  		Checkbox paloina=(Checkbox)gui.radioPieceWiseSettingsDrawPieces.getBody();
		Checkbox tarkat=(Checkbox)gui.chboxPieceWiseQuantilesExactValues.getBody();  		
  		
  		tarkatKvantiilit=false;
  		kvantiilit=false;//luokkamuuttuja printtausta varten
  		
  		try
  		{
			askelString=txtAskel.getText();
  			poisString=txtPois.getText();
  			//askel ja poistettu luokkamuuttujia
  			askel=Integer.parseInt(askelString);
  			poistettu=Integer.parseInt(poisString);
			if(askel<=0||poistettu<0)
			{ 
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				return false;
  			}
		}
  		catch(NumberFormatException e)
  		{ 
  			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  			return false;
  		}  		
  		
  		try
  		{
  			xYlaString=txtXYla.getText();
  			xAlaString=txtXAla.getText();
  			xYla=new Float(xYlaString).floatValue();
  			xAla=new Float(xAlaString).floatValue();
  			if(xAla<xYla)
  				syoteOk=true;
  			else
  			{	
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				return false;
  			}
  		
  		}
  		catch(NumberFormatException e)
  		{ 
  			if(automX.getState())
  				syoteOk=true;
  			else	
  			{
  				
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				return false;
  			}
  		}
  		
  			
  		try
  		{
  			yYlaString=txtYYla.getText();
  			yAlaString=txtYAla.getText();
  			
  			yYla=new Float(yYlaString).floatValue();
  			yAla=new Float(yAlaString).floatValue();
  			if(yAla<yYla)
  				syoteOk=true;
			else
			{	
				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);  		
  				return false;
  				
  			}
  		}
  		catch(NumberFormatException e)
  		{ 
  			if(autom.getState())
  				syoteOk=true;
  			else	
  			{
  				
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				return false;
  			}
  		}
  				
  		try
  		{
  			
  			pisteetString=txtPisteet.getText();
  			pisteet=Integer.parseInt(pisteetString);
  			
  			if(Float.isNaN(kontrolli.dh.annaAlaraja(valittuIndeksi)))
  			// headerissa ei annettu mrittely vleja
  			{
  				maarittelyAlaString=txtMaarittelyAla.getText();
  				maarittelyYlaString=txtMaarittelyYla.getText();
  				maarittelyYla=new Float(maarittelyYlaString).floatValue();
  				maarittelyAla=new Float(maarittelyAlaString).floatValue();
  			}
  			else
  			{
  				maarittelyAla=kontrolli.dh.annaAlaraja(valittuIndeksi);
  				maarittelyYla=kontrolli.dh.annaYlaraja(valittuIndeksi);
  			}
  			if(maarittelyAla<maarittelyYla)	
  				syoteOk=true;
  			else
  			{
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				return false;
  			}
  		
  			laskenta.asetaXJako(pisteet,maarittelyAla,maarittelyYla);
  			
  		}
  		catch(NumberFormatException e)
  		{ 
  			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  			return false;
  		}
  		
  		if(piirretaanKvantiilit.getState())
  		{
  			kvantiilit=true;//luokkamuuttuja printtausta varten
  			try
  			{	
  				syoteOk=false;
  			
  				if(prosentti.getState())
  				{	
  					QuantilesProsenttiString=txtQuantilesProsentti.getText();
					qProsentti=new Float(QuantilesProsenttiString).floatValue();  			
  					if((qProsentti<=100)&&(qProsentti>=0))			
  					{
  						qYla=50+0.5f*qProsentti;
  						qAla=50-0.5f*qProsentti;
  						syoteOk=true;
  				
  					}
  			
  					else
  					{	
  						JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  						return false;
  					}
  				}
  				else
  				{
  					QuantilesYlaString=txtQuantilesYla.getText();
					QuantilesAlaString=txtQuantilesAla.getText();
					qYla=new Float(QuantilesYlaString).floatValue();
					qAla= new Float(QuantilesAlaString).floatValue();
					if( (qYla>=qAla)&&(qYla>=0)&&(qYla<=100)&&(qAla>=0)&&(qAla<=100))
						syoteOk=true;	
					else
					{	
						JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
						return false;
					}
				}
			}
  			catch(NumberFormatException e)
  			{ 
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				return false;
  				
  			}
 		}
  		
  		if(kiinnitetaan.getState())
  		//kiinnitetaan palaLkm
  		{
  			try
  			{
  				palojaString=txtPaloja.getText();		
  				paloja=Integer.parseInt(palojaString);
				laskenta.kiinnitaPalaLkm(valittuIndeksi,paloja);  			
				if(paloina.getState())
					piirto.piirraPaloina(true);
				else	  			
  					piirto.piirraPaloina(false);
  			}
  			catch(NumberFormatException e)
  			{ 
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				return false;
  			}
  		}
  		// ei kiinniteta palalukumr
  		else
  			piirto.piirraPaloina(false);
  			
  		if(syoteOk)
  		{
  			gui.lblPieceWiseRowsIncluded.set("text","");
  			gui.lblPieceWiseRowsRemoved.set("text","");
  			gui.lblPieceWiseRowsIncluded.set("text",""+(kontrolli.dh.absKarsintaAskel()*askel));
			gui.lblPieceWiseRowsRemoved.set("text",""+(kontrolli.dh.absKarsittuAlusta()+poistettu*kontrolli.dh.absKarsintaAskel()));	
  			if(piirretaanKvantiilit.getState())
  			{
 				laskenta.asetaKvantiilit(0.01f*qAla,0.01f*qYla);
  				piirto.piirraKvantiilit(true,0.01f*qAla,0.01f*qYla);
  				if(tarkat.getState())
  				{// piirretn tarkat kvantiilit	
  					piirto.piirraTarkatKvantiilit(true);
  					tarkatKvantiilit=true;
  				}
  				else
  					piirto.piirraTarkatKvantiilit(false);
  			}	
  			else
  			{	
  				laskenta.asetaKvantiilit(Float.NaN,Float.NaN);
  				piirto.piirraKvantiilit(false,0,0);
  			}	
  			laskenta.karsiRivit(poistettu,askel);
 			syoteOk=false;
  			
  			if(!automX.getState())
  			//ei automaattinen
  			{
  				piirto.asetaAutomX(false);
  				piirto.asetaAlarajaX(xAla);
  				piirto.asetaYlarajaX(xYla);
  			
  			}
 			else
 			{
 				piirto.asetaAutomX(true);
 			}
 			
  			if(!autom.getState())
  			//ei automaattinen
  			{
  				piirto.asetaAutomY(false);
  				piirto.asetaAlarajaY(yAla);
				piirto.asetaYlarajaY(yYla);  			
  				
  			
  			}
 			else
 			{
 				piirto.asetaAutomY(true);
 				
 			} 		
  			return true;
  		}
  		else
  			return false;	
  	}
  	
  	/** Suoritetaan, kun Settings-ikkunan cancel-nappulaa painetaan.*/
	public void buttPieceWiseSettingsCancelClick(Message msg, Event evt)
	{
    	varattu=false;
    	gui.dialPieceWiseSettings.hide();
		if (asetuksetOk) jatka();
	}
    
	// Kyttmttmia action tapahtumia kalin objekteille
	public void chboxPieceWiseSettingsVisibleAreaXAutomaticClick(Message msg, Event evt){}   
	public void radioPieceWiseParam1TraceNumberClick(Message msg, Event evt){}
	public void radioPieceWiseParam1TraceFunctionsClick(Message msg, Event evt){}
	public void txtPieceWiseParam1TraceFunctionsPcsEnter(Message msg, Event evt){}
	public void radioPieceWiseP1TraceFunctionsTracePieceClick(Message msg, Event evt){}
	public void txtPieceWiseP1TraceFunctionsTracePieceEnter(Message msg, Event evt){}
	public void radioPieceWiseP1TraceFunctionsTracePlaceClick(Message msg, Event evt){}
	public void txtPieceWiseP1TraceFunctionsTracePlaceEnter(Message msg, Event evt){}
	public void radioPieceWiseParam2TraceNumberClick(Message msg, Event evt){}
	public void radioPieceWiseParam2TraceFunctionsClick(Message msg, Event evt){}
	public void txtPieceWiseParam2TraceFunctionsEnter(Message msg, Event evt){}
	public void radioPieceWiseP2TraceFunctionsTracePieceClick(Message msg, Event evt){}
	public void txtPieceWiseP2TraceFunctionsTracePieceEnter(Message msg, Event evt){}
	public void radioPieceWiseP2TraceFunctionsTracePlaceClick(Message msg, Event evt){}
	public void txtPieceWiseP2TraceFunctionsTracePlaceEnter(Message msg, Event evt){}
	public void buttPieceWiseSelectionsOkClick(Message msg, Event evt){}
	public void txtPieceWiseSettingsRangeXLowEnter(Message msg, Event evt){}
	public void txtPieceWiseSettingsRangeXHighEnter(Message msg, Event evt){}
	public void txtPieceWiseSettingsVisibleAreaXLowEnter(Message msg, Event evt){}
	public void txtPieceWiseSettingsVisibleAreaXHighEnter(Message msg, Event evt){}
	public void chboxPieceWiseSettingsVisibleAreaAutomaticClick(Message msg, Event evt){}
	public void radioPieceWiseSettingsDrawPointsClick(Message msg, Event evt){}
	public void radioPieceWiseSettingsDrawPiecesClick(Message msg, Event evt){}
	public void txtPieceWiseSettingsCountingPointsEnter(Message msg, Event evt){}
	public void txtPieceWiseRemoveRowsEnter(Message msg, Event evt){}
	public void txtPieceWiseIncludeRowsEnter(Message msg, Event evt){}
	public void chboxPieceWiseQuantilesDrawClick(Message msg, Event evt){}
	public void radioPieceWiseQuantilesRangeClick(Message msg, Event evt){}
	public void txtPieceWiseQuantilesRangeLowEnter(Message msg, Event evt){}
	public void txtPieceWiseQuantilesRangeHighEnter(Message msg, Event evt){}
	public void radioPieceWiseQuantilesPercentClick(Message msg, Event evt){}
	public void txtPieceWiseQuantilesPercentEnter(Message msg, Event evt){}
	public void chboxPieceWiseQuantilesExactValuesClick(Message msg, Event evt){}
    
  	protected Root initRoot() 
  	{	
		gui = new PieceWiseRoot(this);	
		addAttributeForward(gui.getMainChild());	
		return gui;
  	}

  	protected void initGroup() { }	
 	protected void showGroup() { }	
  	protected void hideGroup() { }	
  	
  	/** Hakee datanhallinnalta muistissa olevat kentt */
  	public void haeKentat()
	{
		List list=(List)gui.listPieceWiseSettings.getBody();
 		int apu=kontrolli.dh.annaKenttienLkm();		   
		list.removeAll();	   
		indeksit=new int[apu];// taulukkoon merkataan listboksissa 
		   							 // olevien parametrien indeksit
		int j=0;//listboksin indeksi
		for (int i=0;i<apu;i++)
		{				
			if(list!=null&&kontrolli.dh.onMuistissa(i))
			{
				list.addItem(kontrolli.dh.annaKentanNimi(i));
				indeksit[j]=i;
				j++;
			}				    
		}
		gui.txtPieceWiseIncludeRows.set("text",""+askel);
  		gui.txtPieceWiseRemoveRows.set("text",""+poistettu);
  		gui.txtPieceWiseSettingsCountingPoints.set("text",""+pisteet);
  		gui.lblPieceWiseRowsIncluded.set("text","");
  		gui.lblPieceWiseRowsRemoved.set("text","");
  		gui.lblPieceWiseRowsIncluded.set("text",""+(kontrolli.dh.absKarsintaAskel()*askel));
		gui.lblPieceWiseRowsRemoved.set("text",""+(kontrolli.dh.absKarsittuAlusta()+poistettu*kontrolli.dh.absKarsintaAskel()));	
  	}
  
  	/** Suoritetaan vhn ennenkuin kyttliittym tulee nkyviin. 
  		Suorittaa alustuksia.
  	*/
  	protected void createGroup()
  	{
   		haeKentat();
  		// alustetaan labelit
  		gui.lblPieceWiseAkseliHigh.set("text","                                        ");
  	 	gui.lblPieceWiseAkseliLow.set("text","                                        ");
	 	gui.lblPieceWiseRowsIncluded.set("text","   "+(kontrolli.dh.absKarsintaAskel()*askel)+"   ");
  		gui.lblPieceWiseRowsRemoved.set("text","   "+(kontrolli.dh.absKarsittuAlusta()+poistettu*kontrolli.dh.absKarsintaAskel())+"   ");
  		gui.lblPieceWiseNumberOfSweeps.set("text","                ");
  		gui.lblPieceWiseRowsProsessed.set("text","                ");
  	}
  	  
  
 	protected void destroyGroup() { }	
 	protected void startGroup() { }	
  	protected void stopGroup() { }	
  	
  	protected Object getOnGroup(String key) 
  	{	
		return super.getOnGroup(key);	
  	}
  	
  	protected void setOnGroup(String key, Object value) 
  	{	
		super.setOnGroup(key, value);	
  	}
  	
  	public boolean handleMessage(Message msg) 
  	{	
		return super.handleMessage(msg);	
  	}
	
	/** Yleinen tapahtumanksittely metodi. */
	public boolean handleEvent(Message msg, Event evt) 	
  	{		
  		switch (evt.id) 
  		{
      			case 2567:	// PAINT_EVENT
			{
         			if (msg.target == gui.canvPieceWise) 
            				tilaaUudelleenpiirto();
				break;
			}
		  	case 701: //listaa npytetty
		  	{
				if(msg.target==gui.listPieceWiseSettings)
					listPieceWiseSettingsClick(msg,evt);  				
				break;
			}
		}
	    	if(evt.id!=java.awt.event.WindowEvent.WINDOW_CLOSING)
    			return super.handleEvent(msg, evt);
  		else
  			return true;
	}
}


