import datanhallinta.*;
import java.io.*;
import java.awt.*;

/**Sie PollaaOtsaketta lukee Datanhallinnalta sytteen otsikkotiedot ja 
kirjoittaa ne kyttjn nkyville.*/
 
public class PollaaOtsaketta extends Thread
{
	private Datanhallinta dh;
	private int apu;
	private List list;
	private String tiedosto;
	private boolean putkesta=false;
	private JavistPaaikkuna kontrolli;
		

	/**Tt konstruktoria kutsutaan kun luetaan putkesta.*/
	public PollaaOtsaketta(Datanhallinta dh, List list, JavistPaaikkuna kontrolli)
	{
	    this.kontrolli=kontrolli;   
	    putkesta=true;
	    this.dh=dh;
	    this.list=list;
	}

	/**Tt konstruktoria kutsutaan, kun luetaan tiedostosta.*/
	public PollaaOtsaketta(Datanhallinta dh, List list, String tiedosto, JavistPaaikkuna kontrolli)
	{
	    this.kontrolli=kontrolli;
	    this.dh=dh;
	    this.list=list;
	    this.tiedosto=tiedosto;
	}
	
	
	public void run()	
    {			    
		kontrolli.otsakeLuettu=false;
		
		Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
		    
	 	// avaa cancelnappi
	 	if(!putkesta)
	 		try
	 		{
	 			dh.avaaDatalahde(tiedosto);
	 			kontrolli.tiedostoAvattu=true;
	 			kontrolli.avattuTiedosto=tiedosto;
	 		}
	 		catch (Otsikkovirhe e)
	 		{
	 			System.out.println("PollaaOtsaketta.run: OTSIKKOVIRHE");
	 			kontrolli.virheDialogi(kontrolli.OTSAKE,kontrolli.LOPETETAAN,
	    			e.annaViesti());
	 			pysayta();
	 		}
	 		catch (Exception e)
	 		{
	 			System.out.println("Datalhteen avaaminen ei toimi");
	 			System.exit(1);
	 			kontrolli.tiedostoAvattu=false;
	 			kontrolli.avattuTiedosto=null;
	 		}          
		else
		    try
		    {	 	
           		dh.avaaDatalahde();
           		kontrolli.tiedostoAvattu=true;
           		kontrolli.avattuTiedosto=null;
            }
            catch (Otsikkovirhe e)
	 		{
	 			System.out.println("PollaaOtsaketta.run: OTSIKKOVIRHE");
	 			kontrolli.virheDialogi(kontrolli.OTSAKE,kontrolli.LOPETETAAN,
	    			e.annaViesti());
	 			pysayta();
	 		}
            catch (Exception e)
            {
            	System.out.println("Datalhteen avaaminen ei toimi");
            	System.exit(1);
            	kontrolli.tiedostoAvattu=false;
            	kontrolli.avattuTiedosto=null;
            }   

		// sulje cancelnappi
		
		apu=dh.annaKenttienLkm();		 
		
		if(list.getItemCount()>0)
			list.removeAll();
		for (int i=0;i<apu;i++)
			/*kirjoitaKayttajanNakyville*/
			if(list!=null)
				list.addItem(dh.annaKentanNimi(i));
	    
	    kontrolli.otsakeLuettu=true;
	    
	    try
	    {
	    	dh.aloitaLukeminen(); //aloittaa datarivien lukemisen
	    }
	    catch(IOException e)
	    {
	   	 	System.out.println("PollaaOtsaketta.run: IOVIRHE");
	    	System.exit(1);
	    }
	    catch(IOvirhe e)
	    {
	   	 	System.out.println("PollaaOtsaketta.run: IOVIRHE");
	    	System.exit(1);
	    }
	    catch(Datavirhe e)
	    {
	   	 	System.out.println("PollaaOtsaketta.run: DATAVIRHE");
	    	kontrolli.virheDialogi(kontrolli.DATA,kontrolli.LOPETETAAN,
	    		e.annaViesti());
	  		pysayta();
	    }
	    catch(Muistivirhe e)
	    {
	   	 	System.out.println("PollaaOtsaketta.run: MUISTIVIRHE");
	    	kontrolli.virheDialogi(kontrolli.MUISTI,kontrolli.LOPETETAAN);
	    	pysayta();
	    }
	    catch(Exception e)
	    {
	    	System.out.println("PollaaOtsaketta.run: VIRHE");
	    	System.exit(1);
	    }	
                
	}//void run

	private void pysayta()
	{
		Thread.currentThread().stop();
	}

}// PollaaOtsaketta
