import sunsoft.jws.visual.rt.base.*;
import sunsoft.jws.visual.rt.shadow.java.awt.*;
import java.awt.*;
import laskenta.*;
import kaavio.*;
import sunsoft.jws.visual.rt.shadow.VJCanvasShadow;
import sunsoft.jws.visual.rt.awt.*;


 
/** Hoitaa Kaavioikkunan tapahtumanksittelyn ja piirtosikeen
	synkronoinnin
*/
public class SimulationTracing extends Group implements Runnable 
{
	public SimulationTracingRoot gui;// kyttliittym (jws:n generoima)
	private Graphics g;// graph olio joka vlitetn piirrolle
	private Jaljityslaskenta laskenta;// tmn kaaviotyypin lakenta olio
	private YksimuuttujaPiirto piirto;// tmn kaaviotyypin piirto olio
	private Thread t; //sie joka hoitaa piirtmisen 		
	private JavistPaaikkuna kontrolli;// viittaus pikkunaan 		
  	private int valittuIndeksi; // kertoo piirrettvn parametrin indeksin 		
  	private int[] indeksit; /* tll silytetn listboksissa olevien 
  								parametrien todelliset (datanhallinnan) indeksit */
  	private String valittuString; //valitun kentn nimi 
  	private int valittuna=0; // valittuna olevien kenttien lkm
	private int riveja=0; // tiedossa olevien rivien lkm
  	private int askel=1; // kaavion sisisen karsinnan askel
  	private int poistettu=0; //kaavion sisisen karsinnan rivimr
  	private int uusiaRiveja=0; // uusien rivien lkm
  	private boolean pysahtynyt = false; // onko pyshtynyt
	private boolean odottamassa = false; // onko odottamassa
	private int pysaytettava = 1; // pysaytettavien lkm
	private boolean asetuksetOk = false;
	private boolean laskettavaUudelleen = true; 
	private boolean piirrettavaUudelleen = true;
	private boolean laskeUudelleen; 
	private boolean piirraUudelleen;
	private boolean varattu=true;// saako settings / print ikkunan avata
	  
	/** Saa viittauksen pikkunaan ja thn menness luettujen rivien mrn */
	public SimulationTracing(JavistPaaikkuna k, int r)
	{
  		kontrolli = k;
  		laskenta = new Jaljityslaskenta(true);   
  		riveja = r;
	  	addForwardedAttributes();
		// sie luodaan ja kynnistetn vlittmsti.
		// pysytettava alustetaan arvolla 1, jolloin run-metodi
		// j odottamaan.
		t = new Thread(this);
		t.start();
	}

	/**	Sikeen t metodi. Hoitaa piirtmisen omana sikeenn */  
  	public void run()
	{
  		int r = 0;
  		while(true)
  		{
			r = rivejaKertynyt();
			if (pysahtynyt) {System.out.println("ei pyshtynyt");System.exit(1)  ;} //debug
  			riveja += r;
  			if (piirraUudelleen && laskeUudelleen) piirto.piirraUudelleen(riveja, true);
			else
			{
				if (piirraUudelleen) piirto.piirraUudelleen(riveja, false);
				if (r > 0) piirto.piirraLisaykset(r);
			}
  			haeTunnusluvut();
		}
	}

	// ++++++ Synkronisoidut metodit +++++++++++

	/** Palauttaa kontrollista tulleiden rivien mrn. 
		Jos rivej ei ole tullut ja piirrettavaUudelleen ja laskettavaUudelleen == false
		tai pysayttettava>0 j odottamaan.
	*/
	private synchronized int rivejaKertynyt()
	{
		int r = uusiaRiveja;
		boolean toimeton = !(piirrettavaUudelleen || laskettavaUudelleen || (r > 0));
		if (toimeton  || (pysaytettava > 0))
		{
			pysahtynyt = true;
			if (odottamassa)
			{
				notifyAll();				// vapauttaa kaikki odota() - metodissa olevat sikeet
				odottamassa = false;
			}
			try { wait(); } catch (Exception e)
			{ System.out.println("rivejaKertynyt: wait exception"); System.exit(1); }
			r = uusiaRiveja;
		}
		piirraUudelleen = piirrettavaUudelleen; piirrettavaUudelleen = false;
		laskeUudelleen = laskettavaUudelleen; laskettavaUudelleen = false;
		uusiaRiveja = 0;
		return r;
	}
  
	/** Lisaa uusien rivien mrn.*/
	public synchronized  void tullutUusiaRiveja(int r)
	{
		uusiaRiveja += r;
		if (pysahtynyt && (pysaytettava == 0)) { notify(); pysahtynyt = false; } 
	}
  
	/** ilmoittaa, ett ei saa aloittaa uutta laskentaa */ 
	public synchronized void pysayta()
	{	
  		pysaytettava++;
	}

	/** palauttaa kontrollin vasta kun piirto on pysaytetty */
	public synchronized void odota()
	{
		if (!pysahtynyt)
		{
			odottamassa = true;
			try { wait(); } catch (Exception e)
			{ System.out.println("odota: wait exception"); System.exit(1); }
		}
	}

	/** Jatkaa pysayta metodilla pysaytettya toimintoa*/
	public synchronized void jatka()
	{
		if ((--pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; }
	}

	/** Tilaa uudelleen piirron */
	private synchronized void tilaaUudelleenpiirto()
	{
		piirrettavaUudelleen = true;
		if ((pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; }
	}

	/** Pst piirtosikeen jatkamaan kun valinnat on tehty */
	private synchronized void valinnatTehty()
	{
		varattu=false;
		piirrettavaUudelleen = laskettavaUudelleen = true;
		if ((--pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; }
	}

	/** muuttaa rivien mr ja kertoo piirrolle karsinnasta
  		kertoo mys, ett on syyt piirt ja laskea uudelleen 
  	*/
  	public synchronized void rivitMuuttuneet(int r, int alusta, int askel)
	{
 		haeKentat(); 
 		if (piirto != null)
 			piirto.asetaDatanKarsinta(alusta,askel);

 		riveja = r;
		uusiaRiveja = 0;
 		piirrettavaUudelleen = laskettavaUudelleen = true;
 	}
  
	/** Hakee ja kirjoittaa kaavion tunnusluvut graphview ikkunaan*/ 
	public void haeTunnusluvut()
	{
		gui.lblSimulationTracingHajonta.set("text",""+laskenta.annaKeskihajonta());	
   		gui.lblSimulationTracingKeskiarvo.set("text",""+laskenta.annaKeskiarvo());
		gui.lblSimulationTracingMax.set("text",""+laskenta.annaMax());
		gui.lblSimulationTracingMin.set("text",""+laskenta.annaMin());
		gui.lblSimulationTracingRowsProsessed.set("text",""+laskenta.rivejaKaytetty());
		gui.lblSimulationTracingNumberOfSweeps.set("text",""+riveja);
		gui.lblSimulationTracingVarianssi.set("text",""+laskenta.annaVarianssi());
	}
  
	/** Tarkistaa onko kaaviossa valittuna oleva kentt viel datanhallinnassa.
  		Jos ei ole, niin tehdn "itsemurha" */
  	public void tarkistaKentat()
	{
  		if(kontrolli.dh.onMuistissa(valittuIndeksi))
			haeKentat();
		else
			kontrolli.tapaMut(this);
	}
  
  	/** Haetaan kyttjn valitseman list-indeksin todellinen indeksi */   
	public void listSimulationTracingSettingsClick(Message msg, Event evt)
	{
  		Label valittu=(Label)gui.lblSimulationTracingSettingsChosenAttribute.getBody();	
  		List list=(List)gui.listSimulationTracingSettings.getBody();
	  	valittuIndeksi=indeksit[list.getSelectedIndex()];
  		valittuString=list.getSelectedItem();
  		valittu.setText(valittuString);		
  		valittuna=1;		
	}
	
	public void buttSimulationTracingSettingsCancelClick(Message msg, Event evt)
	{
  		gui.dialog2.hide();
		if (asetuksetOk) jatka();
		varattu=false;
	}
  
	/** Suoritetaan, kun Print-nappulaa painetaan. Kysyy kyttjlt tiedostot, joihin 
  		tulostetaan
  	*/
	public void buttSimulationTracingPrintClick(Message msg, Event evt)
	{
  		//true == kaavio
  		//false== tunnusluvut
  		if(varattu)return;	
	  	else
	  		varattu=true;
	  	String dir="";
	  	String file="";
	  	List list1 = (List)kontrolli.gui.list1.getBody();
     	pysayta(); odota();
	    // kuvan tulostus
     	kontrolli.gui.filedialog1.set("title","Print picture");
   		kontrolli.gui.filedialog1.show();
	  	FileDialog apu=(FileDialog)kontrolli.gui.filedialog1.getBody();
	  	apu.setMode(FileDialog.SAVE);
	  	dir = (String)kontrolli.gui.filedialog1.get("directory");
		file = (String)kontrolli.gui.filedialog1.get("file");   
	 	if(file!=null)
	  	{
	 		new YksimuuttujaTulostus(""+dir+file,true,laskenta,valittuString,
	 		(kontrolli.dh.absKarsintaAskel()*askel),(kontrolli.dh.absKarsittuAlusta()+poistettu*kontrolli.dh.absKarsintaAskel()));
  	  	}
  	  
  		dir=null;file=null;
  			
  		// tunnuslukujen tulostus
  		kontrolli.gui.filedialog1.set("title","Print statistics");
		kontrolli.gui.filedialog1.show();
  	  	apu=(FileDialog)kontrolli.gui.filedialog1.getBody();
  	  	apu.setMode(FileDialog.SAVE);
  	  	dir = (String)kontrolli.gui.filedialog1.get("directory");
		file = (String)kontrolli.gui.filedialog1.get("file");   
	 	if(file!=null)
	  	{
	 		new YksimuuttujaTulostus(""+dir+file,false,laskenta,valittuString,
	 		(kontrolli.dh.absKarsintaAskel()*askel),(kontrolli.dh.absKarsittuAlusta()+poistettu*kontrolli.dh.absKarsintaAskel()));
  	  	}
  	  
  		dir=null;file=null;	
		tilaaUudelleenpiirto();
		jatka();
		varattu=false;
	}
  
 	/** Suoritetaan, kun Close-nappulaa painetaan. */
 	public void buttSimulationTracingCloseClick(Message msg, Event evt)
	{
		kontrolli.tapaMut(this);
	}
  
	/** Kutsutaan vastaavaa "nappula-painettu" metodia */
	public void menuitemSimulationTracingFileCloseClick(Message msg, Event evt)
	{
  		buttSimulationTracingCloseClick(msg,evt);
	}      
  
	/** Kutsutaan vastaavaa "nappula-painettu" metodia */
	public void menuitemSimulationTracingFilePrintClick(Message msg, Event evt)
	{
  		buttSimulationTracingPrintClick(msg,evt);
	} 
  
	/** Suoritetaan, kun Settings-nappulaa painetaan.*/
	public void menuitemSimulationTracingGraphSettingsClick(Message msg, Event evt)
	{
 	 	if(varattu)return;
 	 	else
 	 		varattu=true; 
 	 	valittuString=""+kontrolli.dh.annaKentanNimi(valittuIndeksi);
 	 	if (asetuksetOk) pysayta();
 	 	gui.dialog2.show();
 	}   
  
	
	public void txtSimulationTracingSettingsVisibleAreaXLowEnter(Message msg, Event evt){}
	public void txtSimulationTracingSettingsVisibleAreaYLowEnter(Message msg, Event evt){}
	public void txtSimulationTracingSettingsVisibleAreaXHighEnter(Message msg, Event evt){}
	public void txtSimulationTracingSettingsVisibleAreaYHighEnter(Message msg, Event evt){}
	public void chboxSimulationTracingVisibleAreaAutomaticClick(Message msg, Event evt){}
	public void txtSimulationTracingRemoveRowsEnter(Message msg, Event evt){}
	public void txtSimulationTracingIncludeRowsEnter(Message msg, Event evt){}
  	public void txtSimulationTracingP1TraceFunctionsTracePieceEnter(Message msg, Event evt){}
	public void txtSimulationTracingP1TraceFunctionsTracePlaceEnter(Message msg, Event evt){}
	public void txtSimulationTracingParam1TraceFunctionsPcsEnter(Message msg, Event evt){}
  	public void radioSimulationTracingParam1TraceNumber(Message msg, Event evt){}
	public void radioSimulationTracingParam1TraceFunctionsClick(Message msg, Event evt){}
  	public void radioSimulationTracingP1TraceFunctionsTracePieceClick(Message msg, Event evt){}	
	public void radioSimulationTracingP1TraceFunctionsTracePlaceClick(Message msg, Event evt){}
  	public void radioSimulationTracingParam2TraceNumberClick(Message msg, Event evt){}
	public void radioSimulationTracingParam2TraceFunctionsClick(Message msg, Event evt){}
  	public void radioSimulationTracingP2TraceFunctionsTracePieceClick(Message msg, Event evt){}
	public void radioSimulationTracingP2TraceFunctionsTracePlaceClick(Message msg, Event evt){}
	public void txtSimulationTracingP2TraceFunctionsTracePieceEnter(Message msg, Event evt){}
	public void txtSimulationTracingP2TraceFunctionsTracePlaceEnter(Message msg, Event evt){}	
	public void txtSimulationTracingParam2TraceFunctionsEnter(Message msg, Event evt){}
	public void txtSimulationTracingSettingsVisibleRangeWidthEnter(Message msg, Event evt){}
	public void chboxSimulationTracingVisibleAreaXAutomaticClick(Message msg, Event evt){} 

	/** Suoritetaan, kun Settings ikkunan Ok-nappulaa painetaan.
    	Jos piirtoa ei ole viel luotu luodaan piirto ja sie t. 
    	Lisksi haetaan kyttjn antamat tiedot. Jos tiedot ovat oikeelliset ja 
    	valittu ei ole funktio kutsutaan valinnatTehty metodia. Jos tiedot ovat 
    	oikeelliset ja valittu on funktio jtetn valinnatTehty metodin kutsu 
    	haeFunktionTiedot metodin suoritettavaksi.   
    
	*/
	public void buttSimulationTracingSettingsOkClick (Message msg, Event evt)
	{
  		int poistettu=0;
		int askel=1;
		
		odota();
  	 	if(valittuna==1)
  	 	{
  	 		Dialog dialogi=(Dialog)gui.dialog2.getBody();// settings dialogi
 	 		Dialog dialogi1=(Dialog)gui.dialog1.getBody();// funktio dialogi
 	 		boolean onFunktio=false;
 	 
 	 		// asetetaan akselien nimet
  	 		Label yAkseli=(Label)gui.lblSimulationTracingAkseliHigh.getBody();
  	 		yAkseli.setText(valittuString);
	 
	 		Label xAkseli=(Label)gui.lblSimulationTracingAkseliLow.getBody();
	 		xAkseli.setText("rows");
 	
 	 		// asetetaan graph-ikkunaan paarametrin nimi
 	 		gui.label73.set("text",valittuString); 	 
  	 
  	 		if(piirto==null)
  	 		{
  	 			VJCanvas vjcanvas = (VJCanvas)gui.vjcanvas5.getBody();
				g = vjcanvas.getGraphics();
    			laskenta.valitseKentta(valittuIndeksi);
	 	
		 		poistettu = kontrolli.dh.absKarsittuAlusta();
  		 		askel =kontrolli.dh.absKarsintaAskel();
  	 		
  	 			piirto = new YksimuuttujaPiirto(g,laskenta,poistettu,askel);

  	 	 		if(haeTiedot())//hakee ja tarkistaa kyttjn antamat tiedot
 	 			{
 		 			// kysytn onko valittu funktio
			 		if(kontrolli.dh.onFunktio(valittuIndeksi))
 			 			onFunktio=true;
 		 		
 					if(onFunktio)
 	 				{			
 	 		 	 		// valitun kentn nimi
 	 					gui.dialog1.show();
	  	 		 		gui.gbpanel6.set("layoutName",valittuString);
 	 		
 	 					// gbpanel6 on funktio dialogin kentt mihin tulee 
						// valittu parametri
 	 					// haetaan funktion tiedot
 		 			}
 					if(!onFunktio) 	
			 		// jos valittu on funktio, ei kynnistet piirtoa
			 		//ennen kuin funktion tiedot on mritetty
		 			{
	 					gui.dialog2.hide();
						asetuksetOk = true;
						valinnatTehty();
					}
	  			} // if (haeTiedot())
	  		}//if(piirto==null)
			else
			{
				laskenta.valitseKentta(valittuIndeksi);
	 	 	 	if(haeTiedot())	//hakee ja tarkistaa kyttjn antamat tiedot
 	 		 	{
					if(kontrolli.dh.onFunktio(valittuIndeksi))
						onFunktio=true; 	 	
 		 			// kysytn onko valittu funktio
 					if(onFunktio)
 	 				{			
 	 		 	 		// valitun kentn nimi
 	 					gui.dialog1.show();
	 	 		 		gui.gbpanel6.set("layoutName",valittuString);
 	 		
 		 				// gbpanel6 on funktio dialogin kentt mihin tulee 
						// valittu parametri
 	 				}
	 	 			if(!onFunktio)
 		 			// jos valittu on funktio, ei kynnistet piirtoa
			 		//ennen kuin funktion tiedot on mritetty
 	 				{
	  					gui.dialog2.hide();
						asetuksetOk = true;
						valinnatTehty();
  					}
  				}
			}
		}//if(valittuna==1)
		else
			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.VALITSEYKSI,JavistPaaikkuna.FOO);
	}
  
  	/** Hakee ja tarkistaa kyttjn antamat tiedot. */
	public boolean haeTiedot()
	{
  		float xYla=0;
  		float xAla=0;
  		float yYla=0;
  		float yAla=0;
  		int leveys=0;
  		boolean syoteOk=false;
  		
  		String xYlaString;
  		String xAlaString;
  		String yYlaString;
  		String yAlaString;
		String poisString;
		String askelString;
  		String leveysString;
  		
  		TextField txtAskel=(TextField)gui.txtSimulationTracingIncludeRows.getBody();
  		TextField txtPois=(TextField)gui.txtSimulationTracingRemoveRows.getBody();
  		
  		TextField txtXYla=(TextField)gui.txtSimulationTracingSettingsVisibleAreaXHigh.getBody(); 
  		TextField txtXAla=(TextField)gui.txtSimulationTracingSettingsVisibleAreaXLow.getBody();
  		TextField txtYYla=(TextField)gui.txtSimulationTracingSettingsVisibleAreaYHigh.getBody();
  		TextField txtYAla=(TextField)gui.txtSimulationTracingSettingsVisibleAreaYLow.getBody();
  		TextField txtLeveys=(TextField)gui.txtSimulationTracingSettingsVisibleRangeWidth.getBody();
  		Checkbox autom=(Checkbox)gui.chboxSimulationTracingVisibleAreaAutomatic.getBody();
  		Checkbox automX=(Checkbox)gui.chboxSimulationTracingVisibleAreaXAutomatic.getBody();
  		
  		try
		{
  			askelString=txtAskel.getText();
  			poisString=txtPois.getText();
  			
  			//askel ja poistettu luokkamuuttujia
  			askel=Integer.parseInt(askelString);
  			poistettu=Integer.parseInt(poisString);
  			if(askel<=0||poistettu<0)
  			{
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);	
  				return false;
  			}			
  		
  		}
  		catch(NumberFormatException e)
  		{ 
  				
  			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);	
  			return false;
  			
  		}		
  		

  		try
		{
  			
  			yYlaString=txtYYla.getText();
  			yAlaString=txtYAla.getText();
  			
  			
  			yYla=new Float(yYlaString).floatValue();
  			yAla=new Float(yAlaString).floatValue();
  			
  			if(yAla<yYla)
  				syoteOk=true;
  			else
  			{	
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				return false;
  				
  			}
  		}
  		catch(NumberFormatException e)
  		{ 
  			if(autom.getState())
  				syoteOk=true;
  			else	
  			{
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);	
  				return false;
  			}
  		}		
  		
  		try
  		{
  			xYlaString=txtXYla.getText();
  			xAlaString=txtXAla.getText();
  			xYla=new Float(xYlaString).floatValue();
  			xAla=new Float(xAlaString).floatValue();
  			if(xAla<xYla)
  				syoteOk=true;	
			else
			{	
				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
				return false;
  				
  			}
  		}
  		catch(NumberFormatException e)
  		{
			if(automX.getState())
  				syoteOk=true;
  			else	
  			{
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);	
  				return false;
  			}
  		}
  		  		
  		if(syoteOk)
  		{
  			gui.lblSimulationTracingRowsIncluded.set("text","");
			gui.lblSimulationTracingRowsRemoved.set("text","");
			
			gui.lblSimulationTracingRowsIncluded.set("text",""+(kontrolli.dh.absKarsintaAskel()*askel));
			gui.lblSimulationTracingRowsRemoved.set("text",""+(kontrolli.dh.absKarsittuAlusta()
				+poistettu*kontrolli.dh.absKarsintaAskel()));	
  			
  			piirto.asetaKaavionKarsinta(poistettu,askel);
  			laskenta.karsiRivit(poistettu,askel);
  			syoteOk=false;
  			
  			if(!autom.getState())
  			// Y ei automaattinen
  			{
 				piirto.asetaAutomY(false);
  				piirto.asetaAlarajaY(yAla);
				piirto.asetaYlarajaY(yYla);  			
  			}
 			else
 			{
 				piirto.asetaAutomY(true);
 			} 		
			if(!automX.getState())
			{
				piirto.asetaAutomX(false);  
  				piirto.asetaAlarajaX(xAla);
  				piirto.asetaYlarajaX(xYla);
  			}
  			else
  			{
  				piirto.asetaAutomX(true);	
  				try
  				{
  					leveysString=txtLeveys.getText();
  					leveys=Integer.parseInt(leveysString);
  					if(leveys<10)
  					{	
  						JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  						return false;//virheellinen syte
  					}	
  					piirto.asetaLeveys(leveys);
  				}
  				catch(NumberFormatException e)
  				{
  					JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  					return false;// virheellinen syte
  				}		
  			}
	  		return true;
  		}
  		else
  			return false;	
	}
  
	/** Siin tapauksessa, ett kyttjn valitsema kentt on funktio,
  		 haetaan kyttn funktiosta antamat tiedot ja sytteiden ollessa oikeelliset 
  		 kutsutaan valinnatTehty metodia 
  	*/
	public void haeFunktionTiedot()
	{	
  		String paloja;
  		String palaa;
  		String kohtaa;
 		int palojaInt=0; 
 		int palaaInt=0;
 		int kohtaaInt=0;
 		boolean syoteOk =false;		
  		Checkbox seurataanLkm=(Checkbox)gui.radioSimulationTracingParam1TraceNumber.getBody();
  		Checkbox seurataanPalaa =(Checkbox)gui.radioSimulationTracingP1TraceFunctionsTracePiece.getBody();
		TextField txtPaloja=(TextField)gui.txtSimulationTracingParam1TraceFunctionsPcs.getBody();
  		TextField txtKohtaa=(TextField)gui.txtSimulationTracingP1TraceFunctionsTracePlace.getBody();
  		TextField txtPalaa=(TextField)gui.txtSimulationTracingP1TraceFunctionsTracePiece.getBody();
		try{
   			if(!seurataanLkm.getState())
  			// kiinnitetn palalukumr
  			{	
  				paloja=txtPaloja.getText();
				palojaInt=Integer.parseInt(paloja);
			  			
  				if(seurataanPalaa.getState())
  				{	
  					palaa=txtPalaa.getText();	
  					palaaInt=Integer.parseInt(palaa);
  					if(palojaInt!=0&&palaaInt<=palojaInt&&palaaInt!=0)
  					{	
  						syoteOk=true;	
  						valittuString+="_level"+palaaInt;
  					}
  					else
  						JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);  			
  				}
  				else	
				{
					// seurataan hyppykohtaa
					kohtaa=txtKohtaa.getText();
					kohtaaInt=Integer.parseInt(kohtaa);
  					if(palojaInt!=0&&kohtaaInt<palojaInt&&kohtaaInt!=0)
					{	
						syoteOk=true;
						valittuString+="_jump"+kohtaaInt;
					}
					else 
						JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
				}
			}	  
  			else
			{	
				syoteOk=true;		
  				valittuString+="_pieces";
  			}
  		}//try
  		catch(NumberFormatException e)
  		{ 
  			syoteOk=false;
  			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  		}		
  		
  		if(syoteOk)
 		{ 		//Sytteet hyvksyttvi	
		  	syoteOk=false;
				
			if(seurataanLkm.getState())
					laskenta.valitseKentta(valittuIndeksi,0);
			else
			{
				laskenta.kiinnitaPalaLkm(valittuIndeksi,palojaInt);
				if(seurataanPalaa.getState())
					laskenta.valitseKentta(valittuIndeksi,2*palaaInt-1);
				else
					laskenta.valitseKentta(valittuIndeksi,2*kohtaaInt);
			}
			
	  		gui.dialog1.hide();
	  		gui.dialog2.hide();
	  			
	  		// piirto voidaan kynnist, koska kaikki
	  		// valinnat on tehty
			asetuksetOk = true;
			valinnatTehty();
		}
	}
  
	  
	protected Root initRoot()
	{
  		gui=new SimulationTracingRoot(this);
  		addAttributeForward(gui.getMainChild());	
		return gui;	
	}

	protected void initGroup() { }
	protected void showGroup() { }
	protected void hideGroup() { }	
  	
  	/** Hakee datanhallinnalta muistissa olevat kentt */
  	public void haeKentat()
	{
		List list=(List)gui.listSimulationTracingSettings.getBody();
 		int apu=kontrolli.dh.annaKenttienLkm();		   
		list.removeAll();
				   
		indeksit=new int[apu];// taulukkoon merkataan listboksissa 
		   							 // olevien parametrien indeksit
		   
		int j=0;//listboksin indeksi
		for (int i=0;i<apu;i++)
		{			
			if(list!=null&&kontrolli.dh.onMuistissa(i))
			{
				list.addItem(kontrolli.dh.annaKentanNimi(i));
				indeksit[j]=i;
				j++;
			}				    
		}

  		gui.txtSimulationTracingIncludeRows.set("text",""+askel);
  		gui.txtSimulationTracingRemoveRows.set("text",""+poistettu);
  		gui.lblSimulationTracingRowsIncluded.set("text","");
  		gui.lblSimulationTracingRowsRemoved.set("text","");
 		gui.lblSimulationTracingRowsIncluded.set("text",""+(kontrolli.dh.absKarsintaAskel()*askel));
		gui.lblSimulationTracingRowsRemoved.set("text",""+(kontrolli.dh.absKarsittuAlusta()+poistettu*kontrolli.dh.absKarsintaAskel()));	
  	}
  
	protected void createGroup()
	{
 		haeKentat();
  		//alustetaan labelit
  		gui.lblSimulationTracingAkseliHigh.set("text","                                        ");
  	 	gui.lblSimulationTracingAkseliLow.set("text","                                        ");
	 	gui.lblSimulationTracingRowsIncluded.set("text","   "+(kontrolli.dh.absKarsintaAskel()*askel)+"   ");
  		gui.lblSimulationTracingRowsRemoved.set("text","   "+(kontrolli.dh.absKarsittuAlusta()+poistettu*kontrolli.dh.absKarsintaAskel())+"   ");
 		gui.txtSimulationTracingSettingsVisibleRangeWidth.set("text",""+5000);
 		gui.lblSimulationTracingHajonta.set("text","              ");	
   		gui.lblSimulationTracingKeskiarvo.set("text","              ");
		gui.lblSimulationTracingMax.set("text","              ");
		gui.lblSimulationTracingMin.set("text","              ");
		gui.lblSimulationTracingRowsProsessed.set("text","              ");
		gui.lblSimulationTracingNumberOfSweeps.set("text","              ");
		gui.lblSimulationTracingVarianssi.set("text","              ");	
  	}

	protected void destroyGroup() { }	
	protected void startGroup() { }	
	protected void stopGroup() { }	

	protected Object getOnGroup(String key)
	{	
  		return super.getOnGroup(key);	
	}

 	protected void setOnGroup(String key, Object value)
	{
    		super.setOnGroup(key, value);	
  	}
  	
	public boolean handleMessage(Message msg)
	{	
		return super.handleMessage(msg);	
	}	
  
	/** Suoritetaan action eventin tapahtuessa. 
		Kytss, koska tarkistettaville nappuloille ei mritetty tapahtumia 
		jws:n puolella. Ei kytss muissa kaavioikkunoisssa.
	*/
	public boolean action(Message msg, Event evt, Object what)
	{
 	
 		if(msg.target==gui.buttSimulationTracingSettings)
  		{	
  			/* Suoritetaan, settings-nappulaa painetaan */
  			menuitemSimulationTracingGraphSettingsClick(msg, evt);
 
  		}
  		
  		if(msg.target==gui.buttSimulationTracingSelectionsOkClick)
  			/* Suoritetaan, kun Selections ikkunan Ok-nappulaa painetaan.*/
  			haeFunktionTiedot();	
  		return true;
	}
  
  	/** Yleinen tapahtumanksittely metodi. */
  	public boolean handleEvent(Message msg, Event evt) 
	{		
		switch (evt.id) 
		{
      			case 2567:	// PAINT_EVENT
				if (msg.target == gui.vjcanvas5) tilaaUudelleenpiirto();
					break;
			case 701: //listaa npytetty
				if(msg.target==gui.listSimulationTracingSettings)
				{
					listSimulationTracingSettingsClick(msg,evt);
				}
				break;
		}
    
		if(evt.id!=java.awt.event.WindowEvent.WINDOW_CLOSING)
 			return super.handleEvent(msg, evt);
  		else
  			return true;
	}
}


