import sunsoft.jws.visual.rt.base.*;
import sunsoft.jws.visual.rt.shadow.java.awt.*;
import java.awt.*;
import laskenta.*;
import kaavio.*;
import sunsoft.jws.visual.rt.shadow.VJCanvasShadow;
import sunsoft.jws.visual.rt.awt.*;

/** Hoitaa Kaavioikkunan tapahtumanksittelyn ja piirtosikeen
	synkronoinnin
*/
public class TwoParameter extends Group implements Runnable
{
	public TwoParameterRoot gui;
	private Graphics g;
 	private Yhteisjakaumalaskenta laskenta;
 	private KaksimuuttujaaPiirto piirto;
  	private String valittuXString;//valitun kentn nimi
  	private String valittuYString;//valitun kentn nimi	
	private int valittuXIndeksi = 0;
	private int valittuYIndeksi = 0;
  	
  	private Thread t; //sie joka hoitaa piirtmisen 		
	private JavistPaaikkuna kontrolli;// viittaus pikkunaan 		
  	private int valittuIndeksi; // kertoo piirrettvn parametrin indeksin 		
  	private int[] indeksit; /* tll silytetn listboksissa olevien 
  								parametrien todelliset (datanhallinnan) indeksit */
  	private String valittuString; //valitun kentn nimi 
  	private int valittuna=0; // valittuna olevien kenttien lkm
	private int riveja=0; // tiedossa olevien rivien lkm
  	private int askel=1; // kaavion sisisen karsinnan askel
  	private int poistettu=0; //kaavion sisisen karsinnan rivimr
  	private int uusiaRiveja=0; // uusien rivien lkm
  	private boolean pysahtynyt = false; // onko pyshtynyt
	private boolean odottamassa = false; // onko odottamassa
	private int pysaytettava = 1; // pysaytettavien lkm
	private boolean asetuksetOk = false;
	private boolean laskettavaUudelleen = true; 
	private boolean piirrettavaUudelleen = true;
	private boolean laskeUudelleen; 
	private boolean piirraUudelleen;
	private boolean varattu=true;// saako settings- /print-ikkunan avata
	private int[] jono={-1,-1};
	private int jonoindeksi=1;
    
	/** Saa viittauksen pikkunaan ja thn menness luettujen rivien mrn */
	public TwoParameter(JavistPaaikkuna k, int r)
	{
  		kontrolli = k;
  		laskenta = new Yhteisjakaumalaskenta(true);   
  		riveja = r;
	  	addForwardedAttributes();
		// sie luodaan ja kynnistetn vlittmsti.
		// pysytettava alustetaan arvolla 1, jolloin run-metodi
		// j odottamaan.
		t = new Thread(this);
		t.start();
	}

	/**	Sikeen t metodi. Hoitaa piirtmisen omana sikeenn */  
  	public void run()
	{
  		int r = 0;
  		while(true)
  		{
			r = rivejaKertynyt();  		
  			riveja += r;
  			if (piirraUudelleen && laskeUudelleen) piirto.piirraUudelleen(riveja, true);
			else
			{
				if (piirraUudelleen) piirto.piirraUudelleen(riveja, false);
				if (r > 0) piirto.piirraLisaykset(r);
			}
  			haeTunnusluvut();
		}
	}

	// ++++++ Synkronisoidut metodit +++++++++++

	/** Palauttaa kontrollista tulleiden rivien mrn. 
		Jos rivej ei ole tullut ja piirrettavaUudelleen ja laskettavaUudelleen == false
		tai pysayttettava>0 j odottamaan.
	*/
	private synchronized int rivejaKertynyt()
	{
		int r = uusiaRiveja;
		boolean toimeton = !(piirrettavaUudelleen || laskettavaUudelleen || (r > 0));
		if (toimeton  || (pysaytettava > 0))
		{
			pysahtynyt = true;
			if (odottamassa)
			{
				notifyAll();				// vapauttaa kaikki odota() - metodissa olevat sikeet
				odottamassa = false;
			}
			try { wait(); } catch (Exception e)
			{ System.out.println("rivejaKertynyt: wait exception"); System.exit(1); }
			r = uusiaRiveja;
		}
		piirraUudelleen = piirrettavaUudelleen; piirrettavaUudelleen = false;
		laskeUudelleen = laskettavaUudelleen; laskettavaUudelleen = false;
		uusiaRiveja = 0;
		return r;
	}
  
	/** Lisaa uusien rivien mrn.*/
	public synchronized  void tullutUusiaRiveja(int r)
	{
		uusiaRiveja += r;
		if ((pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; } 
	}
  
	/** ilmoittaa, ett ei saa aloittaa uutta laskentaa */ 
	public synchronized void pysayta()
	{	
  		pysaytettava++;
	}

	/** palauttaa kontrollin vasta kun piirto on pysaytetty */
	public synchronized void odota()
	{
		if (!pysahtynyt)
		{
			odottamassa = true;
			try { wait(); } catch (Exception e)
			{ System.out.println("odota: wait exception"); System.exit(1); }
		}
	}

	/** Jatkaa pysayta metodilla pysaytettya toimintoa*/
	public synchronized void jatka()
	{
		if ((--pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; }
	}

	/** Tilaa uudelleen piirron */
	private synchronized void tilaaUudelleenpiirto()
	{
		piirrettavaUudelleen = true;
		if ((pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; }
	}

	/** Pst piirtosikeen jatkamaan kun valinnat on tehty */
	private synchronized void valinnatTehty()
	{
		varattu=false;
		piirrettavaUudelleen = laskettavaUudelleen = true;
		if ((--pysaytettava == 0) && pysahtynyt) { notify(); pysahtynyt = false; }
	}

	/** muuttaa rivien mr ja kertoo piirrolle karsinnasta
  		kertoo mys, ett on syyt piirt ja laskea uudelleen 
  	*/
  	public synchronized void rivitMuuttuneet(int r, int alusta, int askel)
	{
 		haeKentat(); 
 		
 		riveja = r;
		uusiaRiveja = 0;
 		piirrettavaUudelleen = laskettavaUudelleen = true;
 	}


 	/** Hakee ja kirjoittaa kaavion tunnusluvut graphview ikkunaan*/
	public void haeTunnusluvut()
  	{
  		gui.lblTwoParameterP1Hajonta.set("text",""+laskenta.annaXKeskihajonta());
  		gui.lblTwoParameterP1Keskiarvo.set("text",""+laskenta.annaXKeskiarvo());
   		gui.lblTwoParameterP1Maksimi.set("text",""+laskenta.annaXMax());
   		gui.lblTwoParameterP1Minimi.set("text",""+laskenta.annaXMin());
   		gui.lblTwoParameterP1Varianssi.set("text",""+laskenta.annaXVarianssi());
  		gui.lblTwoParameterP2Hajonta.set("text",""+laskenta.annaYKeskihajonta());
  		gui.lblTwoParameterP2Keskiarvo.set("text",""+laskenta.annaYKeskiarvo());
  		gui.lblTwoParameterP2Maksimi.set("text",""+laskenta.annaYMax());
   		gui.lblTwoParameterP2Minimi.set("text",""+laskenta.annaYMin());
		gui.lblTwoParameterP2Varianssi.set("text",""+laskenta.annaYVarianssi());
		gui.lblTwoParameterRowsProsessed.set("text",""+laskenta.rivejaKaytetty());  
  		gui.lblTwoParameterNumberOfSweeps.set("text",""+riveja);
  		gui.lblTwoParameterKorrelaatio.set("text",""+laskenta.annaKorrelaatio());
  	}

	public void tarkistaKentat()
	{
  		if(kontrolli.dh.onMuistissa(valittuXIndeksi)&&kontrolli.dh.onMuistissa(valittuYIndeksi))
			haeKentat();
		else
			kontrolli.tapaMut(this);
	}
  
  
  	
  	/** Suoritetaan, kun Print-nappulaa painetaan. Kysyy kyttjlt tieedostot, joihin 
  		tulostetaan
  	*/
  	public void buttTwoParameterPrintClick(Message msg, Event evt)
	{
		//true == kaavio
  		//false== tunnusluvut
  		
  		if(varattu)return;
		else
			varattu=true;
		
  		String dir="";
  		String file="";
  		List list1 = (List)kontrolli.gui.list1.getBody();

  	  	pysayta(); odota();
  	  	// kuvan tulostus
		kontrolli.gui.filedialog1.set("title","Print picture");
		kontrolli.gui.filedialog1.show();
  	  	FileDialog apu=(FileDialog)kontrolli.gui.filedialog1.getBody();
  	  	apu.setMode(FileDialog.SAVE);
  	  	dir = (String)kontrolli.gui.filedialog1.get("directory");
     		file = (String)kontrolli.gui.filedialog1.get("file");   
	 	if(file!=null)
	  	{
	 		new KaksimuuttujaaTulostus(""+dir+file,true,laskenta,valittuXString,valittuYString);
  	  	}
  	  	dir=null;file=null;
  		// tunnuslukujen tulostus
  		kontrolli.gui.filedialog1.set("title","Print statistics");
     		kontrolli.gui.filedialog1.show();
  	  	apu=(FileDialog)kontrolli.gui.filedialog1.getBody();
  	  	apu.setMode(FileDialog.SAVE);
  	  	dir = (String)kontrolli.gui.filedialog1.get("directory");
     		file = (String)kontrolli.gui.filedialog1.get("file");   
	 	if(file!=null)
	  	{
	 		new KaksimuuttujaaTulostus(""+dir+file,false,laskenta,valittuXString,valittuYString);
  	  	}
  		dir=null;file=null;	
		tilaaUudelleenpiirto();
  		jatka();
  		varattu=false;
  	}

   	/** Suoritetaan, kun Settings-nappulaa painetaan.*/
   	public void buttTwoParameterSettingsClick(Message msg, Event evt)
	{
		if(varattu)return;
		else
			varattu=true;
		valittuXString=""+kontrolli.dh.annaKentanNimi(valittuXIndeksi);
 	 	valittuYString=""+kontrolli.dh.annaKentanNimi(valittuYIndeksi);
 	 	if (asetuksetOk) pysayta();
		gui.dialTwoParameterSettings.show();
	}

	/** Suoritetaan, kun Close-nappulaa painetaan. */
	public void buttTwoParameterCloseClick(Message msg, Event evt)
	{
		kontrolli.tapaMut(this);
	}
    
	/** Kutsutaan vastaavaa "nappula-painettu" metodia */
	public void menuitemTwoParameterFilePrintClick(Message msg, Event evt)
	{
		buttTwoParameterPrintClick(msg,evt);
	}

	/** Kutsutaan vastaavaa "nappula-painettu" metodia */
	public void menuitemTwoParameterFileCloseClick(Message msg, Event evt)
	{
    		buttTwoParameterCloseClick(msg,evt);
	}

	/** Kutsutaan vastaavaa "nappula-painettu" metodia */
	public void menuitemTwoParameterGraphSettingsClick(Message msg, Event evt)
	{
    		buttTwoParameterSettingsClick(msg,evt);
	}
    
	/** Haetaan kyttjn valitsemien list-indeksien todelliset indeksit */
	public void listTwoParameterSettingsClick(Message msg, Event evt)
	{
    	Label valittuX=(Label)gui.lblTwoParameterSettingsChosenAttributeX.getBody();
 		Label valittuY=(Label)gui.lblTwoParameterSettingsChosenAttributeY.getBody();
  	 	List list=(List)gui.listTwoParameterSettings.getBody();
	  	int[] valitut=list.getSelectedIndexes();//listassa valittuna olevat indeksit  		
	  	int n=valitut.length;
	  	if (n>valittuna)
	  	{
	  		int lisattava=-1; //indeksi listaan
	  		for(int i=0;i<n;i++)
	  			if ((valitut[i]!=jono[0])&&(valitut[i]!=jono[1]))
	  				lisattava=valitut[i];
	  		jonoindeksi=(jonoindeksi+1)%2;
	  		if (jono[jonoindeksi]>=0) list.deselect(jono[jonoindeksi]);	  			
	  		jono[jonoindeksi]=lisattava;
	  		if (valittuna<2) valittuna++;
	  	}
	  	else
	  	{
	  		int poistettava=0; //indeksi jonoon
	  		if (((n==0)&&(jono[0]<0))||((n==1)&&(valitut[0]==jono[0]))) 
	  			poistettava=1;
	  		jono[poistettava]=-1;
	  		jonoindeksi=(poistettava+1)%2;
	  		valittuna=n;
	  	}
	  		
	  	String[] apuS=new String[2];
	  	int[] apuI=new int[2];
	  	for(int i=0;i<2;i++)
	  		if (jono[i]<0){ apuS[i]=""; apuI[i]=-1; }
	  		else { apuS[i]=list.getItem(jono[i]); apuI[i]=indeksit[jono[i]];}
	  	valittuXIndeksi=apuI[0]; valittuYIndeksi=apuI[1];
	  	valittuXString=apuS[0]; valittuYString=apuS[1];
	  	valittuX.setText(valittuXString); valittuY.setText(valittuYString);
	  		
  	}
    
	/** Suoritetaan, kun Settings ikkunan Ok-nappulaa painetaan.
    	Jos piirtoa ei ole viel luotu luodaan piirto ja sie t. 
    	Lisksi haetaan kyttjn antamat tiedot. Jos tiedot ovat oikeelliset ja 
    	valittu ei ole funktio kutsutaan valinnatTehty metodia. Jos tiedot ovat 
    	oikeelliset ja valittu on funktio jtetn valinnatTehty metodin kutsu 
    	haeFunktionTiedot metodin suoritettavaksi.   
	*/

	public void buttTwoParameterSettingsOkClick(Message msg, Event evt)
 	{
   		int poistettu=0;
  	 	int askel=1;
  	 			
		odota();
    	if(valittuna==2)
  	 	{
  	 		Dialog dialogi=(Dialog)gui.dialTwoParameterSettings.getBody();// settings dialogi
 	 		Dialog dialogi1=(Dialog)gui.dialPieceWiseSelections.getBody();// funktio dialogi
 	 		boolean onFunktio=false;
 	 		// asetetaan akselien nimet
  	 		Label yAkseli=(Label)gui.lblTwoParameterVisAkseliHigh.getBody();
  	 		yAkseli.setText(valittuYString);
			Label xAkseli=(Label)gui.lblTwoParameterVisAkseliLow.getBody();
	 		xAkseli.setText(valittuXString);
 			// asetetaan graph-ikkunaan parametrien nimet
  	 		
  	 		gui.lblTwoParameterParam1.set("text",valittuXString);
  	 		gui.lblTwoParameterParam2.set("text",valittuYString);
  	 		
  	 		if(piirto==null)
  	 		{
  	 			VJCanvas vjcanvas = (VJCanvas)gui.canvTwoParameter.getBody();
 				g = vjcanvas.getGraphics();
    			laskenta.valitseXKentta(valittuXIndeksi);
				laskenta.valitseYKentta(valittuYIndeksi);    	
 				poistettu=kontrolli.dh.absKarsittuAlusta();
  	 			askel=kontrolli.dh.absKarsintaAskel();
  	 			piirto= new KaksimuuttujaaPiirto(g,laskenta/*,poistettu,askel*/);
  	 	 		if(haeTiedot())//hakee ja tarkistaa kyttjn antamat tiedot
 	 			{
 	 				// kysytn onko valittu funktio
 		 			if(kontrolli.dh.onFunktio(valittuXIndeksi)||kontrolli.dh.onFunktio(valittuYIndeksi))
 		 				onFunktio=true;
 					if(onFunktio)
 	 				{			
 	 					
 	 					gui.dialPieceWiseSelections.show();
 	 					if(kontrolli.dh.onFunktio(valittuXIndeksi))
 						{	
 							gui.gbpanel6.set("layoutName","X: "+valittuXString);
 	 						if(kontrolli.dh.onFunktio(valittuYIndeksi))
 	 							gui.gbpanel7.set("layoutName","Y: "+valittuYString);
 	 						else
 	 							gui.gbpanel7.set("layoutName","Y: Not used");
 	 					}	
 	 					else
 	 					{	
 	 						gui.gbpanel6.set("layoutName","X: Not used");
 	 						gui.gbpanel7.set("layoutName","Y: "+valittuYString);	
 	 					}
 	 					// gbpanel6 on funktio dialogin kentt mihin tulee 
						// valittu-x
						// gbpanel7 on funktio dialogin kentt mihin tulee 
						// valittu-y
 	 			 		
 	 			 	}
					if(!onFunktio) 	
		 			// jos valittu on funktio, ei kynnistet piirtoa
		 			//ennen kuin funktion tiedot on mritetty
		 			{
		 				gui.dialTwoParameterSettings.hide();
						asetuksetOk = true;
						valinnatTehty();
					}
 	 		  	}
  			}//if(piirto==null)
	 		else
			{
				laskenta.valitseXKentta(valittuXIndeksi);
				laskenta.valitseYKentta(valittuYIndeksi);
	 			if(haeTiedot())//hakee ja tarkistaa kyttjn antamat tiedot
 	 	 		{
					if(kontrolli.dh.onFunktio(valittuXIndeksi)||kontrolli.dh.onFunktio(valittuYIndeksi))
						onFunktio=true; 	 	
 		 			// kysytn onko valittu funktio
 					if(onFunktio)
 	 				{			
 	 					
 	 					gui.dialPieceWiseSelections.show();
 	 					if(kontrolli.dh.onFunktio(valittuXIndeksi))
 						{	
 							gui.gbpanel6.set("layoutName","X: "+valittuXString);
 	 						if(kontrolli.dh.onFunktio(valittuYIndeksi))
 	 							gui.gbpanel7.set("layoutName","Y: "+valittuYString);
 	 						else
 	 							gui.gbpanel7.set("layoutName","Y: Not used");
 	 					}	
 	 					else
 	 					{
 	 						gui.gbpanel7.set("layoutName","Y: "+valittuYString);	
 	 						gui.gbpanel6.set("layoutName","X: Not used");
 	 					}
 	 					
 	 					// gbpanel6 on funktio dialogin kentt mihin tulee 
						// valittu-x
						// gbpanel7 on funktio dialogin kentt mihin tulee 
						// valittu-y
					}
 					if(!onFunktio)
 	 				// jos valittu on funktio, ei kynnistet piirtoa
		 			//ennen kuin funktion tiedot on mritetty
 	 				{
 	 					gui.dialTwoParameterSettings.hide();
						asetuksetOk = true;
						valinnatTehty();
  					}
  				}
			}
		}//if(valittuna==2)
		else
			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.VALITSEKAKSI,JavistPaaikkuna.FOO);
	}
  
  	/** Hakee ja tarkistaa kyttjn antamat tiedot. */
	public boolean haeTiedot()
	{
  		float xYla=0;
  		float xAla=0;
  		float yYla=0;
  		float yAla=0;
  		boolean syoteOk=false;
  		String xYlaString;
  		String xAlaString;
  		String yYlaString;
  		String yAlaString;
  	   	String poisString;
  	   	String askelString;
  	   	TextField txtAskel=(TextField)gui.txtTwoParameterIncludeRows.getBody();
  		TextField txtPois=(TextField)gui.txtTwoParameterRemoveRows.getBody();
  		TextField txtXYla=(TextField)gui.txtTwoParameterVisibleAreaXHigh.getBody(); 
  		TextField txtXAla=(TextField)gui.txtTwoParameterVisibleAreaXLow.getBody();
  		TextField txtYYla=(TextField)gui.txtTwoParameterVisibleAreaYHigh.getBody();
  		TextField txtYAla=(TextField)gui.txtTwoParameterVisibleAreaYLow.getBody();
  		Checkbox autom=(Checkbox)gui.chboxTwoParameterVisibleAreaAutomatic.getBody();
  		Checkbox viivat=(Checkbox)gui.radioTwoParameterSettingsDrawLines.getBody();
  		Checkbox automX=(Checkbox)gui.chboxTwoParameterVisibleAreaXAutomatic.getBody();
  		
  		try
  		{
  			//askel ja poistettu luokkamuuttujia
  			askelString=txtAskel.getText();
  			poisString=txtPois.getText();
  			askel=Integer.parseInt(askelString);
  			poistettu=Integer.parseInt(poisString);
  			if(askel<=0||poistettu<0)
 			{ 
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);	
  				return false;
  			
  			} 			
  		
  		}
  		catch(NumberFormatException e)
  		{ 
  			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);	
  			return false;
  			
  		}
  		try
  		{
  			yYlaString=txtYYla.getText();
  			yAlaString=txtYAla.getText();
  			yYla=new Float(yYlaString).floatValue();
  			yAla=new Float(yAlaString).floatValue();
  			if(yAla<yYla)
  				syoteOk=true;
  			else
  			{
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				return false;
  				
  			}
  		}
  		catch(NumberFormatException e)
  		{ 
  			if(autom.getState())
  				syoteOk=true;
  			else	
  			{
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);	
  				return false;
  			}
  		}		
  		try
  		{
  			xYlaString=txtXYla.getText();
  			xAlaString=txtXAla.getText();
  			xYla=new Float(xYlaString).floatValue();
  			xAla=new Float(xAlaString).floatValue();
  			if(xAla<xYla)
  				syoteOk=true;	
  			else
  			{	
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				return false;
  			}
  		}
  		catch(NumberFormatException e)
  		{
			if(automX.getState())
  				syoteOk=true;
  			else	
  			{
  				JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);	
  				return false;
  			}
  		}
  		if(syoteOk)
  		{
  			gui.lblTwoParameterRowsIncluded.set("text","");
			gui.lblTwoParameterRowsRemoved.set("text","");
  			gui.lblTwoParameterRowsIncluded.set("text",""+kontrolli.dh.absKarsintaAskel()*askel);
			gui.lblTwoParameterRowsRemoved.set("text",""+kontrolli.dh.absKarsittuAlusta()
					+poistettu*kontrolli.dh.absKarsintaAskel());	
  			//piirto.asetaKaavionKarsinta(poistettu,askel);
  			laskenta.karsiRivit(poistettu,askel);
  			syoteOk=false;
  			if(viivat.getState())
  				piirto.piirraViiva(true);
  			else
  				piirto.piirraViiva(false);	
  			if(!autom.getState())
  			// Y ei automaattinen
  			{
  				piirto.asetaAutomY(false);
 				piirto.asetaAlarajaY(yAla);
				piirto.asetaYlarajaY(yYla);  			
  			}
 			else
 				piirto.asetaAutomY(true);
			if(!automX.getState())
			{
				piirto.asetaAutomX(false);  
  				piirto.asetaAlarajaX(xAla);
  				piirto.asetaYlarajaX(xYla);
  			}
  			else
  				piirto.asetaAutomX(true);
			return true;
  		}
  		else
  			return false;	
	}
 	
 	/** Siin tapauksessa, ett kyttjn valitsema kentt on funktio,
  		 haetaan kyttn funktiosta antamat tiedot ja sytteiden ollessa oikeelliset 
  		 kutsutaan valinnatTehty metodia 
  	*/  
 	public void haeFunktionTiedot()
  	{	
  		String palojaX;
  		String palaaX;
  		String kohtaaX;
 		int palojaXInt=0; 
 		int palaaXInt=0;
 		int kohtaaXInt=0;
 		String palojaY;
  		String palaaY;
  		String kohtaaY;
 		int palojaYInt=0; 
 		int palaaYInt=0;
 		int kohtaaYInt=0;
 		boolean syoteOk =false;		
  		Checkbox seurataanXLkm=(Checkbox)gui.radioTwoParameterParam1TraceNumber.getBody();
  		Checkbox seurataanXPalaa=(Checkbox)gui.radioTwoParameterP1TraceFunctionsTracePiece.getBody();
		Checkbox seurataanYLkm=(Checkbox)gui.radioTwoParameterParam2TraceNumber.getBody();
  		Checkbox seurataanYPalaa=(Checkbox)gui.radioTwoParameterP2TraceFunctionsTracePiece.getBody();
		TextField txtPalojaX=(TextField)gui.txtTwoParameterParam1TraceFunctionsPcs.getBody();
  		TextField txtKohtaaX=(TextField)gui.txtTwoParameterP1TraceFunctionsTracePlace.getBody();
  		TextField txtPalaaX=(TextField)gui.txtTwoParameterP1TraceFunctionsTracePiece.getBody();
   		TextField txtPalojaY=(TextField)gui.txtTwoParameterParam2TraceFunctions.getBody();
  		TextField txtKohtaaY=(TextField)gui.txtTwoParameterP2TraceFunctionsTracePlace.getBody();
  		TextField txtPalaaY=(TextField)gui.txtTwoParameterP2TraceFunctionsTracePiece.getBody();
   		try
   		{
   			if(!seurataanXLkm.getState())
  			// kiinnitetn x:n palalukumr
  			{	
  				palojaX=txtPalojaX.getText();
				palojaXInt=Integer.parseInt(palojaX);
  				if(seurataanXPalaa.getState())
  				{	
  					palaaX=txtPalaaX.getText();	
  					palaaXInt=Integer.parseInt(palaaX);
  					if(palojaXInt!=0&&palaaXInt<=palojaXInt&&palaaXInt!=0)
  					{
  						syoteOk=true;	
  						if(kontrolli.dh.onFunktio(valittuXIndeksi))
  							valittuXString+="_level"+palaaXInt;	
  				  	}
  				  	else
  				  		JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);		
  				}
  				else	
				{
					// seurataan hyppykohtaa
					kohtaaX=txtKohtaaX.getText();
					kohtaaXInt=Integer.parseInt(kohtaaX);
  					if(palojaXInt!=0&&kohtaaXInt<palojaXInt&&kohtaaXInt!=0)
					{	
						syoteOk=true;
						if(kontrolli.dh.onFunktio(valittuXIndeksi))
							valittuXString+="_jump"+kohtaaXInt;
					}
					else
						JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);			
				}	
				
			}	  
  			else
				if(kontrolli.dh.onFunktio(valittuXIndeksi))
					valittuXString+="_pieces";
  			if(!seurataanYLkm.getState())
  			// kiinnitetn y:n palalukumr
  			{	
  				palojaY=txtPalojaY.getText();
				palojaYInt=Integer.parseInt(palojaY);
			  	if(seurataanYPalaa.getState())
  				{	
  					palaaY=txtPalaaY.getText();	
  					palaaYInt=Integer.parseInt(palaaY);
  					if(palojaYInt!=0&&palaaYInt<=palojaYInt&&palaaYInt!=0)
  					{
  						syoteOk=true;	
  						if(kontrolli.dh.onFunktio(valittuYIndeksi))
  							valittuYString+="_level"+palaaYInt;	
  				  	}	
  				  	else
  				  		JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  				}
  				else	
				{
					// seurataan hyppykohtaa
					kohtaaY=txtKohtaaY.getText();
					kohtaaYInt=Integer.parseInt(kohtaaY);
  					if(palojaYInt!=0&&kohtaaYInt<palojaYInt&&kohtaaYInt!=0)
					{
  						syoteOk=true;	
  						if(kontrolli.dh.onFunktio(valittuYIndeksi))
  							valittuYString+="_jump"+kohtaaYInt;	
  				  	}
					else
						JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
				}
			}
  			else
			{
				syoteOk=true;
				if(kontrolli.dh.onFunktio(valittuXIndeksi))
					valittuYString+="_pieces";
			}		
		}//try
  		catch(NumberFormatException e)
  		{ 
  			syoteOk=false;
  			JavistPaaikkuna.virheDialogi(JavistPaaikkuna.SYOTE,JavistPaaikkuna.FOO);
  		}		
  		if(syoteOk)
 		{ 		//Sytteet hyvksyttvi	
			syoteOk=false;
			if(kontrolli.dh.onFunktio(valittuXIndeksi))
			// jos x on funktio kerrotaan valinnat laskennnalle
			{	
				if(seurataanXLkm.getState())
					laskenta.valitseXKentta(valittuXIndeksi,0);
				else
				{
					laskenta.kiinnitaPalaLkm(valittuXIndeksi,palojaXInt);
					if(seurataanXPalaa.getState())
						laskenta.valitseXKentta(valittuXIndeksi,2*palaaXInt-1);
					else
						laskenta.valitseXKentta(valittuXIndeksi,2*kohtaaXInt);
				}
			}
			if(kontrolli.dh.onFunktio(valittuYIndeksi))
			// jos y on funktio kerrotaan valinnat laskennnalle
			{
				if(seurataanYLkm.getState())
					laskenta.valitseYKentta(valittuYIndeksi,0);
				else
				{
					laskenta.kiinnitaPalaLkm(valittuYIndeksi,palojaYInt);
					if(seurataanXPalaa.getState())
						laskenta.valitseYKentta(valittuXIndeksi,2*palaaYInt-1);
					else
						laskenta.valitseYKentta(valittuXIndeksi,2*kohtaaYInt);
				}
			}
			gui.dialPieceWiseSelections.hide();
	  		gui.dialTwoParameterSettings.hide();	
			asetuksetOk = true;
			valinnatTehty();	  		
 		}
  	}
    
	public void buttTwoParameterSettingsCancelClick(Message msg, Event evt)
	{
		varattu=false;
		gui.dialTwoParameterSettings.hide();
		if (asetuksetOk) jatka();
	}
    
	public void txtTwoParameterRemoveRowsEnter(Message msg, Event evt){}
	public void txtTwoParameterIncludeRowsEnter(Message msg, Event evt){}
	public void txtTwoParameterVisibleAreaXLowEnter(Message msg, Event evt){}
	public void txtTwoParameterVisibleAreaXHighEnter(Message msg, Event evt){}
	public void txtTwoParameterVisibleAreaYLowEnter(Message msg, Event evt){}
	public void txtTwoParameterVisibleAreaYHighEnter(Message msg, Event evt){}
	public void chboxTwoParameterVisibleAreaAutomaticClick(Message msg, Event evt){}
	public void radioTwoParameterSettingsDrawPointsClick(Message msg, Event evt){}
	public void radioTwoParameterSettingsDrawLinesClick(Message msg, Event evt){}
	public void radioTwoParameterParam1TraceNumberClick(Message msg, Event evt){}
	public void radioTwoParameterParam1TraceFunctionsClick(Message msg, Event evt){}
	public void txtTwoParameterParam1TraceFunctionsPcsEnter(Message msg, Event evt){}
	public void radioTwoParameterP1TraceFunctionsTracePieceClick(Message msg, Event evt){}
	public void txtTwoParameterP1TraceFunctionsTracePieceEnter(Message msg, Event evt){}
	public void radioTwoParameterP1TraceFunctionsTracePlaceClick(Message msg, Event evt){}
	public void txtTwoParameterP1TraceFunctionsTracePlaceEnter(Message msg, Event evt){}
	public void radioTwoParameterParam2TraceNumberClick(Message msg, Event evt){}
	public void radioTwoParameterParam2TraceFunctionsClick(Message msg, Event evt){}
	public void txtTwoParameterParam2TraceFunctionsEnter(Message msg, Event evt){}
	public void radioTwoParameterP2TraceFunctionsTracePieceClick(Message msg, Event evt){}
	public void txtTwoParameterP2TraceFunctionsTracePieceEnter(Message msg, Event evt){}
	public void radioTwoParameterP2TraceFunctionsTracePlaceClick(Message msg, Event evt){}
	public void txtTwoParameterP2TraceFunctionsTracePlaceEnter(Message msg, Event evt){}
   	public void chboxTwoParameterVisibleAreaXAutomaticClick(Message msg, Event evt){}    
    
   	 /** Suoritetaan, kun Settings ikkunan cancel-nappulaa painetaan. */
   	public void buttTwoParameterSelectionsOkClick(Message msg, Event evt)
	{
    		haeFunktionTiedot();
	}
   	
   	protected Root initRoot() 
  	{	
       	gui = new TwoParameterRoot(this);	
		addAttributeForward(gui.getMainChild());	
		return gui;	
  	}
  
  	protected void initGroup() { }	
  	protected void showGroup() { }	
  	protected void hideGroup() { }	
  
  	
  	public void haeKentat()
	{
		List list=(List)gui.listTwoParameterSettings.getBody();
 		list.removeAll();
 		int apu=kontrolli.dh.annaKenttienLkm();		   
		indeksit=new int[apu];// taulukkoon merkataan listboksissa 
		   							 // olevien parametrien indeksit
		int j=0;//listboksin indeksi
		for (int i=0;i<apu;i++)
		{			
			if(list!=null&&kontrolli.dh.onMuistissa(i))
			{
				list.addItem(kontrolli.dh.annaKentanNimi(i));
				indeksit[j]=i;
				j++;
			}
		}
  		
	    
	    
  		gui.txtTwoParameterIncludeRows.set("text",""+askel);
  		gui.txtTwoParameterRemoveRows.set("text",""+poistettu);
  		gui.lblTwoParameterRowsIncluded.set("text","");
		gui.lblTwoParameterRowsRemoved.set("text","");
  		gui.lblTwoParameterRowsIncluded.set("text",""+(kontrolli.dh.absKarsintaAskel()*askel));
		gui.lblTwoParameterRowsRemoved.set("text",""+(kontrolli.dh.absKarsittuAlusta()+poistettu*kontrolli.dh.absKarsintaAskel()));
	}
  
  	/** Hakee datanhallinnalta muistissa olevat kentt */
  	protected void createGroup()
  	{
  		haeKentat();
  		// alustetaan labelit
  		gui.lblTwoParameterVisAkseliHigh.set("text","                                        ");
  	 	gui.lblTwoParameterVisAkseliLow.set("text","                                        ");
  		gui.lblTwoParameterRowsIncluded.set("text","   "+(kontrolli.dh.absKarsintaAskel()*askel)+"   ");
		gui.lblTwoParameterRowsRemoved.set("text","   "+(kontrolli.dh.absKarsittuAlusta()+poistettu*kontrolli.dh.absKarsintaAskel())+"   ");
  		gui.lblTwoParameterP1Hajonta.set("text","              ");
  		gui.lblTwoParameterP1Keskiarvo.set("text","              ");
   		gui.lblTwoParameterP1Maksimi.set("text","              ");
   		gui.lblTwoParameterP1Minimi.set("text","              ");
   		gui.lblTwoParameterP1Varianssi.set("text","              ");
  		gui.lblTwoParameterP2Hajonta.set("text","              ");
  		gui.lblTwoParameterP2Keskiarvo.set("text","              ");
  		gui.lblTwoParameterP2Maksimi.set("text","              ");
   		gui.lblTwoParameterP2Minimi.set("text","              ");
		gui.lblTwoParameterP2Varianssi.set("text","              ");
		gui.lblTwoParameterRowsProsessed.set("text","              ");  
  		gui.lblTwoParameterNumberOfSweeps.set("text","              ");
  		gui.lblTwoParameterKorrelaatio.set("text","              ");	
  	
  	}
  	
  	protected void destroyGroup() { }	
	protected void startGroup() { }	
	protected void stopGroup() { }	
  	
	protected Object getOnGroup(String key) 
  	{	
    		return super.getOnGroup(key);	
  	}	
 	
 	protected void setOnGroup(String key, Object value) 
 	{	
    		super.setOnGroup(key, value);	
  	}	

 	public boolean handleMessage(Message msg) 
 	{	
		return super.handleMessage(msg);	
  	}	
  
  	/** Yleinen tapahtumanksittely metodi. */
  	public boolean handleEvent(Message msg, Event evt) 	
  	{
  		switch (evt.id) 
  		{
      			case 2567:	// PAINT_EVENT
         	if (msg.target == gui.canvTwoParameter) 
				tilaaUudelleenpiirto();
			break;
			case 701: case 702: //listaa npytetty
			if(msg.target==gui.listTwoParameterSettings)
				listTwoParameterSettingsClick(msg, evt);				
			break;
		}
		if(evt.id!=java.awt.event.WindowEvent.WINDOW_CLOSING)
    			return super.handleEvent(msg, evt);
  		else
  			return true;
  	}
}


