package laskenta;

/**Keko on abstrakti yliluokka, josta periytyvt luokat MaxKeko ja UlkoKeko.
*Kytetn Jakaumalaskenta- ja Funktiolaskenta-luokissa tarkkojen kvantiilien
*laskemiseen. Keot toteutetaan taulukkoina, joiden huippu on indeksiss 1.*/
abstract class Keko
{
/**Konstruktori saa parametrina keon koon*/
	protected Keko(int k) { koko = k;  viimeinen = 0; }

/**Pivitt kekojrjestyksen parametrina saadusta solmusta huippua kohti*/
	protected void paivitaYlos(int solmu)
	{
		int isa;
		while (((isa = solmu >> 1) > 0) && (vertaa(isa, solmu)))
		{ vaihda(isa, solmu); solmu = isa; }
	}

/**Pivitt kekojrjestyksen parametrina saadusta solmusta alaspin*/
	protected void paivitaAlas(int solmu)
	{
		int oikea,vasen,poika;
		while (true)
		{
			vasen = solmu + solmu; oikea = vasen + 1;
			if (vasen > viimeinen) return;
			if (oikea > viimeinen) poika = vasen;
			else poika = vertaa(oikea, vasen) ? vasen : oikea;
			if (vertaa(solmu, poika)) { vaihda(solmu, poika); solmu = poika; }
			else return;
		}
	}

/**Aliluokissa toteutettava metodi, joka vaihtaa kahden keon solmun arvot keskenn*/
	abstract protected void vaihda(int p, int q);

/**Aliluokissa toteutettava metodi, joka vertailee parametreina saatujen solmujen arvoja.
*Palauttaa true, jos arvot ovat vrss jrjestyksess*/
	abstract protected boolean vertaa(int isa, int poika);

/**Palauttaa true, jos keko on tysi*/
	protected boolean taysi() { return koko == viimeinen; }

	protected int varaaUusi() { return ++viimeinen; }

	private int viimeinen, koko;
}




