package laskenta;

/**Kertymataulu on abstrakti yliluokka, josta periytyvt luokat KiinteKertymataulu ja
*JoustavaKertymataulu.  Kytetn Jakaumalaskenta-luokassa histogrammipylviden
*kertymien ja kvantiilien laskemiseen ja Funktiolaskenta-luokassa likimristen
*kvantiilien laskemiseen*/
abstract class Kertymataulu
{
/**Konstruktori saa parametrina laskettavien kvantiilien lukumrn*/
	protected Kertymataulu(int lkm)
	{
		kvantiilit = new Kvantiili[lkm];
		for (int i = 0; i < lkm; i++) kvantiilit[i] = new Kvantiili();
	}
	
/**Lis taulun alkion p kertym*/
	protected void uusiArvo(int p)
	{
		for (int i = 0; i < kvantiilit.length; i++)
			if (p < kvantiilit[i].alue) kvantiilit[i].positio++;
		kasvataArvoa(p);
	}
	
/**Palauttaa sen alkion indeksin p, jossa kvantiili i sijaitsee*/
	protected int annaKvantiili(int i) { return kvantiilit[i].alue; }
	
/**Palauttaa alkion p kertymn*/
	protected int annaKertyma(int p) { int i = annaArvo(p); return (i < 0) ? 0 : i; }

/**Palauttaa alkion p arvon*/
	abstract protected int annaArvo(int p);

/**Asettaa alkion p arvoksi k*/
	abstract protected void asetaArvo(int p,int k);

/**Kasvattaa alkion p arvoa yhdell*/
	abstract protected void kasvataArvoa(int p);

/**Tyhj toteutus toistaiseksi*/
	protected void valmistele() {}

/**Pivitt kvantiilin i paikan. pos on kvantiilin positio parametrin kaikkien arvojen 
*jrjestetyss jonossa*/
	protected void paivitaKvantiili(int i,int pos)
	{
		while (pos < kvantiilit[i].positio)
		{
			int j = --kvantiilit[i].alue;
			kvantiilit[i].positio -= annaKertyma(j);
		}
		int p;
		while (pos >= (p = kvantiilit[i].positio + annaKertyma(kvantiilit[i].alue)))
		{
			kvantiilit[i].alue++;
			kvantiilit[i].positio = p;
		}	
	}

	private class Kvantiili
	{
		protected Kvantiili() { alue = positio = 0; }
		protected int alue, positio;
	}

	private Kvantiili[] kvantiilit;
}



