package laskenta;
/**Muutostaulu-luokkaa kytetn jrjestmn paloittain vakion funktion muutoskohdat
*suuruusjrjestykseen laskettaessa tarkkoja kvantiileja.*/
class Muutostaulu
{
/**Konstruktori saa parametreina laskentapisteiden ja rivien lukumrt p ja r*/
	protected Muutostaulu(int p,int r)
	{
		keula = new int[p];
		seur = new int[r];
		for (int i = 0; i <p; i++) keula[i] = -1;
		for (int i = 0; i < r; i++) seur[i] = -1;
		jakoX = p; lp = 0;
	}

/**Palauttaa ensimmisen muutoskohdan laskentapisteen*/
	protected int annaLaskentapiste() { return lp; }

/**Palauttaa ensimmisen muutoskohdan rivinumeron*/
	protected int annaRivi() { return keula[lp]; }

/**Poistaa ensimmisen muutoskohdan ja lis saman rivin seuraavan muutoskohdan,
*jos p > -1, */	
	protected void paivitaMuutoskohta(int p)
	{
		int i = keula[lp];
		keula[lp] = seur[i];
		if (p == -1) return;
		seur[i] = keula[p];
		keula[p] = i;
	}

/**Palauttaa true, jos muutoskohtia on jljell*/		
	protected boolean seuraava()
	{
		int i = keula[lp];
		if (i != -1) return true;
		while ((++lp < jakoX) && (keula[lp] == -1));
		return lp < jakoX;
	}

/**Lis muutoskohdan (rivi = r, laskentapiste = p)*/
	protected void lisaa(int r, int p) { seur[r] = keula[p]; keula[p] = r; }

	private int lp, jakoX;
	private int[] seur, keula;
}


