package laskenta;

/**Ulkokeko on abstrakti yliluokka, joka periytyy abstraktista yliluokasta Keko, ja josta
*periytyvt luokat MaxUlkokeko ja MinUlkokeko. Kytetn Funktiolaskenta-luokassa
*tarkkojen kvantiilien laskemiseen. Keon alkiot ovat rivinumeroita. Kekojrjestys perustuu
*keon ulkopuoliseen arvotaulukkoon, jota indeksoidaan rivinumeroilla.*/
abstract class Ulkokeko extends Keko
{
/**Konstruktori saa parametrieina keon koon, viittaukset keon ulkopuolisiin kekoindeksi- ja
*arvotaulukoihin, sek keon alimman indeksin kekoindeksitaulukossa*/
	protected Ulkokeko(int k, int[] kekoix, float[] taulu, int alin)
	{
		super(k);
		rivi = new int[k+1];
		kekoindeksi = kekoix; arvo = taulu;
		alaindeksi = alin;
	}

	protected void vaihda(int p, int q)
	{
		int rp = rivi[p], rq = rivi[q];
		kekoindeksi[rp] = alaindeksi + q - 1;
		kekoindeksi[rq] = alaindeksi + p - 1;
		rivi[p] = rq; rivi[q] = rp;
	}

/**Palauttaa keon huipun rivinumeron*/
	protected int annaHuippu() { return rivi[1]; }

/**Korvaa keon solmun s rivinumeron r:ll. Ei pivit kekojrjestyst*/
	protected void korvaa(int s, int r)
	{
		rivi[s - alaindeksi + 1] = r;
		kekoindeksi[r] = s;
	}
	
/**Pivitt rivin r sijainnin keossa*/
	protected void paivitaPaikka(int r)
	{
		int solmu = kekoindeksi[r] - alaindeksi + 1;
		if ((solmu > 1) && vertaa(solmu >> 1,solmu)) paivitaYlos(solmu);
		else paivitaAlas(solmu);
	}

/**Lis kekoon rivin r ja pivitt kekojrjestyksen*/
	protected void lisaa(int r)
	{
		int solmu = varaaUusi();
		rivi[solmu] = r;
		kekoindeksi[r] = alaindeksi + solmu - 1;
		paivitaYlos(solmu);
	}

	protected int[] rivi;
	protected float[] arvo;
	private int alaindeksi;
	private int[] kekoindeksi;
}


